****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--GOLD
'
'###############################################################
'#                        Gold-CAN.inc                         #
'#              INCLUDE-file for ADwin-Gold-system             #
'###############################################################
'#                                                             #
'# Contents: Summary of functions and procedures               #
'#           for ADwin-Gold-CAN-Interface.                     #
'#                                                             #
'#  03.02.2004  OL   creation                                  #
'#  14.06.2004  MF                                             #
'#  30.07.2004  JK   ADWGCOM.inc   ->  ADWGCAN.inc             #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#   - arrays which should be transfered to lib-functions must #
'#   - be declared at external DRAM                            #
'#                                                             #
'###############################################################

  dim can_msg[9] as long at DRAM_EXTERN' array with 9 elements 
                                 ' element 1 to 8 for databyte 1 to 8 in CAN-Frame
                                 ' element 9 for the number of databytes in CAN-Frame 
'  {import gold_com_lib.li9}
 import gold_can_lib.li9


  '------------------CAN


  '***************************************************************
  'The function checks, if there is a new frame in the selected
  'message object. If there is a new frame all databytes are read
  'and then written to the array "can_msg".
  'The number of dadabytes is written to the element 9 of the array "can_msg".
  'The return value of the function is the identifier of the frame. 
  'If there is no new frame in the message box the return value is -1.
  'channel    : number of the CAN interface on the CAN module 
  'msg_nummer : number of the message object
  '***************************************************************
  function read_msg(channel,msg_number) as integer
    read_msg=lib_read_msg(channel,msg_number,can_msg)
  endfunction


  '***************************************************************
  'Transmitting a frame. 
  'channel    : number of the CAN interface on the CAN module
  'msg_nummer : number of the message object
  'The databytes and the number of databytes have to be written in the
  'array "can_msg" before this subroutine is activated.
  'After this subroutine the frame is transmitted as soon as the 
  'CAN-bus allows it.
  '***************************************************************
  sub transmit(channel,msg_num)
    lib_transmit(channel,msg_num,can_msg)
  endsub


  '***************************************************************
  'Setting a register of the CAN-controller.
  'channel     : number of the CAN interface 
  'register_no : register which should be set
  'value       : value which should be written to the register.
  '***************************************************************
  sub set_can_reg(channel,register_no, value)   
    dim adr1 as integer  
    adr1 = 20400000h or register_no  or (500h + ((channel -1) * 100h))
    poke(adr1 ,value)											'Writing adress to the CAN-controller
  endsub


  '***************************************************************
  'Reading a register of the CAN-controller.
  'channel      : number of the CAN interface 
  'register_no  : register to read
  'return value : value of the register
  '***************************************************************
  Function get_can_reg(channel,register_no) as integer
    dim adr1 as integer  
    adr1 = 20400000h or register_no  or (500h + ((channel -1) * 100h))
    get_can_reg = peek(adr1)
  endfunction

	
  '***************************************************************
  'Reading the register where the bus error pin of the tranceiver
  'is sored.
  'The register is set when the a bus error occurs and is reset by 
  'reading the register.
  'channel : number of the CAN interface on the CAN module
  'return value : 0 = no error
  '               1 = error
  'Attention: This command is only for low-speed CAN
  '***************************************************************	
  Function get_line_status(channel) as long
    dim value as long
    get_line_status =(peek(20400421H+(channel-1)*2)) AND 1
  endfunction


  '***************************************************************
  'Enables the interrupt of a message object.
  'channel    : number of the CAN interface on the CAN module
  '             (also necessary if the module provides only one channel)
  'msg_nummer : number of the message object
  '***************************************************************
  sub en_CAN_interrupt(channel,msg_num)
    set_can_reg(channel, msg_num * 16, 0ebh) 	'Enable interrupt of the message object.
    set_can_reg(channel, 0, 02h)							'Enable global interrupt.
    poke (20400425h,(peek(20400425h) or channel))
  endsub


  '**************************************************************
  ' read SSI encoder value 32 Bit (new counter board)
  ' counter : number of the counter
  '**************************************************************
  FUNCTION SSI_READ(counter) AS long
    SSI_READ = PEEK(2040043Fh + counter)      'read 32 Bit-value
  ENDFUNCTION


  '**************************************************************
  ' sets the number of databits for the SSI Interface
  ' counter : number of the counter
  ' value   : number of bits
  '**************************************************************
  SUB SSI_SET_Bits(counter,value)
    poke((20400443h + counter) , value)           
  ENDSUB


  '**************************************************************
  ' sets frequency of the SSI clock
  ' counter : number of the counter
  ' value   : frequency = 10MHZ / value
  '**************************************************************
  SUB SSI_Set_Clock(counter,value)
    poke((20400447h + counter), value)           
  ENDSUB


  '**************************************************************
  ' Starts the SSI interface
  ' value  : Bitcombination each bit corresponts to one counter
  '**************************************************************
  SUB SSI_START(value)
    Dim value2 as long
    value2=(value and 0fH) or peek(2040044ch)
    poke(2040044ch, value2)
  ENDSUB


  '*************************************************************
  ' Sets the SSI mode
  ' value : Bitcombination each bit corresponts to one counter
  '         0 = single start mode
  '         1 = continuous start mode
  '*************************************************************
  sub SSI_MODE(value)
    dim value3 as long
    value3= shift_left(value,4) AND 0F0H
    poke(2040044ch, ((peek(2040044ch) AND 0FH)OR value3))
  endsub


  '*************************************************************
  ' Reads the SSI status
  ' counter      : number of the SSI counter
  ' return value : 0 = SSI value compleated
  '                1 = SSI transfer running
  '*************************************************************
  FUNCTION SSI_STATUS(counter) AS long
    dim value2 as long
 	  value2 = peek(2040044ch)
	  ssi_status=shift_right(value2,(counter-1)) AND 01H
  ENDFUNCTION


  '------------------RS
  '***********************************************
  ' Setting a register of the seriell controller
  '	    adr: register on the serial controller
  '  value : value for the selected register
  '***********************************************
  sub set_rs(adr,value)
    poke (20400400h + adr, value) 
  endsub


  '***********************************************
  ' reads the value of a register of the serial controller
  '	   adr: register on the serial controller
  '**********************************************
  FUNCTION get_rs(adr) AS INTEGER
    get_rs = peek(20400400h + adr)
  ENDFUNCTION


  '***************************************************************
  'Reset for the ADwin module (serial interface module)
  '***************************************************************
  sub rs_reset()
    poke(20400424h, 1)    			  ' reset aktiv
    poke(20400424h, 0)    			  ' reset inaktiv
    poke(2040042Ch, 0)  					'RS 485 Control
    poke(2040042Dh, 0)						'RS 485 Control
  endsub


  '***************************************************************
  'Only for RS485.
  'Selects whether the interface is sending data or is listening on the bus.
  'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
  'value   :  0 = Listening
  '           1 = Sending Data
  '           2 = Sending Data + Listening
  '***************************************************************
  sub rs485_send(channel,value)
    poke(2040042Bh+channel,((value+1)AND 3))	 'setting the RTS-Pin 		
  endsub
