****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwinpro1.inc                        #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Definition of functions and procedures            #
'#           to access A/D-modules.                            #
'#                                                             #
'#  01.02.2005  MF   creation                                  #                       
'#  31.05.2005  MF   T11                                       #
'#  16.06.2005  MF   make_lib=off                              # 
'#  07.07.2005  MF   sleep->p1_sleep                           #
'#  20.09.2005  MF   tc_read_voltage                           #
'#  24.01.2006  MF   writedac32                                #
'#  11.04.2006  ur   syntax checked                            #
'#  24.04.2006  MF   TCJ_DIG_TO_TEMP                           #
'#  24.04.2006  MF   TCK_DIG_TO_TEMP                           #
'#  27.04.2006  MF   DIGIN_LONG_F optimze                      #
'#  02.05.2006  MF   PT100_DIG_TO_TEMP                         #
'#  02.05.2006  MF   PT100_DIG_TO_R                            #
'#  20.06.2006  MF   TC_READ_B                                 #
'#                                                             #
'#                                                             #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.19 or higher!       #
'#                                                             #
'###############################################################

'---------------------------------------------------------------
' Base-address for the different types of Pro-modules.
'---------------------------------------------------------------
#if PROZESSOR=T11 then
  #DEFINE DIO 000h      'DIO - MASK
  #DEFINE AD  040h      'A/D - MASK
  #DEFINE DA  080h      'D/A - MASK
  #DEFINE CPU 0A0h      'CPU - MASK
  #DEFINE EXT 0C0h      'EXT - MASK
  'Profibus slave adresses (DPRAM)
  'Handshakeregisters
  #define app_ind       7feH 
  #define any_ind       7ffH 
  'Mailboxregisters
  #define mail_in_0     400H 
  #define mail_in_1     401H 
  #define mail_in_2     402H 
  #define mail_in_3     403H 
  #define mail_in_4     404H 
  #define mail_in_5     405H 
  #define mail_in_6     406H 
  #define mail_in_7     407H 
  #define mail_in_8     408H 
  #define mail_in_9     409H 
  #define mail_in_a     40aH 
  #define mail_in_b     40bH 
  #define mail_in_c     40cH 
  #define mail_in_d     40dH 
  #define mail_in_e     40eH 
  #define mail_in_f     40fH 

  #define mail_out_0    520H 
  #define mail_out_1    521H 
  #define mail_out_2    522H 
  #define mail_out_3    523H 
  #define mail_out_4    524H 
  #define mail_out_5    525H 
  #define mail_out_6    526H 
  #define mail_out_7    527H 
  #define mail_out_8    528H 
  #define mail_out_9    529H 
  #define mail_out_a    52aH 
  #define mail_out_b    52bH 
  #define mail_out_c    52cH 
  #define mail_out_d    52dH 
  #define mail_out_e    52eH 
  #define mail_out_f    52fH 

  #if make_lib=off then
    dim test as integer          ' variable for delay
    dim can_msg[9] as integer    ' array with 9 elements 
  #endif

  '---------------------------------------------------------------
  ' Address-table to access the hardware of the Pro-system,
  ' depending on the CPU in use (ADSP OR Transputer).
  '---------------------------------------------------------------         
  #define DL           20400000h
  #define DH           20400010h
  #define DLX          20400020h
  #define DHX          20400030h
  #define ADWR         20400060h
  #define ADRD         20400070h
  #define adrdf        20400078h
  #define CPU_EVENT    204000F0h
  #define WATCHDOG     10000400h
  #define WD_TIMER     10000400h
  #define CPU_LED      10000100h
  #define d32          20400180h
  #define D32I         20400198H
  #define CPU_DIG_ADR  10000210H 
  #define CPU_DIG_ADR1 10000220H 
  #define SYNC_REG     10000100H


  '---------------------------------------------------------------
  ' Procedure which adds NOP-instructions after a REG.-WRITE
  ' to compensate delaytimes.
  '---------------------------------------------------------------
  SUB poke_nop(adress,value)
    #IF PROZESSOR = T11 THEN
      poke(adress,value)
      bus_sleep(25)
    #ENDIF
  ENDSUB
  
  SUB poke_nop_rd(adress,value)
    #IF PROZESSOR = T11 THEN
      poke(adress,value)
    #endif
  ENDSUB


  '---------------------------------------------------------------
  ' Procedure which adds one additional NOP-instruction only for
  ' the ADSP processor, because only neccessary there.
  '---------------------------------------------------------------
  SUB NOP_T9()

  ENDSUB


  '---------------------------------------------------------------
  ' If a low-priority process accesses a Pro-module it must not be
  ' interrupted by any other process !!!
  '---------------------------------------------------------------
  SUB SUB_BEGIN_CRITICAL_SECTION() 
    #IF PRIORITAET = LOW
      BEGIN_CRITICAL_SECTION
    #ENDIF
  ENDSUB
  
  SUB SUB_END_CRITICAL_SECTION()
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
  ENDSUB


  '**************************************************************
  ' Waits for the settling time of the multiplexer.
  ' waits 14 s for AIN-8/16-RB , AIN-32/16-RB 
  ' waits 3 s  for all other modules
  ' This sub is only for T9 or T10 (= ADSP) processors.
  '**************************************************************
  SUB ADC_WAIT_MUX_T9(card)
    DIM addr3 AS LONG
    DIM modulcode AS LONG
    dim time1, time2, time3 as long
   
    addr3=PEEK(SYNC_REG)
    time1=read_timer()
    addr3=069H OR (SHIFT_LEFT(card,8)) 
                    
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr3)
      modulcode=PEEK(DLX) AND 255
    SUB_END_CRITICAL_SECTION
                    
    IF ((Modulcode=9) OR (Modulcode=11)) then        'AIN 8/16 RB or AIN 32/16RB
      time3=4200       '14 s
    ELSE
      IF ((Modulcode=21) or (modulcode=23)) then     'AIN 8/14 or 'AIN 32/14
        time3=750      '2,5 s                            
      ELSE
        IF ((Modulcode=22) or (Modulcode=24)) then   'AIN 8/16 RC or 'AIN 32/16 RC                             
          time3=1650  '5,5 s                                        
        ELSE
          time3=900   '3 s                                  
        ENDIF
      ENDIF                           
    ENDIF   
    do
      time2=Read_timer()-time1
    until (time2>time3)  
  ENDSUB


  '***************************************************************
  ' Waits for the settling time of the multiplexer.
  ' This procedure is suitable for the ADC and the ADC16 function. 
  ' (Rechecked by JK 22.11.2000 :  The waiting time caused by this
  '  procedure is 2.7 microseconds (for T8 processor with 25MHz), 
  '  which is also sufficient for Pro-AIn-8/16) 
  ' For AIN-8/16-RB or AIN-32/16-RB please use ADC_WAIT_MUX_T9 .
  '***************************************************************
  SUB ADC_WAIT_MUX() 
    P1_sleep(300)
  ENDSUB


  '***************************************************************
  ' Samples, converts and reads out the digital ADC-value of an
  ' analog input.
  ' This function is suitable for all 12 bit modules and for the
  ' following 16 bit modules :  AIN-8/16-RB , AIN-32/16-RB 
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' ! Attention:                                                 !
  ' ! This instruction is not prepared to handle an access from  !
  ' ! a low AND high priority process to the same module.        !
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '***************************************************************
  FUNCTION ADC(card,ADC_No) AS INTEGER
    DIM addr, addr1, adc_n, reminder AS INTEGER
          
    '............ set MUX ............
    addr = 050h OR (SHIFT_LEFT(card,8))
    adc_n = ADC_No-1
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,adc_n)
    SUB_END_CRITICAL_SECTION
    
    '............ wait multiplexer settling time ........
    ADC_WAIT_MUX_T9(card) ' wait 3 s or more, depending on hardware
    
    '............ start conversion ............
    addr = 054h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,0)
    SUB_END_CRITICAL_SECTION
    bus_sleep(6)    
  
    '............ wait EOC ............
    addr = 056h OR (SHIFT_LEFT(card,8))
    addr1 = AD OR (SHIFT_LEFT(card,8))
    DO
      SUB_BEGIN_CRITICAL_SECTION
        Poke_NOP_rd(ADRD,addr)
        reminder = (PEEK(DLX) AND 1)
      SUB_END_CRITICAL_SECTION
    UNTIL(reminder = 0)
    '............ read out result ............
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr1)
      ADC = PEEK(DLX)
    SUB_END_CRITICAL_SECTION
    bus_sleep(30)
  ENDFUNCTION


  '***************************************************************
  ' Samples, converts and reads out the digital 16 bit ADC-value
  ' of an analog input.
  ' For AIN-8/16-RB or AIN-32/16-RB please use the function "ADC"
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' ! Attention:                                                 !
  ' ! This instruction is not prepared to handle an access from  !
  ' ! a low AND high priority process to the same module.        !
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '***************************************************************
  FUNCTION ADC16(card,ADC_No) AS INTEGER
    DIM addr, addr1, adc_n, reminder AS INTEGER
  
    '************ set MUX ************
    addr = 050h OR (SHIFT_LEFT(card,8))
    adc_n = ADC_No - 1
    SUB_BEGIN_CRITICAL_SECTION
      POKE (ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,adc_n)
    SUB_END_CRITICAL_SECTION
  
    '............ wait multiplexer settling time ........
    ADC_WAIT_MUX
  
    '............ start conversion ............
    addr = 054h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX, 0)
    SUB_END_CRITICAL_SECTION
    bus_sleep(6)    
  
    '............ wait EOC ............
    addr = 056h OR (SHIFT_LEFT(card,8))
    addr1 = AD OR (SHIFT_LEFT(card,8))
    DO
      SUB_BEGIN_CRITICAL_SECTION
        Poke_NOP_rd(ADRD,addr)
        reminder = (PEEK(DLX) AND 1)
      SUB_END_CRITICAL_SECTION
    UNTIL(reminder = 0)
    bus_sleep(27)
    bus_sleep(27)
    bus_sleep(27)
  
    '............ start conversion again (serial ADC) ............
    addr = 054h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,0)
    SUB_END_CRITICAL_SECTION
          
    bus_sleep(6)    
  
    '............ wait EOC ............
    addr = 056h OR (SHIFT_LEFT(card,8))
    addr1 = AD OR (SHIFT_LEFT(card,8))
    DO
      SUB_BEGIN_CRITICAL_SECTION
        Poke_NOP_rd(ADRD,addr)
        reminder = (PEEK(DLX) AND 1)
      SUB_END_CRITICAL_SECTION
    UNTIL(reminder = 0)
    
    '............ read out result ............
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr1)
      ADC16 = PEEK(DLX)
    SUB_END_CRITICAL_SECTION
    bus_sleep(30)
  ENDFUNCTION


  '***************************************************************
  ' Set MUX to desired input channel.
  ' (Gain is only on 12 bit modules available!)
  ' card:   module-address
  ' select: bit 6 & 5 -> gain,  bit 4...0 -> channel 1...32
  '***************************************************************
  SUB SET_MUX(card,select)
    DIM addr, adc_n AS INTEGER
  
    addr = 050h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,select)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Start conversion of ADC.
  ' card: module-address
  '***************************************************************
  SUB START_CONV(card)
    DIM addr, adc_n AS INTEGER

    addr = 054h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,0)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Wait until EOC-signal goes active (End Of Conversion).
  ' card: module-address
  '***************************************************************
  SUB WAIT_EOC(card)
    DIM addr, reminder AS INTEGER

    addr = 056h OR (SHIFT_LEFT(card,8))
    bus_sleep(6)
    DO
      SUB_BEGIN_CRITICAL_SECTION
        Poke_NOP_rd(ADRD,addr)
        reminder = PEEK(DLX) AND 1
      SUB_END_CRITICAL_SECTION
    UNTIL(reminder = 0)
    bus_sleep(35)
  ENDSUB


  '***************************************************************
  ' Returns conversion result of ADC.
  ' card:   module-address
  ' result: 16 bit integer
  '***************************************************************
  FUNCTION READADC(card) AS INTEGER
    DIM addr AS INTEGER

    addr = AD OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr)
      READADC = PEEK(DLX)
    SUB_END_CRITICAL_SECTION 
  ENDFUNCTION


  '***************************************************************
  ' Returns conversion result of ADC and starts immediately
  ' a new conversion.
  ' card:   module-address
  ' result: 16 bit integer
  '***************************************************************
  FUNCTION READADC_SCONV(card) AS INTEGER
    DIM addr AS INTEGER

    addr = 058h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr)
      READADC_SCONV = PEEK(DLX)
    SUB_END_CRITICAL_SECTION 
  ENDFUNCTION


  '***************************************************************
  ' Selects single-ended (s.e.) or differential (diff.) inputs
  ' for the AIN-32/12-module only.
  ' card: module-address
  ' mode: s.e. -> 0,  diff. -> 1 (default after power-up)
  '***************************************************************
  SUB SE_DIFF(card,mode)
    DIM addr AS INTEGER

    addr = 061h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,mode)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Samples, converts and reads out the digital 16 bit ADC-value
  ' of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' ! Attention:                                                 !
  ' ! This instruction is not prepared to handle an access from  !
  ' ! a low AND high priority process to the same module.        !
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' card :  module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '***************************************************************
  FUNCTION ADCF(card,ADC_No) AS INTEGER
    DIM addr, dip, adc_n1, reminder AS INTEGER

    adc_n1 = SHIFT_LEFT(1,(ADC_No-1))

    '............ start conversion ............
    addr = 054h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE (ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,adc_n1)
    SUB_END_CRITICAL_SECTION

    '............ wait EOC ............
    bus_sleep(6)    
    addr = addr+2
    DO
      SUB_BEGIN_CRITICAL_SECTION
        Poke_NOP_rd(ADRD,addr)
        reminder = PEEK(DLX) AND adc_n1
      SUB_END_CRITICAL_SECTION
    UNTIL(reminder = 0)

    '............ read out result ............
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD, (addr-17H+(ADC_No)))
      ADCF = PEEK(DLX) 
    SUB_END_CRITICAL_SECTION
    bus_sleep(32)
  ENDFUNCTION


  '***************************************************************
  ' Starts a conversion on selected ADC on AIN-Fx/yy-modules.
  ' card:   module-address
  ' select: Datenbit z. B.: 0101=adc1+3
  '***************************************************************
  SUB START_CONVF(card,select)
    DIM addr,adc_n AS INTEGER

    addr = 054h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,select)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Wait until EOC-signals of all selected ADCs are active.
  ' (for AIN-Fx/yy-modules only)
  ' card:   module-address
  ' select: ADC-#1 -> bit 0,  ...,  ADC-#8 -> bit 7
  '***************************************************************
  SUB WAIT_EOCF(card,select)
    DIM addr, reminder AS INTEGER

    bus_sleep(6)
    addr = 056h OR (SHIFT_LEFT(card,8))
    DO
      SUB_BEGIN_CRITICAL_SECTION
        Poke_NOP_rd(ADRD,addr)
        reminder = (PEEK(DLX) AND select)
      SUB_END_CRITICAL_SECTION        
    UNTIL(reminder = 0)
    bus_sleep(32)
  ENDSUB


  '***************************************************************
  ' Returns conversion result of ADC of AIN-Fx/yy-module.
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '***************************************************************
  FUNCTION READADCF(card,ADC_No) AS INTEGER
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,(03Fh+ADC_No) OR (SHIFT_LEFT(card,8)))
      READADCF = PEEK(DLX)
    SUB_END_CRITICAL_SECTION 
  ENDFUNCTION


  '***************************************************************
  ' Returns conversion result of two ADC's simultaneously from
  ' an AIN-Fx/yy-module.
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 32 bit integer
  '         low-word -> ADC_No,  high-word -> ADC_No + 1
  '***************************************************************
  FUNCTION READADCF_32(card,ADC_No) AS INTEGER
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,(03Fh+ADC_No) OR (SHIFT_LEFT(card,8)))
      READADCF_32=peek(d32) 
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Returns conversion result of two ADC's simultaneously and
  ' immediately starts the conversion of both ADC again.
  ' card:   module-address
  ' ADC_No:       1 = channel no. 1 + 2
  '               2 = channel no. 3 + 4
  '               3 = channel no. 5 + 6
  '               4 = channel no. 7 + 8
  ' result: 32 bit integer
  '         low-word -> ADC_No,  high-word -> ADC_No + 1
  '***************************************************************
  FUNCTION READADCF_SCONV_32(card,ADC_No) AS INTEGER
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,(049h+ADC_No) OR (SHIFT_LEFT(card,8)))
      READADCF_SCONV_32=Peek(d32)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Returns conversion result of ADC and starts immediately
  ' a new conversion (for AIN-Fx/yy-modules only).
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '***************************************************************
  FUNCTION READADCF_SCONV(card,ADC_No) AS INTEGER
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,(057h+ADC_No) OR (SHIFT_LEFT(card,8)))
      READADCF_SCONV = PEEK(DLX)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Sets, if equipped with a S&H add-on PCB,
  ' the mode of the S&H stage.
  ' card: module-address
  ' mode: sample -> 0,  hold -> 1
  '***************************************************************
  SUB SH_SETMODE(card,mode)
    DIM addr AS INTEGER
  
    addr = 05Ah OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,mode)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'Sub is setting the parameters of the burst mode
  'card : dip switch address
  'mode=1 Sample Channel 1 only
  'mode=2 Sample Channel 1-2
  'mode=3 Sample Channel 1-4
  'mode=4 Sample Channel 1-8 
  'sampleperiode (n*25 ns)
  'samples max 2^19 values in Mode 1
  'This sub is only for ADSP processors and Fx/14
  '**************************************************************
  SUB BURST_INIT(card,mode,sampleperiode,samples)
    DIM addr AS INTEGER
    DIM mode2 AS INTEGER
  
    ADDR=(SHIFT_LEFT(card,8)) OR 51H
          
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(d32,sampleperiode)
    SUB_END_CRITICAL_SECTION
    inc ADDR       'samples

    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(d32,samples)
    SUB_END_CRITICAL_SECTION
    ADDR=ADDR + 2       'set mode
    MODE2=SHIFT_LEFT(((mode-1) AND 3),8)
  
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADDR)
      NOP_T9
      Poke_NOP(DLX,MODE2)
    SUB_END_CRITICAL_SECTION
  endsub


  '**************************************************************
  'Sub start the burst measurement
  'card : dip switch address
  'This sub is only for ADSP processors and Fx/14
  '**************************************************************
  SUB BURST_START(card)
    DIM ADR AS LONG
    DIM MODE AS LONG
    
    ADR=054h OR (SHIFT_LEFT(card,8))
  
    SUB_BEGIN_CRITICAL_SECTION  
      poke_nop_rd(ADRD,ADR)
      MODE=PEEK(D32)OR 10000000000B
      nop_t9
    SUB_END_CRITICAL_SECTION
    
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADR)
      NOP_T9
      Poke_NOP(D32,MODE)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'Sub start the burst measurement in continous mode
  'card : dip switch address
  'This sub is only for ADSP processors and Fx/14 Rev B2 
  '**************************************************************
  SUB BURST_CSTART(card) 
    DIM ADR AS LONG
    DIM MODE AS LONG
    
    ADR=054h OR (SHIFT_LEFT(card,8))
  
    SUB_BEGIN_CRITICAL_SECTION  
      poke_nop_rd(ADRD,ADR)
      MODE=PEEK(D32)OR 110000000000B
      nop_t9
    SUB_END_CRITICAL_SECTION
    
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADR)
      NOP_T9
      Poke_NOP(D32,MODE)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'function reads the progress of the burst measure
  'return value: number of convertions to do
  'card : dip switch address
  'This function is only for ADSP processors and Fx/14
  '**************************************************************
  function BURST_STATUS(card) AS INTEGER
    DIM ADDR AS INTEGER
    DIM COUNT AS LONG
     
    ADDR = 052h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr)
      COUNT = peek(d32) 
    SUB_END_CRITICAL_SECTION 
    INC ADDR
  
    SUB_BEGIN_CRITICAL_SECTION 'wert
      poke_nop_rd(ADRD,addr)
      BURST_STATUS=count-peek(d32)
    SUB_END_CRITICAL_SECTION      
    nop_t9
  endfunction


  '**************************************************************
  'transfer the input data to an array
  'card : dip switch address
  'channel: select channel
  'startadr: first value of channel which should be transferred
  'length: number of values
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for ADSP processors and Fx/14
  '**************************************************************
  SUB BURST_READ(card,channel,startadr,length,array,array_startindex)
    DIM ADR AS LONG
    DIM ADDR AS LONG
    DIM value AS LONG
    DIM i AS LONG
    dim mode as long
    dim ramstartadr as long
    dim lenint as long
    dim pointer as long
    
    ADR=SHIFT_LEFT(card,8) 
    addr=054H or adr
    SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP_rd(ADRD,addr)
      MODE=peek(DLX) AND 1100000000B
    SUB_END_CRITICAL_SECTION       
    
    RAMSTARTADR=(SHIFT_LEFT((channel-1),(20-shift_right(mode,8))))+startadr-1
    addr=061H or adr
    SUB_BEGIN_CRITICAL_SECTION 
      poke(ADWR,addr)
      nop_t9
      poke_nop(d32,RAMSTARTADR)
    SUB_END_CRITICAL_SECTION       
    
    addr=60H or adr
    lenint=LENGTH AND 0FFFFFFFEH
    if (LENINT>1) then
      for i=1 to LENINT step 2   
        SUB_BEGIN_CRITICAL_SECTION 'wert
          poke_nop_rd(ADRD,addr)
          value=peek(d32)
        SUB_END_CRITICAL_SECTION
        pointer=array_startindex+i-1        
        array[pointer]=value AND 0FFFFH
        array[pointer+1]=SHIFT_RIGHT(VALUE,16)      
      NEXT
    endif
    if (LENGTH AND 1=1) THEN
      SUB_BEGIN_CRITICAL_SECTION 'wert
        poke_nop_rd(ADRD,addr)
        array[LENGTH+array_startindex-1]=peek(d32) AND 0FFFFH
      SUB_END_CRITICAL_SECTION    
    endif
  ENDSUB


  '**************************************************************
  'transfer the input data to an array
  'card : dip switch address
  'channel: select channel
  'length: number of values
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for ADSP processors and Fx/14
  '**************************************************************
  SUB BURST_CREAD(card,channel,length,array[],array_startindex)
    DIM adr as long
    dim diff as long
    dim pos as long 
    dim le as long 
    dim addr as long
    dim anz as long
    dim i as long
    dim str[2] as long
    dim len[2] as long
    dim sindex[2] as long
    
    ADR=SHIFT_LEFT(card,8) 
    addr=052H or adr
    SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP_rd(ADRD,addr)
      le=peek(D32) 
    SUB_END_CRITICAL_SECTION       
    inc addr
     
    SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP_rd(ADRD,addr)
      pos=peek(D32) 
    SUB_END_CRITICAL_SECTION       
    diff=pos-length
    
    if (diff>=0) then 'overflow ?
      anz=1
      str[1]= diff
      len[1]=length
      sindex[1]=array_startindex
    else
      anz=2
      str[1]=le+diff
      str[2]=1
      len[1]=-diff
      len[2]=pos
      sindex[1]=array_startindex
      sindex[2]=array_startindex-diff
    endif
    
    for i=1 to anz
      burst_read(card,channel,str[i],len[i],array,sindex[i])
    next
  endsub


  '**************************************************************
  'transfer the input data to an array
  'card : dip switch address
  'channel: select channel
  'startadr: first value of channel which should be transferred
  'length: number of values / 2
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for ADSP processors and Fx/14
  '**************************************************************
  SUB BURST_READ_PACKED(card,channel,startadr,length,array,array_startindex)
    DIM ADR AS LONG
    DIM ADDR AS LONG
    DIM VALUE AS LONG
    DIM I AS LONG
    DIM MODE AS LONG
    DIM RAMSTARTADR as long
    DIM LENINT AS LONG
    DIM POINTER AS LONG
    DIM INTERNAINDEX AS LONG
    
    ADR=SHIFT_LEFT(card,8) 
    INTERNAINDEX=ARRAY_STARTINDEX-1
    addr=054H or adr
    SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP_rd(ADRD,addr)
      MODE=peek(DLX) AND 1100000000B
    SUB_END_CRITICAL_SECTION       
      
    RAMSTARTADR=(SHIFT_LEFT((channel-1),(20-shift_right(mode,8))))+startadr-1
    ADDR=061H OR ADR
    SUB_BEGIN_CRITICAL_SECTION 
      poke(ADWR,ADDR)
      nop_t9
      poke_nop(d32,RAMSTARTADR)
    SUB_END_CRITICAL_SECTION       
     
    ADDR=060H or ADR
    IF (LENGTH>0) THEN                             
      FOR i=1 to LENGTH    
        SUB_BEGIN_CRITICAL_SECTION 
          poke_nop_rd(ADRD,addr)
          array[i+INTERNAINDEX]=peek(d32)
        SUB_END_CRITICAL_SECTION        
      NEXT
    ENDIF
  ENDSUB


  '**************************************************************
  'Function stop the burst measure and returns the samples  
  'card : dip switch address
  'This sub is only for ADSP processors and Fx/14
  '**************************************************************
  Function BURST_ABORT(card) AS INTEGER
    DIM ADDR AS LONG
    DIM value AS LONG
  
    addr=054H OR (SHIFT_LEFT(card,8)) 
    SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP_rd(ADRD,addr)
      Value=peek(d32) AND 0FFFFFBFFH
      nop_t9
    SUB_END_CRITICAL_SECTION       
   
    SUB_BEGIN_CRITICAL_SECTION 
      poke(ADWR,addr)
      nop_t9
      poke_nop(d32,value)
    SUB_END_CRITICAL_SECTION       
    dec addr
    
    SUB_BEGIN_CRITICAL_SECTION 'wert
      poke_nop_rd(ADRD,addr)
      BURST_ABORT=peek(d32)
      nop_t9
    SUB_END_CRITICAL_SECTION       
  ENDFUNCTION


  '***************************************************************
  'sub set the input range 
  'card: dip switch address
  'channel 1-8
  'mode=0 range -10 V -> +10 V
  'mode=1 range -5V   -> + 5 V
  'mode=2 range -2.5V -> + 2.5 V
  'mode=3 range -1.25 -> + 1.25 V
  'for AIN Fx/14 only 
  '***************************************************************
  SUB SET_GAIN(card,channel,mode)
    DIM addr, AS INTEGER
    DIM mode3 AS INTEGER
    DIM shift AS INTEGER
                  
    addr = 055h OR (SHIFT_LEFT(card,8))
    shift=shift_left((channel-1),1)
          
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr)
      mode3 = PEEK(DLX) 
      nop_t9
    SUB_END_CRITICAL_SECTION
    mode3=(mode3 AND NOT (shift_left(3,shift))) OR (shift_left((mode),shift))  
                   
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,mode3)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'initialising the syncronisation mode of the f14 board
  'card : dip switch address
  'mode =0 normal Mode (no syncronasation)
  '     =1 Master Mode
  '     =2 Slave Mode
  '     =3 Event Mode
  '**************************************************************
  SUB SYNC_MODE(card,MODE)
    dim addr as long
    
    addr = 04Fh OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADDR)
      NOP_T9
      Poke_NOP(D32,MODE)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'card : dip switch address
  'time 0=default time
  '     1-2048 time in 25 ns
  '**************************************************************
  SUB SEQ_SET_DELAY(card,time)
    dim addr as long
  
    addr = 63H OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADDR)
      NOP_T9
      Poke_NOP(D32,time)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'initialising the ain mode 
  'card : dip switch address
  'mode =0 normal Mode 
  '     =1 single shot mode
  '     =3 continuous mode
  'gain=0 range -10 V -> +10 V
  'gain=1 range -5V   -> + 5 V
  'gain=2 range -2.5V -> + 2.5 V
  'gain=3 range -1.25 -> + 1.25 V
  
  '**************************************************************
  SUB SEQ_MODE(CARD,MODE,GAIN)
    dim addr as long
    
    addr=52h or (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADDR)
      NOP_T9
      POKE_NOP(DLX,0)
    SUB_END_CRITICAL_SECTION
    
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr-2)
      NOP_T9
      Poke_NOP(DLX,shift_left(GAIN,5))
    SUB_END_CRITICAL_SECTION
           
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,ADDR)
      NOP_T9
      POKE_NOP(DLX,MODE)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'select the channel in single shot or continuous mode 
  'card : dip switch address
  'channel :selected channels in binary
  '**************************************************************
  SUB SEQ_SELECT(card,Channel)
    dim addr as long
    
    addr=53h or (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADDR)
      NOP_T9
      POKE_NOP(D32,CHANNEL)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDSUB
  
  
  '**************************************************************
  'this function returns the number of channel that is in progress
  'card : dip switch address
  'This sub is only for (ADSP) processors 
  '**************************************************************
  function SEQ_STATUS(card) AS INTEGER
    DIM ADDR AS INTEGER
       
    ADDR = 051h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,addr)
      SEQ_STATUS = peek(d32)
      nop_t9      
    SUB_END_CRITICAL_SECTION
  endfunction


  '**************************************************************
  'transfer the input data to an array
  'card : dip switch address
  'channel:
  'This sub is only for (ADSP) processors 
  '**************************************************************
  FUNCTION SEQ_READ_ONE(card,channel) as long 
    dim value as long
    dim i as long
    dim baseadr as long
           
    i=shift_right(channel-1,1)
    baseadr=(040h+i) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,baseadr)
      if (channel and 1=1) then 
        SEQ_READ_ONE=PEEK(d32) AND 0FFFFH    
      else
        SEQ_READ_ONE=shift_right(PEEK(d32),16) 
     endif
     nop_t9
   SUB_END_CRITICAL_SECTION       
  endfunction


  '**************************************************************
  'transfer the input data to an array
  'card : dip switch address
  'channel:
  'This sub is only for (ADSP) processors 
  '**************************************************************
  FUNCTION SEQ_READ_TWO(card,channel) as long 
    dim value as long
    dim baseadr as long
           
    baseadr=(040h+channel) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,baseadr)
      SEQ_READ_TWO=PEEK(D32)
      nop_t9
    SUB_END_CRITICAL_SECTION                        
  endfunction


  '**************************************************************
  'transfer the input data to an array
  'card : dip switch address
  'length: number of values
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for (ADSP) processors 
  '**************************************************************
  SUB SEQ_READ(card,length,array[],array_startindex)  
    dim value as long
    dim i as long
    dim baseadr as long
          
    baseadr=(040h) OR (SHIFT_LEFT(card,8))
    if (length>2) then 
      for i=1 to length-2 step 2
        SUB_BEGIN_CRITICAL_SECTION
          Poke_NOP_rd(ADRD,baseadr)
          Value=PEEK(D32)
        SUB_END_CRITICAL_SECTION
        inc baseadr
        array[i+array_startindex-1]=value AND 0FFFFH   'Kanal 1
        array[i+array_startindex]=shift_right(value,16) 'Kanal 2       
      next     
    endif
     
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,baseadr)
      Value=PEEK(D32)
    SUB_END_CRITICAL_SECTION
     
    if (length and 1=1) then 
      array[length+array_startindex-1]=value AND 0FFFFH   
    else 
      array[length+array_startindex-2]=value AND 0FFFFH   
      array[length+array_startindex-1]=shift_right(value,16) 
    endif
  endsub  


  '**************************************************************
  'transfer the input data to an array
  'card : dip switch address
  'length: number of values / 2
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for(ADSP) processors 
  '**************************************************************
  SUB SEQ_READ_PACKED(card,length,array[],array_startindex)  
    dim i as long
     
    for i=1 to length
      SUB_BEGIN_CRITICAL_SECTION
        Poke_NOP_rd(ADRD,(03Fh+i) OR (SHIFT_LEFT(card,8)))
        array[i+array_startindex-1]=Peek(D32) 
      SUB_END_CRITICAL_SECTION  
    next           
  endsub  


  '**************************************************************
  'transfer the input data of all 32 channels to an array
  'card : dip switch address
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for (ADSP) processors 
  '**************************************************************
  SUB SEQ_READ32(card,array[],array_startindex)  
    dim value as long
           
    SUB_BEGIN_CRITICAL_SECTION
      Poke_nop_rd(ADRD,(040h)OR (SHIFT_LEFT(card,8)))
      Value=PEEK(D32i)        
      array[array_startindex]=value AND 0FFFFH   
      array[1+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[4+array_startindex]=value AND 0FFFFH   
      array[5+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[8+array_startindex]=value AND 0FFFFH   
      array[9+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[12+array_startindex]=value AND 0FFFFH   
      array[13+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[16+array_startindex]=value AND 0FFFFH   
      array[17+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[20+array_startindex]=value AND 0FFFFH   
      array[21+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[24+array_startindex]=value AND 0FFFFH   
      array[25+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[28+array_startindex]=value AND 0FFFFH   
      array[29+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[2+array_startindex]=value AND 0FFFFH   
      array[3+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[6+array_startindex]=value AND 0FFFFH   
      array[7+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[10+array_startindex]=value AND 0FFFFH   
      array[11+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[14+array_startindex]=value AND 0FFFFH   
      array[15+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[18+array_startindex]=value AND 0FFFFH   
      array[19+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[22+array_startindex]=value AND 0FFFFH   
      array[23+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32i)
      array[26+array_startindex]=value AND 0FFFFH   
      array[27+array_startindex]=shift_left(value,-16) 
      Value=PEEK(D32)
      array[30+array_startindex]=value AND 0FFFFH   
      array[31+array_startindex]=shift_left(value,-16) 
    SUB_END_CRITICAL_SECTION
  endsub    


  '**************************************************************
  'transfer the input data of all 32 channels to an array
  'card : dip switch address
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for (ADSP) processors 
  '**************************************************************
  SUB SEQ_READ32_PACKED(card,array[],array_startindex)  
    dim value as long
    
    SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP_rd(ADRD,(040h) OR (SHIFT_LEFT(card,8)))
      nop_t9
      nop_t9
      array[array_startindex]=PEEK(D32i)
      array[2+array_startindex]=PEEK(D32i)
      array[4+array_startindex]=PEEK(D32i)
      array[6+array_startindex]=PEEK(D32i)
      array[8+array_startindex]=PEEK(D32i)
      array[10+array_startindex]=PEEK(D32i)
      array[12+array_startindex]=PEEK(D32i)
      array[14+array_startindex]=PEEK(D32i)
      array[1+array_startindex]=PEEK(D32i)
      array[3+array_startindex]=PEEK(D32i)
      array[5+array_startindex]=PEEK(D32i) 
      array[7+array_startindex]=PEEK(D32i) 
      array[9+array_startindex]=PEEK(D32i)
      array[11+array_startindex]=PEEK(D32i)
      array[13+array_startindex]=PEEK(D32i)
      array[15+array_startindex]=PEEK(D32)
    SUB_END_CRITICAL_SECTION
  endsub  


  '***********************' Convert the digitial value to an analog output
  ' card:   module-address
  ' DAC_No: channel number of analog output
  ' value:  output value (0..65535)
  '***********************
  SUB DAC_OLD(card,DAC_No,value)
    DIM addr, dac_n,out_value AS INTEGER
  
    out_value = value
    IF (out_value < 0) THEN out_value = 0
    IF (out_value > 0FFFFh) THEN out_value = 0FFFFh
    dac_n = DAC_No-1
    addr = (dac_n OR 080h) OR (SHIFT_LEFT(card,8))
  
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,out_value)
    SUB_END_CRITICAL_SECTION
    addr = 090h OR (SHIFT_LEFT(card,8))
  
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,0)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***********************' Convert the digitial value to an analog output
  ' card:   module-address
  ' DAC_No: channel number of analog output
  ' value:  output value (0..65535)
  '***********************
  SUB DAC(card,DAC_No,value)
    DIM addr, dac_n,out_value AS INTEGER
  
    out_value = value
    IF (out_value < 0) THEN out_value = 0
    IF (out_value > 0FFFFh) THEN out_value = 0FFFFh
    addr = ((DAC_No)+23 OR 080h) OR (SHIFT_LEFT(card,8))
  
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,out_value)
    SUB_END_CRITICAL_SECTION  
  ENDSUB


  '***************************************************************
  ' Set DAC-register to desired value
  ' card:   module-address
  ' DAC_No: channel number of analog output
  ' value:  output value (0..65535)
  '***************************************************************
  SUB WRITEDAC(card,DAC_No,value)
    DIM addr, dac_n, out_value AS INTEGER
  
    out_value = value
    IF (out_value < 0) THEN out_value = 0
    IF (out_value > 0FFFFh) THEN out_value = 0FFFFh
    dac_n = DAC_No-1
    addr = (dac_n OR 080h) OR (SHIFT_LEFT(card,8))
  
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,out_value)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  ' ***************************************************************
  ' Set DAC-register to desired value 
  ' card: module-address
  ' DAC_No: 0 = Channel 1 and 2
  ' DAC_No: 1 = Channel 3 and 4
  ' DAC_No: 2 = Channel 5 and 6
  ' DAC_No: 3 = Channel 7 and 8
  ' value: output value 32Bit
  ' This sub is only for ADSP processors and AOUT Rev B oder Rev C
  '***************************************************************
  SUB WRITEDAC32(card,DAC_N,value)
    DIM addr, AS INTEGER
  
    addr = ((dac_n) OR 0A0h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9        
      poke_nop(d32,value)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Simultaneously start conversion of all DAC on this module.
  ' card:   module-address
  '***************************************************************
  SUB START_DAC(card)
    DIM addr, dac_n AS INTEGER

    addr = 090h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,addr)
      NOP_T9
      Poke_NOP(DLX,0)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '****************************************************************
  ' NEW COMMANDS FOR DAC Module with MEM option
  '****************************************************************
  
  '****************************************************************
  ' set the mode of the dac modul
  ' card:   module-address
  ' mode=0  normal mode 
  ' mode=1  frequency generator mode
  ' This sub is only for ADSP processors and AOUT with MEM option
  '****************************************************************
  SUB FG_MODE(card,mode)   
    DIM adr as integer
    
    adr = (23 OR 080h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr )
      nop_t9
      poke_nop( DLX , 0)
    SUB_END_CRITICAL_SECTION
    bus_sleep(100)
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr )
      nop_t9
      poke_nop( DLX , mode)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '****************************************************************
  ' set the delay between two steps
  ' card:   module-address
  ' DAC_No: channel number of analog output
  ' scale:  F_output=80 MHz/scale
  ' This sub is only for ADSP processors and AOUT with MEM option
  '****************************************************************
  SUB FG_DELAY(card, DAC_No, scale)
    DIM adr as integer

    adr = (10 OR 080h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR, adr)
      nop_t9
      poke_nop( D32 ,(scale-2) or shift_left((DAC_no)-1,29))  
    SUB_END_CRITICAL_SECTION
  EndSub  


  '****************************************************************
  ' set the buffer of each channel
  ' card:   module-address
  ' DAC_No: channel number of analog output
  ' value_startadr: start_adr of memory
  ' value_ramsize: size of memory for this channel
  ' This sub is only for ADSP processors and AOUT with MEM option
  '****************************************************************
  SUB FG_DEF(card, DAC_No, value_startadr, value_ramsize)  
    DIM adr as integer
          
    adr = (8 OR 080h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr)
      nop_t9
      poke_nop( D32, (value_startadr) OR shift_left((DAC_no-1),29))  
    SUB_END_CRITICAL_SECTION
    inc adr
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr)
      nop_t9
      poke_nop( D32, (value_ramsize) OR shift_left((DAC_no-1),29))
      bus_sleep(100)
    SUB_END_CRITICAL_SECTION      
  ENDSUB


  '**************************************************************
  'transfer the output data from a array to the memory of the dac card
  'card : dip switch address
  'ramstart_adr: start_adr of memory
  'length: number of values (only even-numbered)
  'array: source array 
  'array_startindex: startindex in the source array
  'This sub is only for ADSP processors and AOUT with MEM option
  '**************************************************************
  SUB FG_WRITE(card,ramstart_adr,length,array,array_startindex)
    DIM ADR AS LONG
    DIM value AS LONG
    DIM i AS LONG
    dim lenint as long
    dim pointer as long
    dim hw as long
    dim lw as long
    
    ADR=(18 OR 080h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr)
      nop_t9
      poke_nop(d32,((ramstart_adr) or (080000000H)) )
    SUB_END_CRITICAL_SECTION
    
    pointer=array_startindex
    inc adr 
    lenint=LENGTH 
    bus_sleep(100) 
    if (LENINT>1) then
      for i=1 to LENINT step 2   
        lw=array[pointer] AND 0FFFFH
        inc pointer
        hw=shift_left(array[pointer],16)
        inc pointer
        value=lw or hw
        SUB_BEGIN_CRITICAL_SECTION 
          poke(ADWR,adr)
          nop_t9
          poke_nop(d32,value)       
        SUB_END_CRITICAL_SECTION
        #if prozessor=T11 then
          bus_sleep(20)
        #endif             
      NEXT
    endif
  ENDSUB


  '**************************************************************
  'transfer the waveform data from memory to an array
  'card : dip switch address
  'ramstart_adr:  start_adr of memory
  'length: number of values (only even-numbered)
  'array: destination array 
  'array_startindex: startindex in the destination array
  'This sub is only for ADSP processors and AOUT with MEM option
  '**************************************************************
  SUB FG_READ(card,ramstart_adr,length,array,array_startindex)
    DIM ADR AS LONG
    DIM value AS LONG
    DIM i AS LONG
    dim lenint as long
    dim pointer as long
    dim hw as long
    dim lw as long
    
    ADR=(18 OR 080h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr)
      nop_t9
      poke_nop( d32 , (ramstart_adr))
    SUB_END_CRITICAL_SECTION
    pointer=array_startindex
    inc adr 
    bus_sleep(100) 
    lenint=LENGTH 
    if (LENINT>1) then
      for i=1 to LENINT step 2   
        SUB_BEGIN_CRITICAL_SECTION 
          poke_nop_rd(ADRD,adr)
          value=peek(d32)
        SUB_END_CRITICAL_SECTION
        array[pointer]=value AND 0FFFFH
        inc pointer
        array[pointer]=shift_right(value,16)
        inc pointer
      NEXT
    endif
  ENDSUB


  '****************************************************************
  ' Reads the actual output-position of channel 1-8 in the RAM
  ' card : dip switch address
  ' DAC_No: channel number of analog output
  ' This sub is only for ADSP processors and AOUT with MEM option
  '***************************************************************
  FUNCTION FG_READ_INDEX(card, DAC_No) AS LONG
    DIM adr as integer
    
    adr = ((7+(DAC_No))  OR 080h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      FG_READ_INDEX= peek(d32) and 01FFFFFh  
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '****************************************************************
  ' START/STOP FREQUENCYGENERATOR
  ' card : dip switch address
  ' value : bitcombination ; each bit corresponds with an output
  ' action: action=0 starts output of Dacs immediately 
  'action=1 stops output of Dacs immediately 
  'action=2 stops output of Dacs after the periode
  ' This sub is only for ADSP processors and AOUT with MEM option                          
  '***************************************************************
  SUB FG_CONTROL(card,value,action)                                                                                                                                       

    DIM adr as integer
    adr = ((20 OR 080h) OR (SHIFT_LEFT(card,8)))+action
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr )
      nop_t9
      poke_nop( DLX , (value) AND 0FFFFH )
      bus_sleep(100) 
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '****************************************************************
  ' READ STATUS 
  ' card : dip switch address
  ' value : bitcombination ; each bit corresponds with an output
  ' value=1 generator of the channel is running
  ' value=0 generator of the channel is stopped
  ' This sub is only for ADSP processors and AOUT with MEM option
  '***************************************************************
  FUNCTION FG_STATUS(card) AS INTEGER
    DIM adr as integer
    
    adr = (20 OR 080h) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      FG_STATUS= peek(DLX) and 0Fh  
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Initialisation of a digital I/O module (channel 0-15) 
  '  card : dip switch adress
  ' value : each bit corresponds to a channel
  '     0 = input
  '     1 = output
  '***************************************************************
  SUB DIGPROG1(card,value)
    DIM adr, old as integer
    
    adr = 32 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      old = peek( DHX )
      nop_t9
    SUB_END_CRITICAL_SECTION
      
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR, adr )
      nop_t9
      poke( DH , old AND 0FFFFH )
      nop_t9
      poke_nop( DLX, value AND 0FFFFH )
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Initialisation of a digital I/O module (channel 16-31) 
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  '     0 = input
  '     1 = output
  '***************************************************************
  SUB DIGPROG2(card,value)
    DIM adr,old as integer
    
    adr = 32 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      old = peek( DLX )
      nop_t9
    SUB_END_CRITICAL_SECTION
    
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr )
      nop_t9
      poke( DL , old AND 0FFFFH )
      nop_t9
      poke_nop( DHX , value AND 0FFFFH )
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Reads the digital inputs (channel 0 - 15) 
  ' card : dip switch adress
  '***************************************************************
  FUNCTION DIGIN_WORD1(card) AS INTEGER
    DIM adr as integer
    
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      DIGIN_WORD1 = peek(DLX)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Reads the digital inputs (channel 16 - 31) 
  ' card : dip switch adress
  '***************************************************************
  FUNCTION DIGIN_WORD2(card) AS INTEGER
    DIM adr as integer
  
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      DIGIN_WORD2 = peek(DHX)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Reads the digital inputs (channel 0 - 31) 
  ' card : dip switch adress
  '***************************************************************
  FUNCTION DIGIN_LONG(card) AS LONG
    DIM adr as integer
  
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      DIGIN_LONG = PEEK(d32)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Reads the digital inputs (channel 0 - 31) 
  ' card : dip switch adress
  ' only for modules newer 1/2001 and ADSP CPU
  '***************************************************************
  FUNCTION DIGIN_LONG_F(card) AS LONG
    DIM adr as integer

    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION  
      poke_nop_rd(ADRD,ADR)
      Digin_long_F=PEEK(D32)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Sets the digital outputs (channel 0 - 15) 
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  '***************************************************************
  SUB DIGOUT_WORD1(card,value)
    DIM adr as integer
  
    adr = SHIFT_LEFT(card,8)
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr )
      nop_t9
      poke_nop( DLX , value AND 0FFFFH )
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Sets the digital outputs (channel 16 - 31) 
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  '***************************************************************
  SUB DIGOUT_WORD2(card,value)
    DIM adr as integer

    adr = 1 OR SHIFT_LEFT(card,8)
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr )
      nop_t9
      poke_nop( DHX , value AND 0FFFFH )
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Sets the digital outputs (channel 0 - 31) 
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  '***************************************************************
  SUB DIGOUT_LONG(card,value)
    DIM adr as integer
    
    adr = 2 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr )
      nop_t9
      Poke_NOP(D32,value)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Sets the digital outputs (channel 0 - 31) 
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  ' only for modules newer 1/2001 and ADSP CPU
  '***************************************************************
  SUB DIGOUT_long_F(card,value)
    DIM adr as integer
    
    ADR=2h OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADR)
      NOP_T9
      Poke_NOP(D32,value)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' read back of the output value of the digital
  ' outputs (channel 0 - 15)) 
  ' card : dip switch adress
  '***************************************************************
  FUNCTION GET_DIGOUT_WORD1(card) AS INTEGER
    DIM adr as integer
    
    adr = SHIFT_LEFT(card,8)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_RD(ADRD, adr )
      GET_DIGOUT_WORD1 = peek(DLX)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Sets and resets selected digital outputs
  ' card : dip switch adress
  ' set  : Bitstring indicating the outputs which should be set
  ' reset: Bitstring indicating the outputs which should be reset
  '***************************************************************
  Sub DIGOUT_BITS(card,set,reset)
    dim old as long
  
    'getting actual value and manipulating Bits
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_RD(ADRD, SHIFT_LEFT(card,8)) 
      old = (((PEEK(D32)) or set) and not(reset))   
    SUB_END_CRITICAL_SECTION
  
    'writing to output
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR, SHIFT_LEFT(card,8) or 2) 
      nop_t9
      poke_nop(D32 , old )  
    SUB_END_CRITICAL_SECTION
  endsub


  '***************************************************************
  ' Sets and resets selected digital outputs
  ' card : dip switch adress
  ' set  : Bitstring indicating the outputs which should be set
  ' reset: Bitstring indicating the outputs which should be reset
  ' only for DIO32RB and ADSP CPU
  '***************************************************************
  Sub DIGOUT_BITS_F(card,set,reset)
    dim adr as long
    
    ADR=5 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADR)
      NOP_T9
      Poke_NOP(D32,reset)
    SUB_END_CRITICAL_SECTION
    dec ADR
  
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,ADR)
      NOP_T9
      Poke_NOP(D32,set)
    SUB_END_CRITICAL_SECTION
  endsub


  '***************************************************************
  ' read back of the output value of the digital
  ' outputs (channel 16 - 31)) 
  ' card : dip switch adress
  '***************************************************************
  FUNCTION GET_DIGOUT_WORD2(card) AS INTEGER
    DIM adr as integer
    
    adr = SHIFT_LEFT(card,8)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      GET_DIGOUT_WORD2 = peek(DHX)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' read back of the output value of the digital
  ' outputs (channel 0 - 31)) 
  ' card : dip switch adress
  '***************************************************************
  FUNCTION GET_DIGOUT_LONG(card) AS INTEGER
    DIM adr as integer
    
    adr = SHIFT_LEFT(card,8)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      GET_DIGOUT_LONG =peek(D32)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Sets or resets one channel of a digital output  
  ' card    : dip switch adress
  ' channel : channel (0..31)
  ' value   : 0 = reset channel
  '           1 = set channel
  '***************************************************************
  SUB DIGOUT(card,channel,value)
    DIM adr, old, new as integer
    
    adr = SHIFT_LEFT(card,8)
    SUB_BEGIN_CRITICAL_SECTION   'Begin 1
    poke_nop_rd(ADRD, adr )
    IF (channel<16) THEN
      old = peek(DLX)
      SUB_END_CRITICAL_SECTION   'End 1
      IF (value=0) THEN
        new = old AND (NOT(SHIFT_LEFT(1,channel)))
      ELSE
        new = old OR SHIFT_LEFT(1,channel)
      ENDIF
      nop_t9
      SUB_BEGIN_CRITICAL_SECTION
        poke(ADWR, adr)
        nop_t9
        poke_nop(DLX, new)
      SUB_END_CRITICAL_SECTION
    ELSE       
      old = peek(DHX)
      nop_t9
      SUB_END_CRITICAL_SECTION   'End 1
      IF (value=0) THEN
        new = old AND (NOT(SHIFT_LEFT(1,(channel-16))))
      ELSE
        new = old OR SHIFT_LEFT(1,(channel-16))
      ENDIF
    
      SUB_BEGIN_CRITICAL_SECTION
        poke(ADWR, adr+1)
        nop_t9
        poke_nop(DHX, new)
      SUB_END_CRITICAL_SECTION
    ENDIF 
  ENDSUB


  '***************************************************************
  ' Sets or resets one channel of a digital output  
  ' card    : dip switch adress
  ' channel : channel (0..31)
  ' value   : 0 = reset channel
  '           1 = set channel
  ' only for DIO32RB and ADSP CPU
  '***************************************************************
  SUB DIGOUT_F(card,channel,value)  
    SUB_BEGIN_CRITICAL_SECTION  
      POKE(ADWR,((5h-value) OR (SHIFT_LEFT(card,8))))
      NOP_T9
      Poke_NOP(D32,shift_left(1,(channel)))
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' latches the digital I/O card. 
  ' Inputs ars latched in the input registers
  ' Outputs ars set according to the output register.             
  ' card : dip switch adress
  '***************************************************************
  SUB DIG_LATCH(card)
    DIM adr as integer

    adr = 22 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR, adr)
      nop_t9
      poke_nop(DLX , 0)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' reads the input latch register (channel 0 - 15)
  ' card : dip switch adress
  '***************************************************************
  FUNCTION DIG_READLATCH1(card) AS INTEGER
    DIM adr as integer
    
    adr = 20 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      DIG_READLATCH1 = peek(DLX)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' reads the input latch register (channel 16 - 31)
  ' card : dip switch adress
  '***************************************************************
  FUNCTION DIG_READLATCH2(card) AS INTEGER
    DIM adr as integer
    
    adr = 20 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      DIG_READLATCH2 = peek(DHX)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' sets output register (channel 0 - 31)
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  '***************************************************************
  SUB DIG_WRITELATCH32(card,value)
    DIM adr as integer
    
    adr = 18 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr)
      nop_t9
      poke_nop(d32,value)     
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' sets output register (channel 0 - 15)
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  'ATTENTION: Do not use in combination with DIG_WRITELATCH2
  '***************************************************************
  SUB DIG_WRITELATCH1(card,value)
    DIM adr as integer
  
    adr = 18 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr)
      nop_t9
      poke_nop( DLX , value)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' sets output register (channel 16 - 31)
  ' card : dip switch adress
  ' value : each bit corresponds to a channel
  'ATTENTION: Do not use in combination with DIG_WRITELATCH1
  '***************************************************************
  SUB DIG_WRITELATCH2(card,value)
    DIM adr as integer
    
    adr = 18 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr)
      nop_t9
      poke_nop( DHX , value)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  '
  ' The following functions and procedures
  ' are for accessing counter modules. 
  '
  '***************************************************************
  '***************************************************************
  'activate / deaktivate counter 
  ' card : dip switch adress
  ' value : each bit corresponds to a counter
  '***************************************************************
  SUB CNT_ENABLE(card,value)
    DIM adr as integer
  
    adr = 20 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr )
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  'reset counter 
  ' card : dip switch adress
  ' value : each bit corresponds to a counter
  '***************************************************************
  SUB CNT_CLEAR(card,value)
    DIM adr as integer
  
    adr = 18 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr )
      nop_t9
      poke_nop(DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  'latch couner value to register 
  ' card : dip switch adress
  ' value : each bit corresponds to a counter
  '***************************************************************
  SUB CNT_LATCH(card,value)
    DIM adr as integer
  
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr )
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  'set modus for counter
  ' card : dip switch adress
  ' value : each bit corresponds to a counter
  '***************************************************************
  SUB CNT_SETMODE(card,value)
    DIM adr as integer
  
    adr = 22 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr )
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB

  '***************************************************************
  ' set modus for a counter
  ' card : dip switch adress
  ' counter : number of the counter
  ' value : 0 = quadrature encoder input
  '         1 = forward / backward counter
  '         2 = PW input
  '***************************************************************
  SUB CO4_SETMODE(card,counter,value)
    DIM adr1 as integer
    DIM adr2 as integer
    DIM mode1 as long
    DIM mode2 as long
    DIM readback1 as long
    DIM readback2 as long
  
    adr1 = 22 OR (SHIFT_LEFT(card,8))
    adr2 = adr1 + 1
    mode1 = shift_left(value and 1, counter-1)
    mode2 = shift_left(shift_right((value and 2),1), counter-1)
  
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD , adr1)
      readback1 = PEEK(DLX) and not (shift_left(1, counter-1)) 
      nop_t9
    SUB_END_CRITICAL_SECTION
  
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD , adr2)
      readback2 = PEEK(DLX) and not( shift_left(1, counter-1)) 
      nop_t9
    SUB_END_CRITICAL_SECTION
    mode1 = mode1 or readback1  
    mode2 = mode2 or readback2  
  
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr1)
      nop_t9
      poke_nop( DLX , mode1)           
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr2)
      nop_t9
      poke_nop( DLX , mode2)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  'read latch register 32 Bit
  ' card : dip switch adress
  ' number : number of the counter
  ' remark: It is checked if a new counter value had been 
  '         latched between reading the high-word and the
  '         low word. In this case it will be read again. 
  '         (hardware latch)
  '***************************************************************
  FUNCTION CNT_READLATCH32(card,number) AS INTEGER
    DIM hadr, ladr AS INTEGER
    DIM old_hword, old_lword AS INTEGER
    DIM hword, lword AS INTEGER
  
    hadr = (2*number-1) OR (SHIFT_LEFT(card,8))
    ladr = (2*number-2) OR (SHIFT_LEFT(card,8))
    DO
      SUB_BEGIN_CRITICAL_SECTION
        poke_nop_rd(ADRD , ladr)
        old_lword = PEEK(DLX)
      SUB_END_CRITICAL_SECTION
      SUB_BEGIN_CRITICAL_SECTION
        poke_nop_rd(ADRD , hadr)
        old_hword = PEEK(DLX)
      SUB_END_CRITICAL_SECTION
      SUB_BEGIN_CRITICAL_SECTION
        poke_nop_rd(ADRD , ladr)
        lword = PEEK(DLX)
      SUB_END_CRITICAL_SECTION
      SUB_BEGIN_CRITICAL_SECTION
        poke_nop_rd(ADRD , hadr)
        hword = PEEK(DLX)
      SUB_END_CRITICAL_SECTION
    UNTIL ((old_lword = lword) AND (old_hword = hword))
    CNT_READLATCH32 = SHIFT_LEFT(hword, 16) + (lword AND 0FFFFH)
  ENDFUNCTION


  '**************************************************************
  ' reads latch register 32 Bit
  ' card : dip switch adress
  ' number : number of the counter
  '**************************************************************
  FUNCTION CO4_READLATCH(card,number) AS INTEGER
    DIM adr as INTEGER
    
    adr = (number-1) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD , adr)
      CO4_READLATCH = PEEK(D32)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' only for moduls newer than 08/2002
  ' set modus of the 3. PWM-Register and
  ' set destination of the softwarelatch
  ' card : dip switch adress
  ' value :  bit 0-3 each bit corresponds to a counter (3. PWM-Register)
  '          0->latch with high-edge (default)
  '          1->latch with low-edge
  '          bit 4-7 each bit corresponds to a counter (softwarelatch)
  '          0->latch into low-register (default)
  '          1->latch into high-register
  '***************************************************************
  SUB CO4_SET_LATCHMODE(card,value)
    DIM adr as integer
    
    adr = 25 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr )
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' read latch register 16 Bit
  ' card : dip switch adress
  ' number : number of the counter
  '***************************************************************
  FUNCTION CNT_READLATCH16(card,number) AS INTEGER
    DIM adr as integer
    
    IF (number<9) THEN 
      adr = (2*number-2) OR (SHIFT_LEFT(card,8))
    ELSE
      adr = (2*number-17) OR (SHIFT_LEFT(card,8))
    ENDIF
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      CNT_READLATCH16 = PEEK(DLX) AND 0FFFFH  
      nop_t9      
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' read counter value 32 Bit
  '   card : dip switch adress
  ' number : number of the counter
  '***************************************************************
  FUNCTION CNT_READ32(card,number) AS INTEGER
    DIM adr, hword as integer
    
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr )
      nop_t9
      poke_nop( DLX , SHIFT_LEFT(1,(number-1)))   'latch counter
    SUB_END_CRITICAL_SECTION
    adr = (2*number-1) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      hword = Shift_Left(PEEK(DLX),16)            'read HighWord
    SUB_END_CRITICAL_SECTION
    adr = (2*number-2) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      CNT_READ32 = hword + (PEEK(DLX) AND 0FFFFH) 'read LowWord
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '**************************************************************
  ' read counter value 32 Bit (new counter board)
  ' card : dip switch adress
  ' number : number of the counter
  '**************************************************************
  FUNCTION CO4_READ(card,number) AS INTEGER
    DIM adr as integer
  
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr )
      nop_t9
      poke_nop( DLX , SHIFT_LEFT(1,(number-1)))    'latch counter
    SUB_END_CRITICAL_SECTION
  
    adr = (number-1) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      CO4_READ = PEEK(D32)                     'read 32 Bit-value
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' read counter value 16 Bit
  '   card : dip switch adress
  ' number : number of the counter
  '***************************************************************
  FUNCTION CNT_READ16(card,number) AS INTEGER
    DIM adr, hword as integer
    
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr )
      nop_t9
      poke_nop( DLX , SHIFT_LEFT(1,(number-1)))   'latch counter
    SUB_END_CRITICAL_SECTION
    IF (number<9) THEN 
      adr = (2*number-2) OR (SHIFT_LEFT(card,8))
    ELSE
      adr = (2*number-17) OR (SHIFT_LEFT(card,8))
    ENDIF
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      CNT_READ16 = PEEK(DLX) AND 0FFFFH            'read LowWord
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '**************************************************************
  ' reads the status of a counter input 
  ' card : dip switch adress
  ' counter : number of the counter
  '**************************************************************
  FUNCTION CO4_GETSTATUS(card,counter) AS long
    DIM adr as long
  
    adr = (27 + counter) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr)
      CO4_GETSTATUS = PEEK(D32)           'read 32 Bit-value
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '**************************************************************
  ' resets tihe error bits of the status register
  ' card : dip switch adress
  ' value : bitcombination ; each bit corresponds with counter
  '**************************************************************
  SUB CO4_RESETSTATUS(card,value) AS long
    DIM adr as integer
  
    adr = 27 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr)
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  ' enables the hardware clear input of a counter
  ' card : dip switch adress
  ' value : bitcombination ; each bit corresponds with counter
  '**************************************************************
  SUB CO4_CLEARENABLE(card,value) AS long
    DIM adr as integer
  
    adr = 24 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr)
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  ' enables the hardware latch input of a counter
  ' card : dip switch adress
  ' value : bitcombination ; each bit corresponds with counter
  '**************************************************************
  SUB CO4_LATCHENABLE(card,value) AS long
    DIM adr as integer
  
    adr = 26 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr)
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


 '**************************************************************
 ' read SSI encoder value 32 Bit (new counter board)
 ' card : dip switch adress
 ' counter : number of the counter
 '**************************************************************
  FUNCTION SSI_READ(card,counter) AS long
    DIM adr as long
    
    adr = (34 + counter) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr )
      SSI_READ = PEEK(D32)            'read 32 Bit-value
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '**************************************************************
  ' sets the number of databits for the SSI Interface
  ' card : dip switch adress
  ' counter : number of the counter
  ' value : number of bits
  '**************************************************************
  SUB SSI_SET_BITS(card,counter,value)
    DIM adr as integer
    adr = (36 + counter) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR , adr)
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  ' sets frequency of the SSI clock
  ' card : dip switch adress
  ' value : frequency = 10MHZ / value
  '**************************************************************
  SUB SSI_SET_CLOCK(card,value)
    DIM adr as integer
  
    adr = 34 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr)
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  ' Starts the SSI interface
  ' card : dip switch adress
  ' value : Bitcombination each bit corresponts to one counter
  '**************************************************************
  SUB SSI_START(card,value)
    DIM adr as integer
    Dim value2 as long
  
    adr = 17 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr)
      value2 = peek(DLX)
    SUB_END_CRITICAL_SECTION
    value2=(value and 03H)or value2
  
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr)
      nop_t9
      poke_nop(DLX , value2)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*************************************************************
  ' Stets the SSI mode
  ' card : dip switch adress
  ' value : Bitcombination each bit corresponts to one counter
  '       0 = single start mode
  '       1 = continuous start mode
  '*************************************************************
  sub SSI_MODE(card,value)
    dim adr as long
    dim value2 as long
    
    value2=value AND 03H
    adr = 17 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr)
      nop_t9
      poke_nop(DLX , (shift_left(value2,2)))
    SUB_END_CRITICAL_SECTION
  endsub


  '*************************************************************
  ' Reads the SSI status
  ' card : dip switch adress
  ' counter : number of the SSI counter
  ' return value : 0 = SSI value compleated
  '                1 = SSI transfer running
  '*************************************************************
  FUNCTION SSI_STATUS(card,counter) AS long
    dim adr as long
    dim value2 as long
 
    adr = 17 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr)
      value2 = peek(DLX)
    SUB_END_CRITICAL_SECTION
    value2=shift_right(value2,(counter-1))
    ssi_status=value2 AND 01H
  ENDFUNCTION


  '***************************************************************
  ' sets and updates the PWM-4 modul
  '   card : dip switch adress
  ' number : number of the output
  '     prescaler : value 0,...,7 corresponds to division by 2^0,...,2^7
  '     LOW     : Number of cycles after the prescaler for LOW time
  '     HIGH     : Number of cycles after the prescaler for HIGH time
  '***************************************************************
  SUB PWM_SET(card,number,prescaler,LOW,HIGH)
    DIM adr_t, adr_l, adr_h AS INTEGER
    
    adr_t=(number*2-1) OR (SHIFT_LEFT(card,8))
    adr_l=(number*2+6) OR (SHIFT_LEFT(card,8))
    adr_h=(number*2-2) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr_t)
      nop_t9
      poke_nop(DLX,prescaler)
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr_l)
      nop_t9
      poke_nop(DLX,LOW)
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr_h)
      nop_t9
      poke_nop(DLX,HIGH)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' enable a output of the PWM module
  '   card : dip switch adress
  ' number : number of the output
  '***************************************************************
  SUB PWM_ENABLE(card,number)
    DIM adr_en, adr_clr AS INTEGER
  
    adr_clr=18 OR (SHIFT_LEFT(card,8))
    adr_en=20 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr_clr)
      nop_t9
      poke_nop(DLX,SHIFT_LEFT(1,number))
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr_en)
      nop_t9
      poke_nop(DLX,number)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  'External Latch enable/disable 
  ' card  : dip switch adress
  ' value : 1 = enable
  '         0 = disable 
  '***************************************************************
  SUB EXTLCH_ENABLE(card,value)
    DIM adr as integer
    adr = 24 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR , adr )
      nop_t9
      poke_nop( DLX , value)           
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' set/reset a output of the PWM modul
  '   card : dip switch adress
  ' number : number of the output
  'value   : 0 = output voltage = 0V
  '          1 = output voltage = external voltage
  '***************************************************************
  SUB PWM_OUT(card,number,value)
    DIM adr_clr, adr_upd AS INTEGER
    
    adr_clr=18 OR (SHIFT_LEFT(card,8))
    adr_upd=24 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr_clr)
      nop_t9
      poke_nop(DLX,SHIFT_LEFT(1,number-1))
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr_upd)
      nop_t9
      poke_nop(DLX,SHIFT_LEFT(1,number-1))
    SUB_END_CRITICAL_SECTION
    PWM_SET(card,number,0,1-value,value)
  ENDSUB


  '*********************************************************************
  ' The following functions and procedures
  ' are for accessing the STORAGE modules. 
  '*********************************************************************
  
  '*********************************************************************
  ' Reads the status word from the glue logic.
  '  card: module address
  '  status|     |  |  |  |  ||   |   |    |    ||     |    |    |     |
  '   bits |31:12|11|10|09|08|| 07| 06| 05 | 04 || 03  | 02 | 01 | 00  |
  '  ------|-----|--|--|--|--||---|---|----|----||-----|----|----|-----|
  '        |     |           ||   |   | =1 | =1 || =1  | =1 | =1 | =1  |
  '        | NA  |           ||*NA|*NA|RE- |DATA||DATA |BUSY|ERR-|Media|
  '        |     |           ||   |   |SET |wri-|| can |    | OR | in  |
  '        |     |           ||   |   |    |tten|| be  |    |    |Slot |
  '        |     |           ||   |   |    |    ||read |    |    |     |
  '               \          /
  '                0  0  0  1  = 1d : Time-Out READY-Signal
  '                0  0  1  0  = 2d : Time-Out WAIT-Signal
  '                0  0  1  1  = 3d : Media was removed
  '                0  1  0  0  = 4d : Error at READY
  '                0  1  0  1  = 5d : Time-Out READY
  '                0  1  1  0  = 6d : Error at DRQ (Data ReQuest)
  '                0  1  1  1  = 7d : Time-Out DRQ (Data ReQuest)
  '                1  0  0  0  = 8d : Media not inserted
  '       * = Might be set by other function calls
  '*********************************************************************
  FUNCTION MEDIA_STAT(card) AS LONG
    SUB_BEGIN_CRITICAL_SECTION  
      POKE_NOP_rd(ADRD,3 OR SHIFT_LEFT(card,8))
      MEDIA_STAT = PEEK(D32)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*********************************************************************
  ' Reads a 32 bit LONG value from the glue logic which was previously
  ' read from the media.
  '  card: module address
  '*********************************************************************
  FUNCTION MEDIA_RD_DAT(card) AS LONG
    SUB_BEGIN_CRITICAL_SECTION  
      POKE_NOP_RD(ADRD,15 OR SHIFT_LEFT(card,8))
      MEDIA_RD_DAT = PEEK(D32)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*********************************************************************
  ' Writes an instruction word to the glue logic.
  '  card:   module address (LONG)
  '  code:   instruction code (LONG), possible codes are:
  '          6 - write sectors
  '          8 - read identifier of media (256 bytes long)
  '          9 - read sectors
  '  sector: sector number (LONG)
  '  cnt:    sector count (LONG: 1...12)
  '*********************************************************************
  SUB MEDIA_WR_CMD(card,code,sector,cnt)
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,code OR SHIFT_LEFT(card,8))
      NOP_T9
      POKE_NOP(D32,(sector OR SHIFT_LEFT(cnt,28)))
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*********************************************************************
  ' Writes one 32 bit data word to the SRAM of the glue logic.
  '  card : module address (LONG)
  '  daten: 32 bit data word (LONG or FLOAT)
  '*********************************************************************
  SUB MEDIA_WR_DAT(card,daten)
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,7 OR SHIFT_LEFT(card,8))
      NOP_T9
      POKE_NOP(D32,daten)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*********************************************************************
  ' Sends a RESET command to the media for initialization or recovering
  ' from unexpected fault conditions.
  '  card: module address (LONG)
  '*********************************************************************
  SUB MEDIA_RST(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,20 OR SHIFT_LEFT(card,8))
      NOP_T9
      POKE_NOP(D32,0)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*********************************************************************
  ' Waits for respond of the media for a specified amount of time.
  '  card: module address (1...255)
  '  term: Abort condition (as described in MEDIA_STAT())
  '  time: Abort time in 100s steps
  '  return value : Media status as described in MEDIA_STAT() (LONG) or
  '                 80h -> Media does not respond (time-out)
  '*********************************************************************
  FUNCTION MEDIA_WFR(card,term,time) AS LONG
    DIM t1, t2, t3, stat, ret, div AS LONG

    div=2
    t1=READ_TIMER()
    t3=time/(div+1)*30000           '1/3 of the necessary time
    DO
      t2=READ_TIMER()
      stat=MEDIA_STAT(card)
      IF ((stat AND 1)=0) THEN        'media not inserted
        ret=stat
        stat=0
      ELSE
        IF ((t2-t1)>t3) THEN    'time-out
          IF (div>0) THEN
            t1=READ_TIMER()
            DEC div
          ELSE            'after 3 loops: RESET
            MEDIA_RST(card)
            ret=80h
            stat=0
          ENDIF
        ELSE
          ret=stat
        ENDIF
      ENDIF
    UNTIL ((stat AND term)=0h)
    MEDIA_WFR=ret
  ENDFUNCTION


  '*********************************************************************
  ' Writes blocks (1...12 with 128 LONGs each) of data to media.
  '  card   : Module address (LONG: 1...255)
  '  f_info : Name of array that holds the file informations
  '  file   : File number (LONG: 1...10)
  '  s_sec  : Rel. sector number of start sector in file (LONG: 1...m)
  '  s_cnt  : Number of blocks with 128 LONGs each (LONG: 1...12)
  '  array  : Source array to copy data from
  '  idx    : First array element to copy from (LONG: 1...n)
  '  return value : Media status as described in MEDIA_STAT() (LONG) or
  '                 40h -> number of blocks exceeding EOF,
  '                        no data written to media
  '*********************************************************************
  FUNCTION MEDIA_WR_BLK_L(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
    DIM i, first, last, stat, type AS LONG

    last=f_info[file*2+2]
    first=f_info[file*2+1]
    IF ((last-first+2)<(s_sec+s_cnt)) THEN
        stat=40h                        'Block will be written beyond EOF!!!
    ELSE
      stat=MEDIA_WFR(card,26h,150000)
      MEDIA_WR_CMD(card,6,(s_sec-1+first),s_cnt)
      FOR i=1 TO s_cnt*128
        MEDIA_WR_DAT(card,array[idx-1+i])
      NEXT i
      stat=MEDIA_STAT(card)
    ENDIF
    MEDIA_WR_BLK_L=stat
  ENDFUNCTION
  
  FUNCTION MEDIA_WR_BLK(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
    MEDIA_WR_BLK = MEDIA_WR_BLK_L(card,f_info,file,s_sec,s_cnt,array,idx)
  ENDFUNCTION


  '*********************************************************************
  ' Writes blocks (1...12 with 128 FLOATs each) of data to media.
  '  card   : Module address (LONG: 1...255)
  '  f_info : Name of array that holds the file informations
  '  file   : File number (LONG: 1...10)
  '  s_sec  : Rel. sector number of start sector in file (LONG: 1...m)
  '  s_cnt  : Number of blocks with 128 FLOATs each (LONG: 1...12)
  '  array  : Source array to copy data from
  '  idx    : First array element to copy from (LONG: 1...n)
  '  return value : Media status as described in MEDIA_STAT() (LONG) or
  '                 40h -> number of blocks exceeding EOF,
  '                        no data written to media
  '*********************************************************************
  FUNCTION MEDIA_WR_BLK_F(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
    DIM i, first, last, stat, type AS LONG
      last=f_info[file*2+2]
      first=f_info[file*2+1]
      IF ((last-first+2)<(s_sec+s_cnt)) THEN
        stat=40h                        'Block will be written beyond EOF!!!
      ELSE
        stat=MEDIA_WFR(card,26h,150000)
        MEDIA_WR_CMD(card,6,(s_sec-1+first),s_cnt)
        stat=MEDIA_WFR(card,26h,150000)
        FOR i=1 TO s_cnt*128
          MEDIA_WR_DAT(card,CAST_FLOATTOLONG(array[idx-1+i]))
        NEXT i
        stat=MEDIA_STAT(card)
      ENDIF
      MEDIA_WR_BLK_F=stat
  ENDFUNCTION


  '*********************************************************************
  ' Reads blocks (1...12 with 128 LONGs each) of data from media.
  '  card   : Module address (LONG: 1...255)
  '  f_info : Name of array that holds the file informations
  '  file   : File number (LONG: 1...10)
  '  s_sec  : Rel. sector number of start sector in file (LONG: 1...n)
  '  s_cnt  : Number of blocks with 128 LONGs/FLOATs each (LONG: 1...12)
  '  array  : Destination array to copy data to
  '  idx    : First array element to copy to (LONG: 1...n)
  '  return value : Media status as described in MEDIA_STAT() (LONG) or
  '                 40h -> number of blocks exceeding EOF,
  '                        no data read from media
  '*********************************************************************
  FUNCTION MEDIA_RD_BLK_L(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
    DIM i, first, last, stat AS LONG
    
      last=f_info[file*2+2]
      first=f_info[file*2+1]
      IF ((last-first+2)<(s_sec+s_cnt)) THEN
        stat=40h                        'Block will be read beyond EOF!!!
      ELSE
        stat=MEDIA_WFR(card,26h,150000)
        MEDIA_WR_CMD(card,9,(s_sec-1+first),s_cnt)
        stat=MEDIA_WFR(card,26h,150000)
        FOR i=1 TO s_cnt*128
          array[idx-1+i]=MEDIA_RD_DAT(card)
        NEXT i
        stat=MEDIA_STAT(card)
      ENDIF
      MEDIA_RD_BLK_L=stat
  ENDFUNCTION


  '*********************************************************************
  ' Reads blocks (1...12 with 128 FLOATs each) of data from media.
  '  card   : Module address (LONG: 1...255)
  '  f_info : Name of array that holds the file informations
  '  file   : File number (LONG: 1...10)
  '  s_sec  : Rel. sector number of start sector in file (LONG: 1...n)
  '  s_cnt  : Number of blocks with 128 LONGs/FLOATs each (LONG: 1...12)
  '  array  : Destination array to copy data to
  '  idx    : First array element to copy to (LONG: 1...n)
  '  return value : Media status as described in MEDIA_STAT() (LONG) or
  '                 40h -> number of blocks exceeding EOF,
  '                        no data read from media
  '*********************************************************************
  FUNCTION MEDIA_RD_BLK_F(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
    DIM i, first, last, stat AS LONG
    
    last=f_info[file*2+2]
    first=f_info[file*2+1]
    IF ((last-first+2)<(s_sec+s_cnt)) THEN
      stat=40h                        'Block will be read beyond EOF!!!
    ELSE
      stat=MEDIA_WFR(card,26h,150000)
      MEDIA_WR_CMD(card,9,s_sec-1+first,s_cnt)
      stat=MEDIA_WFR(card,26h,150000)
      FOR i=1 TO s_cnt*128
        array[idx-1+i]=CAST_LONGTOFLOAT(MEDIA_RD_DAT(card))
      NEXT i
      stat=MEDIA_STAT(card)
    ENDIF
    MEDIA_RD_BLK_F=stat
  ENDFUNCTION


  '*********************************************************************
  ' Resets media and reads from sector 2 the file information table,
  ' where all start and end sectors of the data files are stored.
  ' Unable to read sector 2 if RESET, BUSY, ERROR, no media in slot!
  '  card  : module address (LONG: 1...255)
  '  array : Name of array (>=22 elements) to store start & end sectors
  '  return value : Media status as described in MEDIA_STAT() (LONG)
  '*********************************************************************
  FUNCTION MEDIA_RD_FILEINFO(card,array[]) AS LONG
    DIM n, stat AS LONG
    
    stat=MEDIA_STAT(card)
    IF ((stat AND 1h)=1h) THEN
      MEDIA_RST(card)
      stat=MEDIA_WFR(card,26h,1200)
      MEDIA_WR_CMD(card,9,2,1)
      stat=MEDIA_WFR(card,26h,150000)
      FOR n=1 TO 22
        array[n]=MEDIA_RD_DAT(card)
      NEXT n
    ENDIF
    MEDIA_RD_FILEINFO=stat
  ENDFUNCTION


  '********************** Real-Time-Clock (RTC): ***********************
  'The 32 bit value holds the information for year, month, day,
  'hour, minute and second in the following manner:
  '   bits: | 31:26 | 25:22 | 21:17 | 16:12 | 11:06 | 05:00 |
  '   ------+-------+-------+-------+-------+-------+-------+
  '         | year  | month |  day  | hour  |minute |second |
  
  '*********************************************************************
  ' Writes the coded 32 bit word containing the date and time infor-
  ' mation to the RTC.
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  SUB RTC_WR(card,value)
    SUB_BEGIN_CRITICAL_SECTION
      POKE(ADWR,16 OR SHIFT_LEFT(card,8))
      NOP_T9
      POKE_NOP(D32,value)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*********************************************************************
  ' Reads the coded 32 bit word containing the date and time information
  ' from the RTC.
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  FUNCTION RTC_RD(card) AS LONG
    SUB_BEGIN_CRITICAL_SECTION
      POKE_NOP_RD(ADRD,17 OR SHIFT_LEFT(card,8))
      RTC_RD=PEEK(D32)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION
  
  
  '*********************************************************************
  ' Sets the RTC to the desired value. If any of the entries are not
  ' valid neither value will be accepted and the RTC remains unchanged!
  '  card:   Module address (LONG: 1...255)
  '  year:   Last two digits of the year 0...63 (LONG)
  '  month:  1...12 (LONG)
  '  day:    1...31 (LONG)
  '  hour:   0...23 (LONG)
  '  minute: 0...59 (LONG)
  '  second: 0...59 (LONG)
  '*********************************************************************
  SUB RTC_SET(card,year,month,day,hour,min,sec)
    DIM val AS LONG
    
    val=0
    val=SHIFT_LEFT(year AND 3Fh,26)                                         'Bits 31:26
    val=val OR SHIFT_LEFT(month AND 0Fh,22)         'Bits 25:22
    val=val OR SHIFT_LEFT(day AND 1Fh,17)                   'Bits 21:17
    val=val OR SHIFT_LEFT(hour AND 1Fh,12)          'Bits 16:12
    val=val OR SHIFT_LEFT(min AND 3Fh,6)                    'Bits 11:06
    val=val OR (sec AND 3Fh)                                                                        'Bits 05:00
    RTC_WR(card,val)
  ENDSUB


  '*********************************************************************
  ' Reads out the current date and time from the RTC at once.
  ' Parameters are preferably LONGs.
  '  card:   Module address (LONG: 1...255)
  '  year:   Last two digits of the year 0...63 (LONG)
  '  month:  1...12 (LONG)
  '  day:    1...31 (LONG)
  '  hour:   0...23 (LONG)
  '  minute: 0...59 (LONG)
  '  second: 0...59 (LONG)
  '*********************************************************************
  SUB RTC_GET(card,year,month,day,hour,min,sec)
    DIM val AS LONG
    
    val=RTC_RD(card)
    year=SHIFT_RIGHT(val,26) AND 3Fh                'Bits 31:26
    month=SHIFT_RIGHT(val,22) AND 0Fh               'Bits 25:22
    day=SHIFT_RIGHT(val,17) AND 1Fh                 'Bits 21:17
    hour=SHIFT_RIGHT(val,12) AND 1Fh                'Bits 16:12
    min=SHIFT_RIGHT(val,6) AND 3Fh                  'Bits 11:06
    sec=val AND 3Fh                                                                                 'Bits 05:00
  ENDSUB


  '*********************************************************************
  ' Reads out the current year from the RTC (2000...2063).
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  FUNCTION RTC_GET_YEAR(card) AS LONG
    RTC_GET_YEAR=SHIFT_RIGHT(RTC_RD(card),26)+2000
  ENDFUNCTION


  '*********************************************************************
  ' Reads out the current month from the RTC (1...12)
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  FUNCTION RTC_GET_MONTH(card) AS LONG
    RTC_GET_MONTH=SHIFT_RIGHT(RTC_RD(card),22) AND 0Fh
  ENDFUNCTION


  '*********************************************************************
  ' Reads out the current day from the RTC
  ' (value ranges from 1...28/29/30/31 depending on month and leapyear)
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  FUNCTION RTC_GET_DAY(card) AS LONG
    RTC_GET_DAY=SHIFT_RIGHT(RTC_RD(card),17) AND 1Fh
  ENDFUNCTION


  '*********************************************************************
  ' Reads out the current hour from the RTC (0...23, military notation)
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  FUNCTION RTC_GET_HOUR(card) AS LONG
    RTC_GET_HOUR=SHIFT_RIGHT(RTC_RD(card),12) AND 1Fh
  ENDFUNCTION


  '*********************************************************************
  ' Reads out the current minute from the RTC (0...59)
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  FUNCTION RTC_GET_MINUTE(card) AS LONG
    RTC_GET_MINUTE=SHIFT_RIGHT(RTC_RD(card),6) AND 3Fh
  ENDFUNCTION
  
  
  '*********************************************************************
  ' Reads out the current second from the RTC (0...59)
  '  card: Module address (LONG: 1...255)
  '*********************************************************************
  FUNCTION RTC_GET_SECOND(card) AS LONG
    RTC_GET_SECOND=RTC_RD(card) AND 3Fh
  ENDFUNCTION


  '*************************************************************
  ' COMP 16
  '*************************************************************
  ' SET HYSTERESIS SWITCH POINTS
  ' card : dip switch adress
  ' channe: channel (1-16)
  ' valueHIGH switch point to set output bit to 1
  ' valueLOW switch point to set output bit to 0
  '*************************************************************
  SUB COMP_SET(card,channel,valueHigh,valueLow)
    DIM adr AS INTEGER
    DIM CH,HIGH,LOW as INTEGER
     
    adr=20 OR (SHIFT_LEFT(card,8))
    CH=shift_left(((channel-1) AND 0FH),20) 
    HIGH=shift_left((valueHigh AND 3FFH),10)
    LOW=valueLow AND 3FFH
     
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr)
      nop_t9
      poke_nop(D32,(CH OR HIGH OR LOW))
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' Reads the digital inputs (channel 0 - 15) 
  ' card : dip switch adress
  '***************************************************************
  FUNCTION COMP_DIGIN_WORD(card) AS INTEGER
    DIM adr as integer
  
    adr = 16 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_RD(ADRD, adr )
      COMP_DIGIN_WORD = peek(DLX)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' Reads the digital inputs (channel 0 - 7) by diff   
  ' card : dip switch adress
  '***************************************************************
  FUNCTION COMP_DIGIN_WORD_DIFF(card) AS LONG
    dim adr as long
    adr = 23 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_RD(ADRD, adr)
      COMP_DIGIN_WORD_DIFF = peek(D32)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*************************************************************
  ' Reads the analog value, min value or max value
  ' card : dip switch adress
  ' channel nummber of channel (1-16)
  ' select 0 = read value
  '                                1 = read min value
  '        2 = read max value
  '*************************************************************
  FUNCTION COMP_READ(card,channel,select) AS long
    dim adr as long
    dim value2 as long
    
    adr = (23+channel) OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_RD(ADRD, adr)
      value2 = peek(D32)
    SUB_END_CRITICAL_SECTION

    COMP_READ=(shift_right(value2,(10*select))) AND 3FFH
  ENDFUNCTION


  '*************************************************************
  ' RESET min / max value (max=0 min=1024)
  ' card : dip switch adress
  ' select : each bit corresponds to a channel
  '*************************************************************
  SUB COMP_RESET(card,select)
    DIM adr AS INTEGER
    
    adr=21 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr)
      nop_t9
      poke_nop(D32,(select))
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*************************************************************
  ' Select the channels to write to the internal FIFO
  ' card : dip switch adress
  ' channel : 0= channel 1/2  1= channel 3/4 ...
  '*************************************************************
  sub COMP_FIFO_SELECT(card,channel)
    DIM adr AS INTEGER
    
    adr=17 OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr)
      nop_t9
      poke_nop(D32,(channel+1))
    SUB_END_CRITICAL_SECTION
  endsub


  '*************************************************************
  ' Read FIFOBUFFER[1024] to DATA 
  ' card : dip switch adress
  ' channel : 0= channel 1,2  1= channel 3,4 ...
  '*************************************************************
  sub COMP_FIFO_READ(card,arrayLowChannel,arrayHighChannel)
    DIM adr AS INTEGER
    dim i as long
    dim value as long
    dim select as long
  
    adr=18 OR (SHIFT_LEFT(card,8))
    'read select for new start
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_RD(ADRd,adr-1)
      nop_t9
      select=peek(Dlx)
      nop_t9
    SUB_END_CRITICAL_SECTION
    
    'stop write to fifo
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr-1)
      nop_t9
      poke_nop(D32,(0))
    SUB_END_CRITICAL_SECTION
  
    'set adress
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr)
      nop_t9
      poke_nop(D32,0)
    SUB_END_CRITICAL_SECTION
  
    'read value
    for i=1 to 1024
      SUB_BEGIN_CRITICAL_SECTION
        poke_nop_RD(ADRD, adr-4)
        value = peek(D32)
      SUB_END_CRITICAL_SECTION
      arrayHighChannel[i]=value AND 0FFFFH
      arrayLowChannel[i]=shift_right(value,16)      
    next
  
    'start write to fifo
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR,adr-1)
      nop_t9
      poke_nop(D32,select)
    SUB_END_CRITICAL_SECTION
  endsub


  '---------------------------------------------------------------
  ' calculates address value
  '---------------------------------------------------------------
  FUNCTION FUNCTIONS_WERT(BEFEHL,KARTE,TYP) AS INTEGER
    FUNCTIONS_WERT = (BEFEHL OR TYP) OR (SHIFT_LEFT(KARTE,8))
  ENDFUNCTION

  '***************************************************************
  '  switches a LED on or off
  '  KARTE        :   module-address
  '  KARTENTYP: type of module
  '  WERT : 0/1 off/on
  '***************************************************************
  SUB SETLED(KARTE,KARTENTYP,WERT)
    DIM adr as integer
    
    IF (KARTENTYP=cpu) THEN
      SUB_BEGIN_CRITICAL_SECTION
        POKE(CPU_LED, WERT)
        nop_t9
      SUB_END_CRITICAL_SECTION
    ELSE
      adr = FUNCTIONS_WERT( 42, KARTE , KARTENTYP)
      SUB_BEGIN_CRITICAL_SECTION
        poke( ADWR, adr )
        nop_t9
        poke_nop( DLX, WERT)
      SUB_END_CRITICAL_SECTION
    ENDIF
  ENDSUB


  '***************************************************************
  '  checks the LED on a module
  '  KARTE        :   module-address
  '  KARTENTYP: type of module
  '***************************************************************
  FUNCTION CHECKLED(KARTE,KARTENTYP) AS INTEGER
    DIM adr as integer
    
    IF (KARTENTYP=cpu) THEN
      SUB_BEGIN_CRITICAL_SECTION
        CHECKLED = (PEEK(CPU_LED) and 1)
        nop_t9
      SUB_END_CRITICAL_SECTION
    ELSE
      adr = FUNCTIONS_WERT( 42, KARTE , KARTENTYP)
      SUB_BEGIN_CRITICAL_SECTION
        poke_nop_rd(ADRD, adr )
        CHECKLED = peek( DLX) AND 1
        nop_t9
      SUB_END_CRITICAL_SECTION
    ENDIF
  ENDFUNCTION


  '***************************************************************
  '  activates or deactivates the external Event input
  '  KARTE        :   module-address         
  '  KARTENTYP: type of module
  '  WERT : 0/1 deactivate/activate
  '***************************************************************
  SUB EVENTENABLE(KARTE,KARTENTYP,WERT)
    DIM adr as integer
  
    SUB_BEGIN_CRITICAL_SECTION
    POKE( cpu_EVENT, 256*WERT)              'enable the EVENT on the processormodule
    #IF PROZESSOR = T11 THEN
      bus_sleep(9)
    #endif
    SUB_END_CRITICAL_SECTION
      adr = FUNCTIONS_WERT( 56, KARTE , KARTENTYP)
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr )
      nop_t9
      poke_nop( DLX, 9-WERT)                ' EVENT on module 
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  '  define whether rising/falling edge is triggering the Event
  '  (= german:   Event auslsendes Ereignis festlegen)
  '  KARTE        :   module-address         
  '  KARTENTYP: type of module
  '  WERT : 0  rising edge              (= steigende Flanke)
  '         1  rising edge              (= steigende Flanke)
  '         2  falling edge             (= fallende Flanke)
  '         3  rising and falling edge  (= beide Flanken)
  '***************************************************************
  SUB EVENTSOURCE(KARTE,KARTENTYP,WERT)
    DIM adr as integer
    
    adr = FUNCTIONS_WERT( 59, KARTE , KARTENTYP)
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr )
      nop_t9
      poke_nop( DLX, WERT)          'EVENTSOURCE on module 
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  '  activate- or deactivate the Sync-function of a module
  '  KARTE        :   module-address         
  '  KARTENTYP: type of module
  '  WERT : 0/1 deactivate/activate
  '***************************************************************
  SUB SYNCENABLE(KARTE,KARTENTYP,WERT)
    DIM adr AS INTEGER
    
    adr = FUNCTIONS_WERT( 58, KARTE , KARTENTYP)
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, adr )
      nop_t9
      poke_nop( DLX, WERT)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' latch all those modules, which have been activated with the 
  ' SYNCENABLE command
  '***************************************************************
  SUB SYNCALL()
    SUB_BEGIN_CRITICAL_SECTION
      poke( ADWR, 52)
      nop_t9
      poke_nop( DLX, 255)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  '  checks, whether the Sync-function of a module is activated
  '  KARTE        :   module-address         
  '  KARTENTYP: type of module
  '  result :   0/1   activated/deactivated 
  '***************************************************************
  FUNCTION SYNCSTAT(KARTE,KARTENTYP) AS INTEGER
    DIM adr as integer
    
    adr = FUNCTIONS_WERT( 58, KARTE , KARTENTYP)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_RD( ADRD, adr )
      SYNCSTAT = peek(DLX) AND 1
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '***************************************************************
  ' commands for processor module 
  '***************************************************************
  '***************************************************************
  ' activate watchdog 
  '***************************************************************
  SUB StartWatchDog()
    SUB_BEGIN_CRITICAL_SECTION
      poke(watchdog,1)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' deactivate watchdog
  '***************************************************************
  SUB StopWatchDog()
    SUB_BEGIN_CRITICAL_SECTION
      poke(watchdog,0)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '***************************************************************
  ' reset the watchdog timer 
  ' If the watchdog is activated, the user program has to call  
  ' this function at least every 80ms.
  ' For ADSP processor modules produced in year 2000 or later 
  ' the minimum time interval is 1600 ms.
  '***************************************************************
  SUB ResetWatchDogTimer()
    SUB_BEGIN_CRITICAL_SECTION
      poke(WD_TIMER,1)
      nop_t9
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '-----------------Thermocouple
  '***********************************************
  ' Setting the thermocouple multipexer
  '       card  : dip switch address 
  '       channel: multiplexer channel
  '***********************************************
  SUB TC_SELECT(card,channel)
    DIM adr,adcnr as integer
    
    adr = 0D0H OR (SHIFT_LEFT(card,8))
                
    SUB_BEGIN_CRITICAL_SECTION
      poke (ADWR, adr)
      nop_t9
      poke_nop (DLX, channel-1) 
    SUB_END_CRITICAL_SECTION
  ENDSUB

        
  '-------------------serial interface
  '***********************************************
  ' Setting a register of the seriell controller
  '       card  : dip switch address 
  '       register_no: register on the serial controller
  '     value : value for the selected register
  '***********************************************
  sub set_rs(card,register_no,value)
    dim adr as integer
    
    adr = (0c0h + register_no) or (shift_left(card, 8))
    SUB_BEGIN_CRITICAL_SECTION
      poke (adwr, adr)
      nop_t9
      poke_nop (dlx, value) 
    SUB_END_CRITICAL_SECTION
  endsub

        
  '***********************************************
  ' reads the value of a register of the serial controller
  '       card  : dip switch address 
  '       register_no: register on the serial controller
  '**********************************************
  FUNCTION get_rs(card, register_no) AS INTEGER
    DIM adr as integer
    
    adr = (0c0h + register_no) or (shift_left(card,8))
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(adrd, adr)
      get_rs = peek(DLX)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION

        
  '******************************************************************
  'Initialisation of a serial interface
  'List of parameters:
  'card : dip switch address
  'channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
  'Baudrate: Baudrate for the serial comunication
  'parity :     0 = no parity
  '             1 = even 
  '             2 = odd 
  'word_length: Number of databits for the serial comunication
  'stop_bits:   0 = 1 Stopbit
  '             1 = 1,5 Stopbits by using 5 Databits
  '             1 = 2 Stopbits bei 6,7 by using 8 Databits
  'handshake:   0 = RS-232 no handshake
  '             1 = RS-232 Hardware handshake (RTS/CTS)
  '             2 = RS-232 Software handshake (Xon/Xoff)
  '             3 = RS-485 no handshake
  '******************************************************************
  sub rs_init(card,channel,Baud_rate,parity,word_length,stop_bits,handshake)
    dim hard_adr as integer                                                 ' phyisical address of the ADwin module (basic address)
    dim offset as integer                                           ' offset for the selected serial interface
    dim divisor as long                                                     ' value by which the external clock has to be divided to get the selected baudrate
    dim DLL_value as integer                                                ' value for the DLL register
    dim DLH_value as integer                                                ' value for the DLH register
    dim LCR_value as integer                                        ' value for the LCR register
    
    offset = ((channel - 1) and 1) * 8
    if (channel >= 3) then                                                  ' for ADwin-PRO modules with more the 2 serial interfaces
      hard_adr = card + 1                                                   ' The hardware address for the serial interfaces 3 and 4 is dip switch + 1 
    else
      hard_adr = card                                               ' The hardware address for the serial interfaces 3 and 4 is dip switch
    endif
    divisor = (36864000/1) / (Baud_rate*16)                         ' calculates the the divider for the external clock
    DLL_value = divisor and 0ffh                                            ' value for the DLL register
    DLH_value = shift_right((divisor and 0ff00h),8)                 ' value for the DLH register
    
    LCR_value = word_length - 5 
    LCR_value = LCR_value or shift_left(stop_bits,2)    
    if (parity = 1) then LCR_value = LCR_value or 011000b
    if (parity = 2) then LCR_value = LCR_value or 001000b           'value for the LCR register

    set_rs(hard_adr, offset + 3, 080h)                    ' LCR-bit7=1    Divisor latch enable
    set_rs(hard_adr, offset + 0, DLL_value)                       ' DLL-reg               setting baudrate
    set_rs(hard_adr, offset + 1, DLH_value)                       ' DLH-reg               setting baudrate
    set_rs(hard_adr, offset + 3,  (0bfh))                         ' LCR-reg               Enhanced feature reg enable
    set_rs(hard_adr, offset + 4,  011h)                           ' setting character for softwarehandshake Xon1     
    set_rs(hard_adr, offset + 5,  012h)                           ' setting character for softwarehandshake Xon2
    set_rs(hard_adr, offset + 6,  013h)                           ' setting character for softwarehandshake Xoff1
    set_rs(hard_adr, offset + 7,  014h)                           ' setting character for softwarehandshake Xoff2
    if (handshake = 0) then 
      set_rs(hard_adr, offset + 2, 010h)                  ' EFR-reg               no handshake(RS232) + enhanced functions enabeld
    endif
    if (handshake = 1) then
      set_rs(hard_adr, offset + 2, 0d0h)                  ' EFR-reg               hardwarehandshake(RS232) + enhanced functions enabeld
    endif
    if (handshake = 2) then
      set_rs(hard_adr, offset + 2, 01ah)                  ' EFR-reg               softwarehandshake(RS232) (Xon1/Xoff1) + enhanced functions enabeld
    endif
    if (handshake = 3) then
      set_rs(hard_adr, offset + 2, 090h)                  ' EFR-reg               no handshake (RS485) + enhanced functions enabeld
    endif
    set_rs(hard_adr, offset + 3,  LCR_value)              ' LCR-reg               Divisor latch disable; 8 Databits
    set_rs(hard_adr, offset + 4 , 040h)                   ' MCR reg               enable access to TCR and TLR register 
    set_rs(hard_adr, offset + 6 , 087h)                   ' TCR reg               FIFO trigger level
    set_rs(hard_adr, offset + 4 , 04h)                    ' MCR reg               FIFOrdy reg enable; is necessary to get status information of the FIFO
    set_rs(hard_adr, offset + 2, 00fh)                    ' FCR-reg               FIFOs enable, FIFOs clear, DMA Mode1
  endsub

        
  '***************************************************************
  'Reset for the ADwin module (serial interface module)
  'card : dip switch address
  '***************************************************************
  sub rs_reset(card)
    set_rs(card, 23, 1)                             ' reset aktiv
    set_rs(card, 23, 0)                             ' reset not aktiv
  endsub
        
        
  '***************************************************************
  'Writes a byte to the transmit FIFO, if the FIFO is not full
  'card : dip switch address
  'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
  'value : value which should be written to the FIFO
  'return value: 
  'write_fifo : 0 = byte is written
  '             1 = FIFO full
  '***************************************************************
  function write_fifo(card,channel,value) as integer
    dim hard_adr as integer                         ' phyisical address of the ADwin module (basic address)
    dim offset as integer                           ' offset for the selected serial interface
    dim bit as integer
    dim fifo_free as integer                        ' FIFO status
      
    bit=channel
    hard_adr=card
            
    if (channel = 2) then bit = 08h ' select the bit, which indicates the status of the selected FIFO
    if (channel = 3) then bit = 02h
      
    if (channel >= 3) then  hard_adr= hard_adr + 1 
    offset = ((channel - 1) and 1) * 8
    fifo_free = get_rs(hard_adr, 7+offset) and bit
    if (fifo_free  <> 0) then                     ' If the FIFO is not full then the byte is written
      set_rs(hard_adr,offset, value)              ' Writeing byte to transmit FIFO
      write_fifo = 0                              ' return value: byte is written successful to the transmit FIFO
    else 
      write_fifo = 1                              ' return value: Fifo full; byte is not written
    endif
  endfunction
        
        
  '***************************************************************
  'checks if there is any more data to transmit
  'card : dip switch address
  'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
  'return value: 
  'check_shift_reg : 0 = Shift register and transmit hold are empty
  '                1 = Shift register and transmit hold are not empty
  '***************************************************************
  function check_shift_reg(card,channel) as integer
    dim hard_adr as integer                         ' phyisical address of the ADwin module (basic address)
    dim offset as integer                           ' offset for the selected serial interface
    dim ret as integer                              ' return value
    
    offset = ((channel - 1) and 1) * 8
    if (channel >= 3) then 
      hard_adr = card + 1 
    else
      hard_adr = card 
    endif
    ret = get_rs(hard_adr,offset + 5) and 64      ' reading the status byte
    if (ret = 64) then
      check_shift_reg = 0
    else 
      check_shift_reg = 1
    endif
  endfunction
        
        
  '***************************************************************
  'Read byte from the receive FIFO
  'card : dip switch address
  'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
  'return value: 
  'read_fifo : 0 - 255 = value of the received byte
  '            -1 = no bytes in the receive FIFO
  '***************************************************************
  function read_fifo(card,channel) as integer
    dim hard_adr as integer                         ' phyisical address of the ADwin module (basic address)
    dim bit as integer                                
    dim offset as integer                           ' offset for the selected serial interface
    dim fifo_status as integer                      ' FIFO status
  
    offset = ((channel - 1) and 1) * 8
    if (channel >= 3) then 
      hard_adr = card + 1 
    else
      hard_adr = card 
    endif
    fifo_status = get_rs(hard_adr,offset + 5) and 1   
    if (fifo_status <> 0) then                    ' read byte, if there is a byte in the receive FIFO
      read_fifo = get_rs(hard_adr,offset) ' read byte from receive FIFO (return value = value of the received byte)
    else
      read_fifo = -1                              ' no new byte in the receive FIFO (return value = -1)
    endif
  endfunction

        
  '***************************************************************
  'Only for RS485.
  'Selects whether the interface is sending data or is listening on the bus.
  'card : dip switch address
  'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
  'value :        0 = Listening
  '           1 = Sending Data
  '           2 = Sending Data + Listening
  '***************************************************************
  sub rs485_send(card,channel,value)
    dim hard_adr as integer                         ' physical address of the ADwin module (basic address)
    dim offset as integer                           ' offset for the selected serial interface
    dim reg_value as integer

    if (value = 0) then reg_value = 5
    if (value = 1) then reg_value = 6
    if (value = 2) then reg_value = 7
    offset = ((channel - 1) and 1) * 8
    if (channel >= 3) then 
      hard_adr = card + 1 
    else
      hard_adr = card 
    endif
    set_rs(hard_adr,offset + 4,reg_value) 'setting the RTS-Pin
  endsub

        
  '------------------CAN
  
  '***************************************************************
  'Enables a message object for receiving messages.
  'Disables all interrups of the message object.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
  'objectnumber : Number of the message object
  'Identifier : incomming frames are accepted by this message object, if the identifier matches the frame identifier
  'extended: Determines whether the identifier is 11 or 29 Bit
  '            0 = 11 Bit Identifier      
  '            1 = 29 Bit Identifier      
  '***************************************************************
  sub en_receive(card,channel,objectnumber,identifier,extended)
    set_can_reg(card,channel, objectnumber * 16, 149)                                                   'enable message object
    if (extended = 0) then 
      set_can_reg(card,channel, objectnumber * 16 + 6, 128)                                             'read; DLC = 8 ; 11 Bit Identifier
      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,3)and 255))  'Set Identifier
      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
    else
      set_can_reg(card,channel, objectnumber * 16 + 6, 132)                                             'read; DLC = 8 ; 29 Bit Identifier
      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,21)and 255))     'Set Identifier
      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
      set_can_reg(card,channel, objectnumber * 16 + 4, (shift_right(identifier,5)and 255))  
      set_can_reg(card,channel, objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
    endif
  endsub
        
        
  '***************************************************************
  'Enables a message object for transmitting messages.
  'Disables all interrups of the message object.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
  'objectnumber : Number of the message object
  'Identifier : identifier for the frames which will be transmitted
  'extended: Determines whether the identifier is 11 or 29 Bit 
  '            0 = 11 Bit Identifier      
  '            1 = 29 Bit Identifier      
  '***************************************************************
  sub en_transmit(card,channel,objectnumber,identifier,extended)
    set_can_reg(card,channel, objectnumber * 16, 149)                                                   'enable message object
    if (extended = 0) then 
      set_can_reg(card,channel, objectnumber * 16 + 6, 136)                                             'write; DLC = 8 ; 11 Bit Identifier
      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,3)and 255))      'Set Identifier
      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
    else
      set_can_reg(card,channel, objectnumber * 16 + 6, 140)                                             'write; DLC = 8 ; 29 Bit Identifier
      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,21)and 255))     'Set Identifier
      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
      set_can_reg(card,channel, objectnumber * 16 + 4, (shift_right(identifier,5)and 255))      
      set_can_reg(card,channel, objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
    endif
  endsub
        
          
  '***************************************************************
  'Initialisation of the CAN-controller.
  'All message objects will be disabled.
  'Bitrat: 1MBit/s
  'Acceptance filter : Must match
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
  '***************************************************************
  sub init_can(card,channel)
    dim counter as integer
    dim adr1 as integer
    
    adr1 = 0c0h or (shift_left(card, 8)) or (38 + channel)
    SUB_BEGIN_CRITICAL_SECTION
      poke(adwr, adr1)                                       ' Reset the CAN-Controllers (Hardwarereset)
      nop_t9
      poke_nop(dlx, 1)
    SUB_END_CRITICAL_SECTION
    P1_sleep(100000) 'Resetpin must be low for at least 1 ms
    
    SUB_BEGIN_CRITICAL_SECTION
      poke(adwr, adr1)
      nop_t9
      poke_nop(dlx, 0)
    SUB_END_CRITICAL_SECTION       
            
    set_can_reg(card,channel, 0,65)                               'Access to the registers of the controller only for CPU
    set_can_reg(card,channel, 2,65)                               'CPU interface register
    set_can_reg(card,channel, 06h,0ffh)                   'Setting all masks to "must match"
    set_can_reg(card,channel, 07h,0ffh)
    set_can_reg(card,channel, 08h,0ffh)
    set_can_reg(card,channel, 09h,0ffh)
    set_can_reg(card,channel, 0ah,0ffh)
    set_can_reg(card,channel, 0bh,0ffh)
    set_can_reg(card,channel, 0ch,0ffh)
    set_can_reg(card,channel, 0dh,0ffh)
    set_can_reg(card,channel, 0eh,0ffh)
    set_can_reg(card,channel, 0fh,0ffh)
    set_can_reg(card,channel, 01fh,0)                   ' Clock Out Register
    set_can_reg(card,channel, 02fh,0)                   '  Bus configuration register
    set_can_reg(card,channel, 03fh,0)                   ' Bit Timing register 0  
    set_can_reg(card,channel, 04fh,032h)                        ' Bit Timing register 1 
    
    for counter = 1 to 15                                 'Disable all message objects
      set_can_reg(card,channel, counter * 16,85)
      set_can_reg(card,channel, counter * 16 + 1,85)
    next counter 
    set_can_reg(card,channel, 0,0)                              'Access to the registers of the controller only for Application 
  endsub
         
        
  '***************************************************************
  'The function checks, if there is a new frame in the selected
  'message object. If there is a new frame all databytes are read
  'and then written to the array "can_msg".
  'The number of dadabytes is written to the element 9 of the array "can_msg".
  'The return value of the function is the identifier of the frame. 
  'If there is no new frame in the message box the return value is -1.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
  'msg_nummer : number of the message object
  '***************************************************************
  function read_msg(card,channel,msg_number) as integer
    dim new as integer                                           ' new message in the message object
    dim id0,id1,id2,id3 as integer                               ' Identifier Byte 0 and 1
    dim counter as integer                                         
    dim buffer as integer                                                    
    dim id_lenght as integer                                                 ' buffer to distinguish 11 and 29 bit identifier
  
    new = get_can_reg(card,channel, msg_number * 16 + 1) and 3           ' Check, if a new frame in arrived
    if (new =2) then                                               ' New frame is arrived
      buffer = (get_can_reg(card,channel, msg_number * 16 + 6))
      can_msg[9] = shift_right((buffer and 0f0h),4)               ' Number of databytes
      id_lenght = buffer and 4
      id0 = get_can_reg(card,channel, msg_number * 16 + 2)                ' Identifier registers
      id1 = get_can_reg(card,channel, msg_number * 16 + 3)
      if (id_lenght = 4) then
        id2 = get_can_reg(card,channel, msg_number * 16 + 4)              
        id3 = get_can_reg(card,channel, msg_number * 16 + 5)
      endif
  
      for counter = 1 to can_msg[9]                                       ' reading databytes
        can_msg[counter] = get_can_reg(card,channel, (msg_number * 16) +counter+6)
      next counter
  
      set_can_reg(card,channel, msg_number * 16 , 0fdh)                           ' Reset the new data flag
      set_can_reg(card,channel, msg_number * 16 +1 , 85) 
      if (id_lenght = 0) then
        read_msg = (shift_right(id1,5)) or (shift_left(id0,3))        ' return value = 11 bit identifier
      else
        read_msg = (shift_right(id3,3)) or (shift_left(id2,5)) or (shift_left(id1,13)) or (shift_left(id0,21))        ' return value = 29 bit identifier
      endif
    else
      read_msg = -1                                                  ' return value = 0
    endif
  endfunction
        
     
  '***************************************************************
  'Transmitting a frame. 
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
  'msg_nummer : number of the message object
  'The databytes and the number of databytes have to be written in the
  'array "can_msg" before this subroutine is activated.
  'After this subroutine the frame is transmitted as soon as the 
  'CAN-bus allows it.
  '***************************************************************
  sub transmit(card,channel,msg_num)
    dim merker as integer
    dim counter as integer
  
    for counter = 1 to can_msg[9]
      set_can_reg(card,channel, (msg_num * 10h)+counter+6,can_msg[counter])       'copy datas
    next counter
   
    ' Anzahl der Datenbytes bergeben
    merker = get_can_reg(card,channel, (msg_num * 10h)+6)         'read register
    merker = merker and 0fh                               'change DLC Bits 
    merker = merker or shift_left(can_msg[9],4)
    set_can_reg(card,channel, msg_num *16 +6,merker)              'write register
    set_can_reg(card,channel, msg_num * 16 +1, 102)                       ' Control register (setting bit to transmit data)
  ENDSUB
        
        
  '***************************************************************
  'Enable the interrupt of a message object.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module
  '          (also necessary if the module provides only one channel)
  'msg_nummer : number of the message object
  '***************************************************************
  sub en_interrupt(card,channel,msg_num)
    set_can_reg(card,channel, msg_num * 16, 0ebh)         'Enable interrupt of the message object.
    set_can_reg(card,channel, 0, 02h)                     'Enable global interrupt.
  endsub
        
        
  '***************************************************************
  'Setting a register of the CAN-controller.
  'card : dip switch address
  'register_no : register which should be set
  'value : value which should be written to the register.
  '***************************************************************
  sub set_can_reg(card,channel,register_no, value)   
  dim adr1 as integer  
  dim adr2 as integer  
    adr1 = 0c0h or (shift_left(card, 8)) or ((channel-1)*8)
    adr2 = adr1 or (1+((channel-1)*8))
  
    SUB_BEGIN_CRITICAL_SECTION
      poke(adwr ,adr2)
      nop_t9
      poke_nop(dlx ,register_no)
      poke(adwr ,adr1)
      nop_t9
      poke_nop(dlx ,value)
    SUB_END_CRITICAL_SECTION
  endsub
        
        
  '***************************************************************
  'Reading a register of the CAN-controller.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module
  '          (also necessary if the module provides only one channel)
  'register_no : register to read
  'return value : value of the register
  '***************************************************************
  Function get_can_reg(card,channel,register_no) as integer
    dim adr1 as integer  
    dim adr2 as integer  

    adr1 = 0c0h or (shift_left(card, 8)) or ((channel-1)*8)
    adr2 = adr1 or (2+((channel-1)*8))
            
    SUB_BEGIN_CRITICAL_SECTION
      poke(adwr ,adr2)
      nop_t9
      poke_nop(dlx ,register_no)
      bus_sleep(60) 
      poke_nop_rd(adrd ,adr1)
      get_can_reg = peek(dlx) and 255
    SUB_END_CRITICAL_SECTION
  endfunction
        
        
  '***************************************************************
  'Reading the register where the bus error pin of the tranceiver
  'is sored.
  'The register is set when the a bus error occurs and is reset by 
  'reading the register.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module
  '          (also necessary if the module provides only one channel)
  'return value : 0 = no error
  '               1 = error
  'Attention: This command is only for low-speed CAN
  '***************************************************************
  Function get_line_status(card,channel) as long
    dim adr as long
   
    adr =  0c0h or shift_left(card, 8) or (3Dh - channel)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop_rd(ADRD, adr)
      get_line_status = peek(DLX)
    SUB_END_CRITICAL_SECTION                                
  endfunction
  
        
  '***************************************************************
  'Function only for internal use.
  '***************************************************************
  function round(value) as long
    dim buffer as float
    
    buffer = value + 0.5
    round = buffer
  endfunction
  
        
  '***************************************************************
  'Function only for internal use.
  '***************************************************************
  function int_check(fl,int) as long
    dim fbuffer as float
  
    fbuffer = fl-int
    if ((fbuffer >= 0.00001) or (fbuffer <= -0.00001)) then 
      int_check = 1                               'not equal
    else
      int_check = 0                               'equal
    endif
  endfunction
        
         
  '***************************************************************
  'Function is setting the baudrate of the CAN-Bus.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module
  '          (also necessary if the module provides only one channel)
  'rate : CAN-Bus baudrate
  'return value : 0 = baudrate is set 
  '                   1 = the selected baudrate is not set 
  '***************************************************************
  function set_can_baudrate(card,channel,rate) as long
    dim scale as long
    dim fbuffer as float
    dim lbuffer as long
    dim back as long
    dim tseg1 as long  
    dim tseg2 as long  
    dim brp as long  
    dim btr0 as long  
    dim btr1 as long  

    set_can_baudrate = 0                                  'Initialisation
    fbuffer = 8000000 / rate
    scale = round(fbuffer)                                'total scale to achive the baudrate
    set_can_baudrate = int_check(fbuffer,scale)   '1 if baudrate not possible
    if (set_can_baudrate = 0) then                        'If baudrate possible then find settings
      brp = (scale - 1) / 25                              'Prescaler
      do                                                  'find the right brp
        fbuffer = (scale / (brp + 1) - 3)
        lbuffer = round(fbuffer)
        back = int_check(fbuffer,lbuffer)         'inc prescaler until tseg1 + tseg 2 is an integer
        inc(brp)
      until((back = 0) or (fbuffer<5)) 
      dec(brp)
      if (back <> 0) then set_can_baudrate = 1
    endif
  
    if (set_can_baudrate = 0) then                        'If there is a correct prescaler
      tseg2 = lbuffer * 0.4
      tseg1 = lbuffer - tseg2
      if (tseg2 > 7) then
        do
          dec(tseg2)
          inc(tseg1)
        until(tseg2 = 7)
      endif 
      btr0 = brp                                          'Synchronization jump width = 1 (bits = 0)
      btr1 = tseg1 + shift_left(tseg2,4)          'one sampling each Bit
      set_can_reg(card,channel,0,65)                      'enable access to btr regisers
      set_can_reg(card,channel,3fh,btr0)          'set btr0 regisers
      set_can_reg(card,channel,4fh,btr1)          'set btr1 regisers
      set_can_reg(card,channel,0,0)                       'disable access to btr regisers
    endif
  endfunction
        
        
  '-------------------Anybus
  '*****************************************************************
  'Getting a byte from the DPRAM of a profibus-DP master or slave
  '       card  : dip switch address 
  '       bytenumber: number of the byte on the DPRAM
  '*****************************************************************
  function get_pro_byte(card,bytenumber) as long
    dim adr as long
  
    adr = 80c0h or shift_left(card,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63) 
    SUB_BEGIN_CRITICAL_SECTION          
      poke_nop_rd(adrd, adr)
      get_pro_byte=peek(dlx) 
    SUB_END_CRITICAL_SECTION
  endfunction

        
  '*****************************************************************
  'Setting a byte in the DPRAM of a profibus-DP master or slave
  '       card  : dip switch address 
  '       bytenumber: number of the byte on the DPRAM
  '     value : value for the selected byte
  '*****************************************************************
  sub set_pro_byte(card,bytenumber,value)
    dim adr as long
    
    adr = 80c0h or shift_left(card,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63) 
    SUB_BEGIN_CRITICAL_SECTION  
      poke(adwr, adr) 
      nop_t9
      poke_nop(dlx, value) 
    SUB_END_CRITICAL_SECTION
  endsub
        
        
  '*****************************************************************
  'Hardware reset on the HMS Module
  '       card  : dip switch address 
  '*****************************************************************
  sub Hardware_reset(card)
    dim adr as long
    
    adr = 0c0h or (shift_left(card, 8)) or 39
    SUB_BEGIN_CRITICAL_SECTION
      poke(adwr, adr) 
      nop_t9
      poke_nop(dlx, 1) 
    SUB_END_CRITICAL_SECTION                
    P1_sleep(500)  'Reset signal must be low for at least 5s
                                                                          
    SUB_BEGIN_CRITICAL_SECTION
      poke(adwr, adr) 
      nop_t9
      poke_nop(dlx, 0) 
    SUB_END_CRITICAL_SECTION                  
    P1_sleep(30000000)                                              'Wait until the module has finished his internal initialisation
  endsub
        
        
        
  'Slave
  '********************************************************
  'This function is for mailbox handling. When the in mailbox
  'is set the mail is sent with this command.
  '********************************************************
  sub send_mail(card)
    dim buffer as long
    
    buffer = get_pro_byte(card,app_ind)
    set_pro_byte(card,app_ind,buffer xor 80h)
  endsub
        
        
  '********************************************************
  'This function is for mailbox handling. If the in mailbox
  'is free to handle a new mailbox communication the return
  'value is 0 else the return value is 1.
  '********************************************************
  function check_inbox_free(card) as long
    dim buffer1 as long
    dim buffer2 as long

    buffer1 = get_pro_byte(card,app_ind) and 080h
    buffer2 = get_pro_byte(card,any_ind) and 080h
    if (buffer1 = buffer2) then
      check_inbox_free = 0
    else
      check_inbox_free = 1
    endif
  endfunction

        
  '********************************************************
  'This function is for mailbox handling. Checks if new
  'data is in the out mailbox. If there is new data the 
  'return value is 0, else the return value is 1.
  '********************************************************
  function check_outbox_full(card) as long
    dim buffer1 as long
    dim buffer2 as long
    
    buffer1 = get_pro_byte(card,app_ind) and 040h
    buffer2 = get_pro_byte(card,any_ind) and 040h
    if (buffer1 = buffer2) then
      check_outbox_full = 1
    else
      check_outbox_full = 0
    endif
  endfunction
    
        
  '********************************************************
  'This function is for mailbox handling. The function is 
  'waiting until the in mailbox is free to handle a new
  'mailbox communication. The return value is 0 when the
  'waiting was successful, else the return value is 08000h.
  '********************************************************
  function wait_inbox_free(card) as long
    dim buffer1 as long
    dim counter as long
    
    counter = 0
    do
      inc counter
      buffer1 = check_inbox_free(card)
    until((counter > 10000000) or (buffer1 = 0))
    if (counter > 10000000) then
      wait_inbox_free = 08000h                                    'mail failed
    else
      wait_inbox_free = 0                                         'mail sended
    endif
  endfunction
  
        
  '********************************************************
  'This function is for mailbox handling. The function is 
  'waiting until the out mailbox is full to handle a new
  'mailbox communication. The return value is 0 when the
  'waiting was successful, else the return value is 04000h.
  '********************************************************
  function wait_outbox_full(card) as long
    dim buffer1 as long
    dim counter as long
  
    counter = 0
    do
      inc counter
      buffer1 = check_outbox_full(card)
    until((counter > 10000000) or (buffer1 = 0))
    if (counter > 10000000) then
      wait_outbox_full = 04000h                                   'mail failed
    else
      wait_outbox_full = 0                                        'mail sended
    endif
  endfunction
        
  '********************************************************
  'This procedure is for mailbox handling. If a new mail 
  'is in out mailbox and is read. This command gives an
  'ACK. The next message can be received now.
  '********************************************************
  sub ack_mail(card)
    dim buffer1 as long
    dim buffer2 as long

    buffer1 = get_pro_byte(card,any_ind) and 040h
    buffer2 = ((get_pro_byte(card,app_ind) and 0bfh) or buffer1)
    set_pro_byte(card,app_ind,buffer2)
  endsub
        
  '********************************************************
  'This procedure is for initialisation of the anybus module 
  'via mailbox. The in mailbox is set to start the 
  'initialisation.
  '********************************************************
  sub set_mailbox_start_init(card)
    set_pro_byte(card,mail_in_0,000h)
    set_pro_byte(card,mail_in_1,001h)
    set_pro_byte(card,mail_in_2,040h)
    set_pro_byte(card,mail_in_3,001h)
    set_pro_byte(card,mail_in_4,000h)
    set_pro_byte(card,mail_in_5,001h)
    set_pro_byte(card,mail_in_6,000h)
    set_pro_byte(card,mail_in_7,000h)
    set_pro_byte(card,mail_in_8,000h)
    set_pro_byte(card,mail_in_9,001h)
    set_pro_byte(card,mail_in_a,000h)
    set_pro_byte(card,mail_in_b,001h)
    set_pro_byte(card,mail_in_c,000h)
    set_pro_byte(card,mail_in_d,000h)
    set_pro_byte(card,mail_in_e,000h)
    set_pro_byte(card,mail_in_f,000h)
  endsub
        

  '********************************************************
  'This procedure is for initialisation of the anybus module 
  'via mailbox. The in mailbox is set to terminate the 
  'initialisation.
  '********************************************************
  sub set_mailbox_end_init(card)
    set_pro_byte(card,mail_in_0,000h)
    set_pro_byte(card,mail_in_1,001h)
    set_pro_byte(card,mail_in_2,040h)
    set_pro_byte(card,mail_in_3,001h)
    set_pro_byte(card,mail_in_4,000h)
    set_pro_byte(card,mail_in_5,003h)
    set_pro_byte(card,mail_in_6,000h)
    set_pro_byte(card,mail_in_7,000h)
    set_pro_byte(card,mail_in_8,000h)
    set_pro_byte(card,mail_in_9,001h)
    set_pro_byte(card,mail_in_a,000h)
    set_pro_byte(card,mail_in_b,001h)
    set_pro_byte(card,mail_in_c,000h)
    set_pro_byte(card,mail_in_d,000h)
    set_pro_byte(card,mail_in_e,000h)
    set_pro_byte(card,mail_in_f,000h)
  endsub

        
  '********************************************************
  'This procedure is for initialisation of the anybus module 
  'via mailbox. The in mailbox is set to check the bus  
  'specific hardware.
  '********************************************************
  sub set_mailbox_hw_chk(card)
    set_pro_byte(card,mail_in_0,000h)
    set_pro_byte(card,mail_in_1,001h)
    set_pro_byte(card,mail_in_2,040h)
    set_pro_byte(card,mail_in_3,001h)
    set_pro_byte(card,mail_in_4,000h)
    set_pro_byte(card,mail_in_5,006h)
    set_pro_byte(card,mail_in_6,000h)
    set_pro_byte(card,mail_in_7,000h)
    set_pro_byte(card,mail_in_8,000h)
    set_pro_byte(card,mail_in_9,001h)
    set_pro_byte(card,mail_in_a,000h)
    set_pro_byte(card,mail_in_b,001h)
    set_pro_byte(card,mail_in_c,000h)
    set_pro_byte(card,mail_in_d,000h)
    set_pro_byte(card,mail_in_e,000h)
    set_pro_byte(card,mail_in_f,000h)
  endsub

        
  '********************************************************
  'This procedure is for initialisation of the anybus module 
  'via mailbox. The in mailbox is set to configure the 
  'module according to the user defined values.
  '********************************************************
  sub set_mailbox_anybus_init(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt)
    dim space_in, space_out as long
    dim io_in_low,io_in_high,io_out_low,io_out_high,space_in_low,space_in_high,space_out_low,space_out_high as long

    space_in = IO_in + par_in 
    space_out = IO_out + par_out
    io_in_low = io_in and 0ffh
    io_in_high = shift_right(io_in,8) and 0ffh
    io_out_low = io_out and 0ffh
    io_out_high = shift_right(io_out,8) and 0ffh
    space_in_low = space_in and 0ffh
    space_in_high = shift_right(space_in,8) and 0ffh
    space_out_low = space_out and 0ffh
    space_out_high = shift_right(space_out,8) and 0ffh
  
    set_pro_byte(card,mail_in_0,000h)
    set_pro_byte(card,mail_in_1,00ah)
    set_pro_byte(card,mail_in_2,040h)
    set_pro_byte(card,mail_in_3,001h)
    set_pro_byte(card,mail_in_4,000h)
    set_pro_byte(card,mail_in_5,002h)
    set_pro_byte(card,mail_in_6,000h)
    set_pro_byte(card,mail_in_7,012h)
    set_pro_byte(card,mail_in_8,000h)
    set_pro_byte(card,mail_in_9,001h)
    set_pro_byte(card,mail_in_a,000h)
    set_pro_byte(card,mail_in_b,001h)
    set_pro_byte(card,mail_in_c,000h)
    set_pro_byte(card,mail_in_d,000h)
    set_pro_byte(card,mail_in_e,000h)
    set_pro_byte(card,mail_in_f,000h)
  
    set_pro_byte(card,0420h,io_in_high)
    set_pro_byte(card,0421h,io_in_low)
    set_pro_byte(card,0422h,space_in_high)
    set_pro_byte(card,0423h,space_in_low)
    set_pro_byte(card,0424h,space_in_high)
    set_pro_byte(card,0425h,space_in_low)
    set_pro_byte(card,0426h,io_out_high)
    set_pro_byte(card,0427h,io_out_low)
    set_pro_byte(card,0428h,space_out_high)
    set_pro_byte(card,0429h,space_out_low)
    set_pro_byte(card,042ah,space_out_high)
    set_pro_byte(card,042bh,space_out_low)
    set_pro_byte(card,042ch,input_handling)
    set_pro_byte(card,042dh,output_handling)
    set_pro_byte(card,042eh,000h)
    set_pro_byte(card,042fh,interrupt)
  endsub

        
  '********************************************************
  'This function checks, if the responding mail to the 
  'start_init mail is ok. If ok return value is 0, else
  'return value is 2.
  '********************************************************
  function check_mailbox_start_init(card) as long
    check_mailbox_start_init = 0
    if (get_pro_byte(card,mail_out_1) <> 01h) then check_mailbox_start_init = 2
    if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_start_init = 2
    if (get_pro_byte(card,mail_out_5) <> 01h) then check_mailbox_start_init = 2
    if (get_pro_byte(card,mail_out_7) <> 00h) then check_mailbox_start_init = 2
    if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_start_init = 2
    if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_start_init = 2
    if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_start_init = 2
    if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_start_init = 2
  endfunction

        
  '********************************************************
  'This function checks, if the responding mail to the 
  'end_init mail is ok. If ok return value is 0, else
  'return value is 080h.
  '********************************************************
  function check_mailbox_end_init(card) as long
    check_mailbox_end_init = 0
    if (get_pro_byte(card,mail_out_1) <> 01h) then check_mailbox_end_init = 080h
    if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_end_init = 080h
    if (get_pro_byte(card,mail_out_5) <> 03h) then check_mailbox_end_init = 080h
    if (get_pro_byte(card,mail_out_7) <> 00h) then check_mailbox_end_init = 080h
    if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_end_init = 080h
    if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_end_init = 080h
    if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_end_init = 080h
    if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_end_init = 080h
  endfunction

        
  '********************************************************
  'This function checks, if the responding mail to the 
  'anybus_init mail is ok. If ok return value is 0, else
  'return value is 4.
  '********************************************************
  function check_mailbox_anybus_init(card) as long
    check_mailbox_anybus_init = 0
    if (get_pro_byte(card,mail_out_1) <> 0ah) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,mail_out_5) <> 02h) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,mail_out_7) <> 012h) then check_mailbox_anybus_init =4
    if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,053eh) <> 00h) then check_mailbox_anybus_init = 4
    if (get_pro_byte(card,053fh) <> 00h) then check_mailbox_anybus_init = 4
  endfunction

        
  '********************************************************
  'This function checks, if the responding mail to the 
  'hw_chk mail is ok. If ok return value is 0 else
  'return value is 1.
  '********************************************************
  function check_mailbox_hw_chk(card) as long
    check_mailbox_hw_chk = 0
    if (get_pro_byte(card,mail_out_1) <> 01h) then check_mailbox_hw_chk = 1
    if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_hw_chk = 1
    if (get_pro_byte(card,mail_out_5) <> 06h) then check_mailbox_hw_chk = 1
    if (get_pro_byte(card,mail_out_7) <> 00h) then check_mailbox_hw_chk = 1
    if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_hw_chk = 1
    if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_hw_chk = 1
    if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_hw_chk = 1
    if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_hw_chk = 1
  endfunction
        
        
  '********************************************************
  'This function checks, if the DPRAM is ok.
  'If ok return value is 0, else return value is 040h.
  'The elements of the watchdog and the handshake are not 
  'checked. This will result in errors.
  '********************************************************
  function dpram_test(card) as long
    dim counter as long
    dim byte as long
    dim buffer as long

    dpram_test = 0
    for counter = 00h to 07d3h
      byte = get_pro_byte(card,counter)                                   'save value
      set_pro_byte(card,counter,(counter and 0ffh))                       'write new value
      buffer = get_pro_byte(card,counter)                                 'check new value
      set_pro_byte(card,counter,byte)                                             'write back old value
      if (buffer <> (counter and 0ffh)) then dpram_test = 040h    
    next counter
    for counter = 7d6h to 7fdh
      byte = get_pro_byte(card,counter)
      set_pro_byte(card,counter,(counter and 0ffh))
      buffer = get_pro_byte(card,counter)
      set_pro_byte(card,counter,byte)
      if (buffer <> (counter and 0ffh)) then dpram_test = 040h
    next counter
  endfunction

        
  '************************************************************************
  'Function to initialize an anybus module.
  'Attention: This function can only be used after power up.
  'Attention: This function can only be used in a low init part.
  '               Do not use in a high priority process.
  'Attention: input and output size must be equal. (INTERBUS)
  'card : dip switch address
  'IO_in:         number of input bytes for fast data exchange
  'par_in:                number of input bytes for parameter data exchange
  'IO_out:                number of output bytes for fast data exchange
  'par_out:               number of output bytes for parameter data exchange
  'input_handling:        bit0:   0 = input area cleared on application stopped
  '                               1 = input area freezed on application stopped
  '                       bit1:   0 = changed data field not activated
  '                               1 = changed data field activated
  'output_handling:       bit0:   0 = Fieldbus OFF-line
  '                               1 = Fieldbus ON-line
  '                       bit1:   0 = output area cleared on fieldbus stopped
  '                               1 = output area freezed on fieldbus stopped
  'interrupt:             bit0:   0 = no interrupt on data changed 
  '                               1 = interrupt on data changed
  '                       bit1:   0 = no interrupt Fieldbus OFF-line
  '                               1 = interrupt Fieldbus OFF-line
  '                       bit2:   0 = no interrupt Fieldbus ON-line
  '                               1 = interrupt Fieldbus ON-line
  'return value:  0 = no error; initialisation OK
  '                       bit1 = 0:       anybus hardware_check failed 
  '                       bit1 = 1:       mailbox start_init failed 
  '                       bit1 = 2:       mailbox anybus_init failed 
  '                       bit1 = 3:       reseved for further use 
  '                       bit1 = 4:       reseved for further use  
  '                       bit1 = 5:       reseved for further use  
  '                       bit1 = 6:       dpram check failed  
  '                       bit1 = 7:       mailbox end_init failed 
  '                       bit1 = 8:       reseved for further use  
  '                       bit1 = 9:       reseved for further use  
  '                       bit1 = 10:      reseved for further use  
  '                       bit1 = 11:      reseved for further use  
  '                       bit1 = 12:      reseved for further use  
  '                       bit1 = 13:      reseved for further use  
  '                       bit1 = 14:      mail was not received
  '                       bit1 = 15:      mail was not send 
  '************************************************************************
  function init_slave(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt) as long
    dim buffer as long

    init_slave = 0
    buffer = get_pro_byte(card,07ffh)                     'clear interrupt
    buffer = 0
  
  'DPRAM_check (not via mailbox)
    buffer = dpram_test(card)
    init_slave = init_slave or buffer
  
  'Mailbox operations
  'Hardware_check
    buffer = wait_inbox_free(card)                        'waiting until in mailbox is free
    init_slave = init_slave or buffer
    set_mailbox_hw_chk(card)                              'setting the in mailbox
    send_mail(card)                                               'send mail
    buffer = wait_inbox_free(card)                        'wait until in mail was send
    init_slave = init_slave or buffer
    buffer = wait_outbox_full(card)                       'wait until out mail was received
    init_slave = init_slave or buffer
    buffer = check_mailbox_hw_chk(card)           'check out mail (hw ok)
    init_slave = init_slave or buffer
    ack_mail(card)                                                'acknowledge mail
  
  'start_init
    buffer = wait_inbox_free(card)                        'waiting until in mailbox is free
    init_slave = init_slave or buffer
    set_mailbox_start_init(card)                  'setting in mailbox
    send_mail(card)                                               'send mail
    buffer = wait_inbox_free(card)                        'wait until in mail was send
    init_slave = init_slave or buffer
    buffer = wait_outbox_full(card)                       'wait until out mail was received
    init_slave = init_slave or buffer
    buffer = check_mailbox_start_init(card)               'check out mail (init start ok)
    init_slave = init_slave or buffer
    ack_mail(card)                                                'acknowledge mail
  
  'anybus_init
    buffer = wait_inbox_free(card)                        'waiting until in mailbox is free
    init_slave = init_slave or buffer
    set_mailbox_anybus_init(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt)            'setting the in mailbox
    send_mail(card)                                               'send mail
    buffer = wait_inbox_free(card)                        'wait until in mail was send
    init_slave = init_slave or buffer
    buffer = wait_outbox_full(card)                       'wait until out mail was received
    init_slave = init_slave or buffer
    buffer = check_mailbox_anybus_init(card)      'check out mail (init anybus ok)
    init_slave = init_slave or buffer
    ack_mail(card)                                                'acknowledge mail
  
  'end_init
    buffer = wait_inbox_free(card)                        'waiting until in mailbox is free
    init_slave = init_slave or buffer
    set_mailbox_end_init(card)                            'setting in mailbox
    send_mail(card)                                               'send mail
    buffer = wait_inbox_free(card)                        'wait until in mail was send
    init_slave = init_slave or buffer
    buffer = wait_outbox_full(card)                       'wait until out mail was received
    init_slave = init_slave or buffer
    buffer = check_mailbox_end_init(card)         'check out mail (end init ok)
    init_slave = init_slave or buffer
    ack_mail(card)                                                'acknowledge mail
  endfunction

        
  '******************************************************
  'The function gives the information wether the data in
  'the out area has changen or not. If there is new data
  'the return value is <> 0 else the return value is 0.
  'size:  number of bytes of the out area.
  '******************************************************
  Function changed_data(card,size) as long
    dim loopsize as long
    dim buffer as long
    dim count as long

    changed_data = 0
    loopsize = (size - 1)/8 + 1
    for count = 1 to loopsize
      buffer = get_pro_byte(card,(count + 7E3h))
      changed_data = changed_data or buffer
    next count 
  endfunction
        
        
  '******************************************************
  'Request application access to DPRAM.
  'The DPRAM consists of 3 parts. Each part equals a bit
  'in the parameter array:
  'Bit 0:         Anybus control registers
  'Bit 1:         Output data
  'Bit 2:         Input data
  '******************************************************
  sub request_access(card,array) as long
    dim buffer1 as long

    buffer1 = get_pro_byte(card,app_ind) and 0f8H
    set_pro_byte(card,app_ind,((buffer1 or array) or 010h))
  endsub

        
  '******************************************************
  'Request application access release to DPRAM.
  'The DPRAM consists of 3 parts. Each part equals a bit
  'in the parameter array:
  'Bit 0:         Anybus control registers
  'Bit 1:         Output data
  'Bit 2:         Input data
  '******************************************************
  sub request_release_access(card,array) as long
    dim buffer1 as long

    buffer1 = get_pro_byte(card,app_ind) and 0e8H
    set_pro_byte(card,app_ind,(buffer1 or array))
  endsub
        

  '******************************************************
  'Check access right. If bit is set the application has
  'access right.
  'The DPRAM consists of 3 parts. Each part equals a bit
  'in the parameter array:
  'Bit 0:         Anybus control registers
  'Bit 1:         Output data
  'Bit 2:         Input data
  '******************************************************
  function check_access(card) as long
    check_access = get_pro_byte(card,any_ind) and 07h
  endfunction
        
  '*******************************************************
  'Reads the input data from the DPRAM
  '       card  :         dip switch address 
  '       array :         destination array for input data
  '       start :         first byte (DPRAM)
  '       count :         number of bytes
  '*******************************************************
  sub get_read_buffer(card,array,start,count)
    dim i as long
  
    for i = start to (start + count - 1)
      array[i + 1 - start] = get_pro_byte(card,i)
    next i
  endsub
        
        
  '*******************************************************
  'Writes the output data to the DPRAM
  '       card  :         dip switch address 
  '       array :         source array for input data
  '       start :         first byte (DPRAM)
  '       count :         number of bytes
  '*******************************************************
  sub set_write_buffer(card,array,start,count)
    dim i as long

    for i = start to (start + count - 1)
      set_pro_byte(card,i,array[i+1])
    next i
  endsub
        
  
        
  'Master
  '*******************************************************
  ' Giving access right to DPRAM to device.
  ' Set Pdcom and Pdack unequal.
  ' Data exchange mode 3 and 4.
  '       card  : dip switch address 
  '*******************************************************
  sub pass_access_3(card)
    dim byte as long                                                
    dim flag as long

    byte = (get_pro_byte(card,control_to_host) and 04h) xor 4
    flag = (get_pro_byte(card,control_to_device) and 0bh) 
    byte = flag or byte
    set_pro_byte(card,control_to_device,byte)
  endsub
        
        
  '*******************************************************
  ' Giving access right to DPRAM to device.
  ' Set Pdcom and Pdack equal.
  ' Data exchange mode 0 and 1.
  '       card  : dip switch address 
  '*******************************************************
  sub pass_access_0(card)
    dim byte as long                                
    dim flag as long
  
    byte = (get_pro_byte(card,control_to_host) and 04h)
    flag = (get_pro_byte(card,control_to_device) and 0bh) 
    byte = flag or byte
    set_pro_byte(card,control_to_device,byte)
  endsub
        
        
  '*******************************************************
  ' communication via mailbox
  ' slave diagnostic
  '       card  : dip switch address 
  '       number: unique message number 
  '       slave : ID of the selected slave 
  '*******************************************************
  sub slave_diagnostic(card,number,slave)
    set_pro_byte(card,out_mailbox_0,3)
    set_pro_byte(card,out_mailbox_1,16)
    set_pro_byte(card,out_mailbox_2,8)
    set_pro_byte(card,out_mailbox_3,number)
    set_pro_byte(card,out_mailbox_4,0)  
    set_pro_byte(card,out_mailbox_5,0)
    set_pro_byte(card,out_mailbox_6,66)
    set_pro_byte(card,out_mailbox_7,0)
    set_pro_byte(card,out_mailbox_8,slave)
    set_pro_byte(card,out_mailbox_9,0)
    set_pro_byte(card,out_mailbox_a,0)
    set_pro_byte(card,out_mailbox_b,0)
    set_pro_byte(card,out_mailbox_c,0)
    set_pro_byte(card,out_mailbox_d,32)
    set_pro_byte(card,out_mailbox_e,5)
    set_pro_byte(card,out_mailbox_f,1)
  endsub
        
        
        
  '*******************************************************
  ' communication via mailbox
  ' global control
  '       card  : dip switch address 
  '       number: unique number
  '       slave : 127 = all selected slaves (selected by group)
  '                       0 - 126 = only one slave (slavenumber)
  '       command:        20h = sync
  '                       10h = unsync
  '                       08h = freeze
  '                       04h = unfreeze
  '                       02h = clear
  '       group:  group for which the command is valid
  '*******************************************************
  sub global_control(card,number,slave,command,group)
    set_pro_byte(card,out_mailbox_0,3)
    set_pro_byte(card,out_mailbox_1,16)
    set_pro_byte(card,out_mailbox_2,3)
    set_pro_byte(card,out_mailbox_3,number)
    set_pro_byte(card,out_mailbox_4,0)  
    set_pro_byte(card,out_mailbox_5,0)
    set_pro_byte(card,out_mailbox_6,70)
    set_pro_byte(card,out_mailbox_7,0)
    set_pro_byte(card,out_mailbox_8,slave)
    set_pro_byte(card,out_mailbox_9,command)
    set_pro_byte(card,out_mailbox_a,group)
  endsub

        
  '*******************************************************
  ' communication via mailbox
  ' read statistic counter
  '       card  : dip switch address 
  '       number: unique message number 
  '       start:  bus address of first slave 
  '       count:  number of slaves
  '*******************************************************
  sub statistic(card,number,start,count)
    set_pro_byte(card,out_mailbox_0,7)
    set_pro_byte(card,out_mailbox_1,16)
    set_pro_byte(card,out_mailbox_2,8)
    set_pro_byte(card,out_mailbox_3,number)
    set_pro_byte(card,out_mailbox_4,0)  
    set_pro_byte(card,out_mailbox_5,0)
    set_pro_byte(card,out_mailbox_6,0feh)
    set_pro_byte(card,out_mailbox_7,0)
    set_pro_byte(card,out_mailbox_8,start)
    set_pro_byte(card,out_mailbox_9,0)
    set_pro_byte(card,out_mailbox_a,0)
    set_pro_byte(card,out_mailbox_b,0)
    set_pro_byte(card,out_mailbox_c,0)
    set_pro_byte(card,out_mailbox_d,count)
    set_pro_byte(card,out_mailbox_e,5)
    set_pro_byte(card,out_mailbox_f,1)
  endsub
        
        
  '*******************************************************
  ' communication via mailbox
  ' clear statistic counter
  '       card  : dip switch address 
  '       number: unique message number 
  '*******************************************************
  sub clear_statistic(card,number)
    set_pro_byte(card,out_mailbox_0,7)
    set_pro_byte(card,out_mailbox_1,16)
    set_pro_byte(card,out_mailbox_2,8)
    set_pro_byte(card,out_mailbox_3,number)
    set_pro_byte(card,out_mailbox_4,0)  
    set_pro_byte(card,out_mailbox_5,0)
    set_pro_byte(card,out_mailbox_6,0feh)
    set_pro_byte(card,out_mailbox_7,0)
    set_pro_byte(card,out_mailbox_8,0)
    set_pro_byte(card,out_mailbox_9,0)
    set_pro_byte(card,out_mailbox_a,0)
    set_pro_byte(card,out_mailbox_b,0)
    set_pro_byte(card,out_mailbox_c,0)
    set_pro_byte(card,out_mailbox_d,0)
    set_pro_byte(card,out_mailbox_e,5)
    set_pro_byte(card,out_mailbox_f,4)
  endsub
        
        
        
  '*******************************************************
  'Communication via Mailbox
  'check if requested message is arrived
  'return value :  1 = message arrived
  '                    2 = message not arrived
  '*******************************************************
  function check_msg(card) as long                        
    dim byte as long
    dim flag as long
  
    byte = get_pro_byte(card,control_to_host) and 02h
    flag = get_pro_byte(card,control_to_device) and 02h
    par_3 = flag
    par_4 = byte
    if (byte = flag) then
      check_msg = 1                                       ' message arrived
    else
      check_msg = 2                                       ' message not arrived
    endif
  endfunction
          
        
  '*******************************************************
  'communicaion via mailbox.
  'Sending message to note.
  'After the initialisation of the Out_mailbox the message
  'must be send to the profibus.
  '       card  : dip switch address 
  '*******************************************************
  sub send_msg_to_note(card)
    dim byte as long
    dim flag as long
    
    byte = ((get_pro_byte(card,control_to_host) and 02h) xor 02h)
    flag = (get_pro_byte(card,control_to_device))
    flag = (flag and 0dh) or byte
    set_pro_byte(card,control_to_device,flag) 
  endsub
        
        
  '*******************************************************
  ' Gives acknolage to arrived message
  '       card  : dip switch address 
  '*******************************************************
  sub ack_msg(card)                               
    dim byte as long

    byte = get_pro_byte(card,control_to_host) and 03h
    set_pro_byte(card,control_to_device, byte)
  endsub
        
        
  '*******************************************************
  'Reset the Master Module
  '       access_mode:    0 = bus synchronus ; device controlled
  '                               1 = bufferd ; device controlled
  '                               2 = uncontrolled
  '                               3 = bufferd ; user controlled
  '                               4 = bus synchronus ; user controlled
  '       card  :         dip switch address 
  '*******************************************************
  sub reset_master(card,access_mode)
    set_pro_byte(card,set_exchange_mode,access_mode)              'set access mode
    set_pro_byte(card,control_to_device,080h)                     'set reset flag
  endsub
        
        
  '*******************************************************
  'Initialisation of the Master Module
  '       access_mode:    0 = bus synchronus ; device controlled
  '                               1 = bufferd ; device controlled
  '                               2 = uncontrolled
  '                               3 = bufferd ; user controlled
  '                               4 = bus synchronus ; user controlled
  '       card  :         dip switch address 
  '*******************************************************
  sub init_master(card,access_mode)
    dim mode as long

    set_pro_byte(card,set_exchange_mode,access_mode)
    set_pro_byte(card,control_to_device,040h)
  endsub
        
        
  '*******************************************************
  'Check if the device or the host has access right
  'function only valid in access_mode 0 and 1
  '       card  :         dip switch address 
  '       return value :  1 = host
  '                               2 = device
  '*******************************************************
  function check_access_0(card) as long
    dim byte as long  
    dim flag as long  
    
    byte = get_pro_byte(card,control_to_host) and 04h
    flag = get_pro_byte(card,control_to_device) and 04h
    if (flag <> byte) then
      check_access_0 = 1
    else
      check_access_0 = 2
    endif
  endfunction
    
        
  '*******************************************************
  'Check if the device or the host has access right
  'function only valid in access_mode 3 and 4
  '       card  :         dip switch address 
  '       return value :  1 = host
  '                               2 = device
  '*******************************************************
  function check_access_3(card) as long
    dim byte as long  
    dim flag as long  
  
    byte = get_pro_byte(card,control_to_host) and 04h
    flag = get_pro_byte(card,control_to_device) and 04h
    if (flag = byte) then
      check_access_3 = 1
    else
      check_access_3 = 2
    endif
  endfunction
        
        
  '*******************************************************
  'Shows the statue of the master
  '       card  :         dip switch address 
  'bit7:  1 = device is ready
  '               0 = device is not ready
  'bit6:  1 = communication is running
  '               0 = communication is not running
  'bit5:  1 = data is getting exchanged
  '               0 = no data exchanged
  '*******************************************************
  function master_status(card) as long
    master_status = get_pro_byte(card,control_to_host) and 0f0h
  endfunction
  
  #IF PROZESSOR = T11 THEN
          {import tc.lib}
  #ENDIF  



  '***************************************************************
  ' convert digit from TC4/8/16 J to temperature
  ' digit16 inputvalue
  ' unit 1= C
  '      2= F
  '***************************************************************
  FUNCTION TCJ_DIG_TO_TEMP(digit16,unit) as float
   TCJ_DIG_TO_TEMP = TC_CONVERT_TYP_J((digit16 - 32778) * 1.57758)
   IF (UNIT=2) THEN  'C -> F
    TCJ_DIG_TO_TEMP=(TCJ_DIG_TO_TEMP*1.8)+32
   ENDIF
  ENDFUNCTION

   '***************************************************************
   ' convert digit from TC4/8/16 K to temperature
   ' digit16 inputvalue
   ' unit 1= C
   '      2= F
   '***************************************************************
   FUNCTION TCK_DIG_TO_TEMP(digit16,unit) as float
     TCK_DIG_TO_TEMP = TC_CONVERT_TYP_K((digit16 - 32778) * 1.234192)
     IF (UNIT=2) THEN  'C -> F
      TCK_DIG_TO_TEMP=(TCK_DIG_TO_TEMP*1.8)+32
     ENDIF
   ENDFUNCTION

   '***************************************************************
   ' convert digit from PT-100 to temperature
   ' digit16 inputvalue
   ' unit 1= C
   '      2= F
   '***************************************************************
   FUNCTION PT100_DIG_TO_TEMP(dig,unit) AS FLOAT
    DIM x AS FLOAT
    x = (dig-32768)*20/65536
    IF (x <= 0) THEN
     PT100_DIG_TO_TEMP = ((((0.0002*x - 0.0032) * x + 0.0906) * x + 25.581) * x - 0.002)
    ELSE
     PT100_DIG_TO_TEMP = (0.1097*x + 25.536)*x + 0.0444
    ENDIF
  
  IF (unit = 2) THEN PT100_DIG_TO_TEMP = PT100_DIG_TO_TEMP*1.8 + 32
  ENDFUNCTION

   '***************************************************************
   ' convert digit from PT-100 to resistor
   ' digit16 inputvalue
   ' return r[ohm]
   '***************************************************************
   FUNCTION PT100_DIG_TO_R(dig) AS FLOAT
     PT100_DIG_TO_R = ((dig-32768)*200/65536)+100
   ENDFUNCTION



  '***************************************************************
  ' read value of tc iso TYP J  -210 C->1200 C 
  ' card : dip switch adress              
  ' channel (1-8) 
  ' unit 0= thermovoltage V
  '                        1= C
  '      2= F
  '***************************************************************
  function TC_READ_J(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
   
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
          
    coldjunction=(shift_right(value,16)) AND 1FFFH
    if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
    
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    spg2=spg *2.44140625 'thermovoltage => V
    spg2=spg2 +TC_CONVERT_TYP_J_INV((coldjunction/16))
           
    IF (UNIT>0) then 'convert
      TC_READ_J=TC_CONVERT_TYP_J(spg2) '-210 C->1200 C DIN EN 60584-1
    ELSE 
      TC_READ_J=spg2 
    endif
  
    if (UNIT=2) then  'C -> F
      TC_READ_J=(TC_READ_J*1.8)+32
    endif
  endfunction


  '***************************************************************
  ' read value of tc iso TYP N  -200C->1300 C 
  ' card : dip switch adress              
  ' channel (1-8) 
  ' unit 0= thermovoltage V
  '                        1= C
  '      2= F
  '***************************************************************
  function TC_READ_N(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
          
    coldjunction=(shift_right(value,16)) AND 1FFFH
    if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
          
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    spg2=spg *2.44140625 'thermovoltage => V
    spg2=spg2 +TC_CONVERT_TYP_N_INV((coldjunction/16))
           
    IF (UNIT>0) then 'convert
      TC_READ_N=TC_CONVERT_TYP_N(spg2) '-210 C->1300 C DIN EN 60584-1
    ELSE 
      TC_READ_N=spg2 
    endif
  
    if (UNIT=2) then  'C -> F
      TC_READ_N=(TC_READ_N*1.8)+32
    endif
  endfunction


  '***************************************************************
  ' read value of tc iso TYP K -200 C -> 1372 C 
  ' card : dip switch adress      
  ' channel (1-8) 
  ' unit 0= thermovoltage in V
  '                        1= C
  '      2= F
  '***************************************************************
  function TC_READ_K(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
   
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
          
    coldjunction=(shift_right(value,16)) AND 1FFFH
    if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
  
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    
    spg2=spg *2.44140625 'thermovoltage => V
    
    if (coldjunction<=400) then '<25 C
      spg2=spg2+(2.5055*coldjunction)
    else
      spg2=spg2+(2.56*(coldjunction-9.76))
    endif
           
    IF (UNIT>0) then 'convert
      TC_READ_K=TC_CONVERT_TYP_K(spg2) '-200 C -> 1372 C DIN EN 60584-1
    ELSE 
      TC_READ_K=spg2 
    endif
  
    if (UNIT=2) then  'C -> F
      TC_READ_K=(TC_READ_K*1.8)+32
    endif
  endfunction


  '***************************************************************
  ' read value of tc iso TYPE S -50 C-> 1768 C
  ' card : dip switch adress
  ' channel (1-8)         
  ' unit 0= thermovoltage in V
  '                        1= C
  '      2= F
  '***************************************************************
  function TC_READ_S(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
          
    coldjunction=(shift_right(value,16)) AND 1FFFH
    if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if(spg AND 32768=32768) then spg=spg OR 0FFFF0000H      
    spg2=spg *2.44140625 'thermovoltage => V
    spg2=spg2 +TC_CONVERT_TYP_S_INV((coldjunction/16))
    IF (UNIT>0) then 'convert
      TC_READ_S=TC_CONVERT_TYP_S(spg2) '-50 C-> 1768 C DIN EN 60584-1
    ELSE 
      TC_READ_S=spg2          
    endif
  
    if (UNIT=2) then  'C -> F
      TC_READ_S=(TC_READ_S*1.8)+32
    endif
  endfunction


  '***************************************************************
  ' read value of tc iso TYPE T -200 C-> 400 C 
  ' card : dip switch adress
  ' channel (1-8)                 
  ' unit 0= thermovoltage in V
  '                  1= C
  '      2= F
  '***************************************************************
  function TC_READ_T(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
   
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
    coldjunction=(shift_right(value,16)) AND 1FFFH
    if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    spg2=spg *2.44140625 'thermovoltage => V
    spg2=spg2 +TC_CONVERT_TYP_T_INV((coldjunction/16))
    IF (UNIT>0) then 'convert
      TC_READ_T=TC_CONVERT_TYP_T(spg2) '-200 C-> 400 C DIN EN 60584-1
    ELSE 
      TC_READ_T=spg2 
    endif
    if (UNIT=2) then  'C -> F
      TC_READ_T=(TC_READ_T*1.8)+32
    endif
  endfunction


  '***************************************************************
  ' read value of tc iso TYPE R -50 C-> 1768 C 
  ' card : dip switch adress
  ' channel (1-8)                 
  ' unit 0= thermovoltage in V
  '                  1= C
  '      2= F
  '***************************************************************
  function TC_READ_R(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
    coldjunction=(shift_right(value,16)) AND 1FFFH
    if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    spg2=spg *2.44140625 'thermovoltage => V
    spg2=spg2 +TC_CONVERT_TYP_R_INV((coldjunction/16))
    IF (UNIT>0) then 'convert
      TC_READ_R=TC_CONVERT_TYP_R(spg2) 
    ELSE 
      TC_READ_R=spg2 
    endif
    if (UNIT=2) then  'C -> F
      TC_READ_R=(TC_READ_R*1.8)+32
    endif
  endfunction


  '***************************************************************
  ' read value of tc iso TYPE E -200 C-> 1000 C 
  ' card : dip switch adress
  ' channel (1-8)                 
  ' unit 0= thermovoltage in V
  '                  1= C
  '      2= F
  '***************************************************************
  function TC_READ_E(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
    coldjunction=(shift_right(value,16)) AND 1FFFH
    if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
   
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    spg2=spg *2.44140625 'thermovoltage => V
    spg2=spg2 +TC_CONVERT_TYP_E_INV((coldjunction/16))
  
    IF (UNIT>0) then 'convert
      TC_READ_E=TC_CONVERT_TYP_E(spg2) 
    ELSE 
      TC_READ_E=spg2 
    endif
  
    if (UNIT=2) then  'C -> F
      TC_READ_E=(TC_READ_E*1.8)+32
    endif
  endfunction

 '***************************************************************
  ' read value of tc iso TYPE B '250 C-1820 
  ' card : dip switch adress
  ' channel (1-8)                 
  ' unit 0= thermovoltage in V
  '                  1= C
  '      2= F
  '***************************************************************
  function TC_READ_B(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
   
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    spg2=spg *2.44140625 'thermovoltage => V
   
  
    IF (UNIT>0) then 'convert
      TC_READ_B=TC_CONVERT_TYP_B(spg2) 
    ELSE 
      TC_READ_B=spg2 
    endif
  
    if (UNIT=2) then  'C -> F
      TC_READ_B=(TC_READ_B*1.8)+32
    endif
  endfunction








  '***************************************************************
  ' read the input voltage [v] without coldjunction correction  
  ' This function may be used if not a Thermocouple is connected 
  ' to the inputs of the TC-8 ISO , but if a voltage is applied 
  ' directly to the inputs. Max. input voltage is +- 80 mVolt
  ' card : dip switch adress
  ' channel (1-8)                 
  '***************************************************************
  function TC_READ_VOLTAGE(card,channel) as float
    dim adr as long
    dim value as long
    dim spg as long
            
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32) AND 0FFFFH
    SUB_END_CRITICAL_SECTION
                  
    if( VALUE AND 32768=32768) then value=value OR 0FFFF0000H       
    TC_READ_VOLTAGE=VALUE *2.44140625 'voltage => V
  endfunction


  '**************************************************************
  'Sub is setting the samplerate of tc iso modul
  'card : dip switch address
  'mode=1 sampelrate = 3520 Hz
  'mode=2 sampelrate = 1760 Hz
  'mode=3 sampelrate = 880 Hz
  'mode=4 sampelrate = 440 Hz
  'mode=5 sampelrate = 220 Hz
  'mode=6 sampelrate = 110 Hz
  'mode=7 sampelrate = 55 Hz
  'mode=8 sampelrate = 27.5 Hz
  'mode=9 sampelrate = 13.75 Hz
  'mode=15 sampelrate = 6.875 Hz (default)
  '************************************************************** 
   sub TC_SET_RATE(card,mode) 
      dim adr as long
  
      adr = SHIFT_LEFT(card,8)or 0c0h 
      SUB_BEGIN_CRITICAL_SECTION
        poke(ADWR , adr )
        nop_t9
        poke_nop( d32 , mode)  
      SUB_END_CRITICAL_SECTION
   endsub


  '**************************************************************
  'transfer the input data from channel 1-4 to an array
  'card : dip switch address
  'array: destination array 
  'index: startindex in the destination array
  '**************************************************************
  SUB READ_ADCF4_PACKED(card,array[],index)    
    SUB_BEGIN_CRITICAL_SECTION
      Poke(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
      array[index]=PEEK(D32i)
      array[index+1]=PEEK(D32)
    SUB_END_CRITICAL_SECTION
  ENDSUB
  
  
  '**************************************************************
  'transfer the input data from channel 1-8 to an array
  'card : dip switch address
  'array: destination array 
  'index: startindex in the destination array
  '**************************************************************
  SUB READ_ADCF8_PACKED(card,array[],index)    
    SUB_BEGIN_CRITICAL_SECTION
      Poke(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
      array[index]=PEEK(D32i)
      array[index+1]=PEEK(D32i)       
      array[index+2]=PEEK(D32i)
      array[index+3]=PEEK(D32)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '**************************************************************
  'transfer the input data from channel 1-8 to an array
  'card : dip switch address
  'array: destination array 
  'index: startindex in the destination array
  '**************************************************************
  SUB READ_ADCF8(card,array[],index)    
    dim value as long
  
    SUB_BEGIN_CRITICAL_SECTION
      Poke(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
      value=PEEK(D32i)'channel 1 + 2
      array[index]=value AND 0FFFFH
      array[index+1]=shift_right(value,16)
      
      value=PEEK(D32i)'channel 3 + 4
      array[index+2]=value AND 0FFFFH
      array[index+3]=shift_right(value,16)
    
      value=PEEK(D32i)'channel 5 + 6
      array[index+4]=value AND 0FFFFH
      array[index+5]=shift_right(value,16)
    
      value=PEEK(D32)'channel 7 + 8
    SUB_END_CRITICAL_SECTION
    array[index+6]=value AND 0FFFFH
    array[index+7]=shift_right(value,16)
  ENDSUB


  '**************************************************************
  'transfer the input data from channel 1-4 to an array
  'card : dip switch address
  'array: destination array 
  'index: startindex in the destination array
  '**************************************************************
  SUB READ_ADCF4(card,array[],index)    
    dim value as long
  
    SUB_BEGIN_CRITICAL_SECTION
      Poke(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
      value=PEEK(D32i)'channel 1 + 2
      array[index]=value AND 0FFFFH
      array[index+1]=shift_right(value,16)
      value=PEEK(D32)'channel 3 + 4
    SUB_END_CRITICAL_SECTION
    array[index+2]=value AND 0FFFFH
    array[index+3]=shift_right(value,16)
  ENDSUB
#else
  #error("This include file can only be used with the processor T11.")
#endif









