****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwinPRO2.inc                        #
'#              INCLUDE-file for ADwin-Pro II-system           #
'###############################################################
'#                                                             #
'# Contents: Definition of functions and procedures            #
'#           to access ADwin PRO SYSTEM                        #
'#                                                             #
'#  08.09.2005  mf   creation                                  #
'#  13.10.2005  mf   check_card                                #
'#  12.12.2005  mf   sync_all                                  #
'#  24.01.2006  mf   Fx/14 (Rev. E) ,  Fx/18                   #
'#  25.01.2006  mf   bugfix CPU_EVENT_CONFIG                   #
'#  24.02.2006  mf   p2_wait_eocf                              #
'#  03.04.2006  mf   AIN 32/18                                 #
'#  11.04.2006  ur   syntax checked                            #
'#  04.05.2006  mf   DAC Rev E                                 #
'#  17.05 2006  mf   P2_ADC_READ_LIMIT                         #
'#  01.06.2006  mf   bugfix P2_SEQ_INIT                        #
'#  14.06.2006  mf   bugfix P2_BURST_READ_INDEX                #
'#                                                             #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.20.04 or higher!    #
'#                                                             #
'###############################################################

#IF PROZESSOR = T11 THEN
  #define DL         20400000h
  #define DH         20400010h
  #define DLX        20400020h
  #define DHX        20400030h
  #define ADWR       20400060h
  #define ADRD       20400070h
  #define CPU_EVENT  204000F0h
  #define WATCHDOG   10000400h
  #define WD_TIMER   10000400h
  #define CPU_LED    10000100h
  #define CPU_DIG_ADR 10000210H 
  #define CPU_DIG_ADR1 10000220H 

  
  '******************************************************************************
  ' If a low-priority process accesses a Pro-module it must not be
  ' interrupted by any other process !!!
  '******************************************************************************
  SUB SUB_BEGIN_CRITICAL_SECTION()
    #IF PRIORITAET = LOW
      BEGIN_CRITICAL_SECTION
    #ENDIF
  ENDSUB
  SUB SUB_END_CRITICAL_SECTION()
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
  ENDSUB


  '******************************************************************************
  ' Function only for internal use.
  ' check if the pro2 address is legal
  '******************************************************************************
  SUB CHECK_CARD(card)
    #IF DEBUG_MODE=ON THEN
      IF ((card<1) OR (card>15)) THEN 
        PROZESS_FEHLER=200001
        end_exit
      ENDIF
    #ENDIF
  ENDSUB
  
  
  '******************************************************************************
  '  switches a LED on or off
  '  card :   module-address 0=CPU
  '  WERT : 0/1 off/on
  '******************************************************************************
  SUB P2_SET_LED(card,value)
    IF (card=0) THEN
      SUB_BEGIN_CRITICAL_SECTION
        POKE(CPU_LED, value)
      SUB_END_CRITICAL_SECTION
    ELSE 
      CHECK_CARD(card)
      POKE_FAST_BUS((32804000h OR shift_left(card,16)),value)
    ENDIF
  ENDSUB


  '******************************************************************************
  '  checks the LED on a module
  '  card :   module-address 0=cpu
  '******************************************************************************
  FUNCTION P2_CHECK_LED(card) AS INTEGER
    IF (card=0) THEN
      SUB_BEGIN_CRITICAL_SECTION
        P2_CHECK_LED = (PEEK(CPU_LED) and 1)
      SUB_END_CRITICAL_SECTION
    ELSE
      CHECK_CARD(card)
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33804000h OR shift_left(card,16)),0)
        READ_FAST_BUS(P2_CHECK_LED,1)
      SUB_END_CRITICAL_SECTION
    ENDIF
  ENDFUNCTION

  
  '******************************************************************************
  '  config the external Event input       
  '  filterON 0/1  0=15 ns (default) 1 =50 ns
  '  edge: 1 rising edge (default)
  '                        2 falling edge
  '        3 rising & falling edge
  '        prescaler 1-15
  '******************************************************************************
  SUB CPU_EVENT_CONFIG(filterON,edge,prescaler)
    DIM old AS LONG
    DIM new AS LONG

    old=peek(10000300h) AND 7FFFFF00H
    new=shift_left((filteron AND 1),31) or (edge AND 3) or (shift_left(prescaler,4)) or old
    poke(10000300h,new)
  ENDSUB
  
  
  '*******************************************************************************
  '  activates or deactivates the external Event input
  '  card       :   module-address         
  '  value: 0/1 deactivate/activate
  '*******************************************************************************
  SUB P2_EVENT_ENABLE(card,value)
    DIM old AS LONG
 
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33804800h OR shift_left(card,16)),0)
      READ_FAST_BUS(old,1)
    SUB_END_CRITICAL_SECTION
    old =(old AND 0FFFFFFFEH) or value
    POKE_FAST_BUS((32804800h OR shift_left(card,16)),old)
  ENDSUB

  '*******************************************************************************
  '  config the external Event input
  '  card       :   module-address         
  '  filter 0/1  0=15 ns (default) 1 =50 ns
  '  edge: 1 rising edge (default)
  '                        2 falling edge
  '        3 rising & falling edge
  '  prescale : 1 to 255
  '*******************************************************************************
  SUB P2_EVENT_CONFIG(card,filterON,edge,prescale)
    DIM old AS LONG
    DIM neu AS LONG
    DIM value AS LONG
  
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33804800h OR shift_left(card,16)),0)
      READ_FAST_BUS(old,1)
    SUB_END_CRITICAL_SECTION
  
    neu=shift_left((filteron AND 1),4) or shift_left((edge AND 3),2)
    old =(old AND 0FFFFFFE3H) or neu
    POKE_FAST_BUS((32804800h OR shift_left(card,16)),old)
    value=prescale AND 0FFH
    POKE_FAST_BUS((32804810h OR shift_left(card,16)),value)
  ENDSUB


  '*******************************************************************************
  '  config the external Event input 
  '  card:    module-address       
  '  mode: 0  normal mode
  '        1  clear impulse mode
  '        2  AB mode
  '        3  AB clear impulse mode 
  '  edge clear impulse: 1 rising edge (default)
  '                                      2 falling edge
  '                      3 rising & falling edge
  '*******************************************************************************
  SUB P2_EVENT2_CONFIG(card,mode,edge)
    DIM old AS LONG
   
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33804820h OR shift_left(card,16)),0)
      READ_FAST_BUS(old,1)
    SUB_END_CRITICAL_SECTION
  
    old = old AND 0FFFFFFE0H
    POKE_FAST_BUS((32804820h OR shift_left(card,16)),old)
    old =old or (shift_left((edge AND 3),3)) or (mode and 7) 
    POKE_FAST_BUS((32804820h OR shift_left(card,16)),old)
  ENDSUB


  '******************************************************************************
  ' Reads the event inputs (channel 0 - 31) 
  ' card:    module-address     
  '******************************************************************************
  FUNCTION P2_EVENT_READ(card) as long
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33007040h OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_EVENT_READ,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  '  checks, whether the DIG_IN 1 -function of a CPU module is activated
  '  activated = a falling edge has been received 
  '  result :   0/1   activated/deactivated 
  '  channel: 0/1 
  '******************************************************************************
  FUNCTION CPU_DIGIN(channel) AS LONG
    CPU_DIGIN = shift_right(peek(cpu_DIG_ADR+(16*channel)),1) AND 1
  ENDFUNCTION


  '******************************************************************************
  '  SET 
  '  BIT 0 DIG IO 0   (DIG IO/=0  0= INPUT, 1= OUTPUT)
  '  BIT 1 DIG IO 0   (0= falling edge, 1= rising edge if DIG IO 0 is input)
  '  BIT 4 DIG IO 1   (DIG IO/=1  0= INPUT, 1= OUTPUT)
  '  BIT 5 DIG IO 1   (0= falling edge, 1= rising edge if DIG IO 1 is input)
  '******************************************************************************
  SUB CPU_DIG_IO_CONFIG(set)
    poke(10000200H,set)
  ENDSUB


  '******************************************************************************
  ' Sets the digital output DIG IO 0/1 on the cpu 
  '
  ' channel= 0 or 1 
  '******************************************************************************
  SUB CPU_DIGOUT(channel,value) 
    poke(10000210H+channel*16,value AND 1)
  ENDSUB


  '******************************************************************************
  ' Initialisation of a digital I/O module (channel 0-31) 
  '  card : module-address
  '  value : each bit corresponds to 8 channel
  '     0 = input
  '     1 = output
  '******************************************************************************
  SUB P2_DIGPROG(card,value)
    CHECK_CARD(card)
    POKE_FAST_BUS((32804100h OR shift_left(card,16)),value)
  ENDSUB


  '******************************************************************************
  ' Sets the digital outputs (channel 0 - 31) 
  ' card : module-address
  ' value : each bit corresponds to a channel
  '******************************************************************************
  SUB P2_DIGOUT_LONG(card,value)
    CHECK_CARD(card)
    POKE_FAST_BUS((32000000h OR shift_left(card,16)),value)
  ENDSUB


  '******************************************************************************
  ' Reads the digital inputs (channel 0 - 31) 
  ' card : module-address
  '******************************************************************************
  FUNCTION P2_DIGIN_LONG(card) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33000100h OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_DIGIN_LONG,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  ' read back of the output value of the digital
  ' outputs (channel 0 - 31)) 
  ' card : module-address
  '******************************************************************************
  FUNCTION P2_GET_DIGOUT_LONG(card) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33000000h OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_GET_DIGOUT_LONG,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  ' Sets and resets selected digital outputs
  ' card : module-address
  ' set  : Bitstring indicating the outputs which should be set
  ' reset: Bitstring indicating the outputs which should be reset
  '******************************************************************************
  SUB P2_DIGOUT_BITS(card,set,reset)
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION 
      POKE_FAST_BUS((32101000h OR shift_left(card,16)),reset)
      POKE_FAST_BUS(32100000h,set) 
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  ' Sets or resets one channel of a digital output  
  ' card    : module-address
  ' channel : channel (0..31)
  ' value   : 0 = reset channel
  '           1 = set channel
  ''*****************************************************************************
  SUB P2_DIGOUT(card,channel,value)  
    CHECK_CARD(card)
    POKE_FAST_BUS(((32000021h-value) OR shift_left(card,16)),shift_left(1,(channel)))
  ENDSUB


  '******************************************************************************
  ' latch all those modules, which have been activated with the 
  ' SYNCENABLE command
  ' card_pattern : bit pattern to set the module adresses
  '******************************************************************************
  SUB P2_SYNC_ALL(card_pattern)
    POKE_FAST_BUS(32801000h,card_pattern) '       
  ENDSUB


  '******************************************************************************
  '  activate- or deactivate the Sync-function of a module
  '  card :   module-address     
  '  value : each bit corresponds to a channel
  '******************************************************************************
  SUB P2_SYNC_ENABLE(card,value)
   CHECK_CARD(card)
   POKE_FAST_BUS((32804110H OR shift_left(card,16)),value)
  ENDSUB


  '******************************************************************************
  '  checks, whether the Sync-function of a module is activated
  '  card :   module-address     
  '  result :  each bit corresponds to a channel
  '******************************************************************************
  FUNCTION P2_SYNC_STAT(card) AS long
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33804110H OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_SYNC_STAT,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  'initialising the syncronisation mode 
  'card : dip switch address
  'mode =0 normal Mode (no syncronisation)
  '     =1 Master Mode
  '     =2 Slave Mode
  '******************************************************************************
  SUB P2_SYNC_MODE(card,MODE)
    if ((card>0) AND (card<16)) then
      POKE_FAST_BUS((32804900H OR shift_left(card,16)),Mode)
    else
      poke(10000310H,mode) 
    endif
  ENDSUB
  
  
  '******************************************************************************
  ' sets output register (channel 0 - 31)
  ' card : module-address
  ' value : each bit corresponds to a channel
  '******************************************************************************
  SUB P2_DIG_WRITE_LATCH(card,value)
     CHECK_CARD(card)
     POKE_FAST_BUS((32000010H OR shift_left(card,16)),value)
  ENDSUB
  
  
  '******************************************************************************
  ' reads the input latch register (channel 0 - 31)
  ' card : module-address
  '******************************************************************************
  FUNCTION P2_DIG_READ_LATCH(card) AS long
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS((33000110h OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_DIG_READ_LATCH,1)  
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  ' latches the digital I/O card. 
  ' Inputs ars latched in the input registers
  ' Outputs ars set according to the output register.             
  ' card : module-address
  '******************************************************************************
  SUB P2_DIG_LATCH(card)
    CHECK_CARD(card)
    POKE_FAST_BUS((32000200h OR shift_left(card,16)),0)
  ENDSUB


  '******************************************************************************
  ' Samples, converts and reads out the digital 16 bit ADC-value
  ' of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' ! Attention:                                                                !
  ' ! This instruction is not prepared to handle an access from                 !
  ' ! a low AND high priority process to the same module.                       !
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' card :  module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '******************************************************************************
  FUNCTION P2_ADCF(card,ADC_No) AS LONG
    DIM adc_n1,reminder AS LONG
  
    CHECK_CARD(card)
  
    adc_n1 = SHIFT_LEFT(1,(ADC_No-1))
     '............ start conversion ............
    POKE_FAST_BUS((32007000h OR shift_left(card,16)),adc_n1 )
  
   '............ wait EOC ............
    do
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33007010h OR shift_left(card,16)),0)
        READ_FAST_BUS(reminder,1)
      SUB_END_CRITICAL_SECTION
    until (((reminder AND adc_n1)=0) or reminder=12345678H)
    ' 12345678H = timeout from bus because no module is present
    '............ read out result ............
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((330001FFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_ADCF,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*****************************************************************************
  ' Samples, converts and reads out the digital 24 bit ADC-value
  ' of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' ! Attention:                                                               !
  ' ! This instruction is not prepared to handle an access from                !
  ' ! a low AND high priority process to the same module.                      !
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' card :  module-address
  ' ADC_No: channel number of analog input
  ' result: 24 bit integer
  '******************************************************************************
  FUNCTION P2_ADCF24(card,ADC_No) AS LONG
    DIM adc_n1,reminder AS LONG
   
    CHECK_CARD(card)
  
    adc_n1 = SHIFT_LEFT(1,(ADC_No-1))
     '............ start conversion ............
    POKE_FAST_BUS((32007000h OR shift_left(card,16)),adc_n1 )
    '............ wait EOC ............
    do
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33007010h OR shift_left(card,16)),0)
        READ_FAST_BUS(reminder,1)
      SUB_END_CRITICAL_SECTION
    until (((reminder AND adc_n1)=0) or reminder=12345678H)
    ' 12345678H = timeout from bus because no module is present
    '............ read out result ............
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((32FFFFFFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_ADCF24,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*****************************************************************************
  ' Starts a conversion on selected ADC on AIN-Fx/yy-modules.
  ' card:   module-address
  ' select: Datenbit z. B.: 0101=adc1+3
  '*****************************************************************************
  SUB P2_START_CONVF(card,select)
    CHECK_CARD(card)
    POKE_FAST_BUS((32007000h OR shift_left(card,16)),select)
  ENDSUB


  '*****************************************************************************
  ' Wait until EOC-signals of all selected ADCs are active.
  ' (for AIN-Fx/yy-modules only)
  ' card:   module-address
  ' select: ADC-#1 -> bit 0,  ...,  ADC-#8 -> bit 7
  '*****************************************************************************
  SUB P2_WAIT_EOCF(card,select)
    DIM reminder AS LONG
 
    CHECK_CARD(card)
    do
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33007010h OR shift_left(card,16)),0)
        READ_FAST_BUS(reminder,1)
      SUB_END_CRITICAL_SECTION
    until (((reminder AND select)=0) or reminder=12345678H)
    ' 12345678H = timeout from bus because no module is present
  ENDSUB


  '*****************************************************************************
  ' Returns conversion result of ADC of AIN-Fx/yy-module.
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit long
  '*****************************************************************************
  FUNCTION P2_READ_ADCF(card,ADC_No) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((330001FFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADCF,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION
  
  
  '*****************************************************************************
  ' Returns conversion result of ADC of AIN-Fx/yy-module.
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 24 bit long
  '*****************************************************************************
  FUNCTION P2_READ_ADCF24(card,ADC_No) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((32FFFFFFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADCF24,1)
    SUB_END_CRITICAL_SECTION 
  ENDFUNCTION


  '*****************************************************************************
  ' Returns conversion result of two ADC's simultaneously from
  ' an AIN-Fx/yy-module.
  ' card:   module-address
  ' ADC_No:       1 = channel no. 1 low  + 2 high word
  '       2 = channel no. 3 + 4
  '       3 = channel no. 5 + 6
  '       4 = channel no. 7 + 8
  ' result: 32 bit integer
  '         low-word -> ADC_No,  high-word -> ADC_No + 1
  '*****************************************************************************
  FUNCTION P2_READ_ADCF32(card,ADC_No) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((330003FFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADCF32,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*****************************************************************************
  ' Returns conversion result of two ADC's simultaneously and
  ' immediately starts the conversion of both ADC again.
  ' card:   module-address
  ' ADC_No: 1 = channel no. 1 + 2
  '         2 = channel no. 3 + 4
  '         3 = channel no. 5 + 6
  '         4 = channel no. 7 + 8
  ' result: 32 bit integer
  '         low-word -> ADC_No,  high-word -> ADC_No + 1
  '*****************************************************************************
  FUNCTION P2_READ_ADCF_SCONV32(card,ADC_No) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((330004FFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADCF_SCONV32,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION
  
  
  '*****************************************************************************
  ' Returns conversion result of ADC and starts immediately
  ' a new conversion (for AIN-Fx/yy-modules only).
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '*****************************************************************************
  FUNCTION P2_READ_ADCF_SCONV(card,ADC_No) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((330002FFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADCF_SCONV,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*****************************************************************************
  ' Returns conversion result of ADC and starts immediately
  ' a new conversion (for AIN-Fx/yy-modules only).
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 24 bit long
  '*****************************************************************************
  FUNCTION P2_READ_ADCF_SCONV24(card,ADC_No) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((330000FFh+ADC_No) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADCF_SCONV24,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '*****************************************************************************
  'transfer the input data from channel 1-4 to an array
  'card : module-address
  'array: destination array 
  'index: startindex in the destination array
  '*****************************************************************************
  SUB P2_READ_ADCF4_PACKED(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33100400H) OR shift_left(card,16)),0)
      READ_FAST_BUS(array[index],2)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*****************************************************************************
  'transfer the input data from channel 1-8 to an array
  'card : module-address
  'array: destination array 
  'index: startindex in the destination array
  '*****************************************************************************
  SUB P2_READ_ADCF8_PACKED(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33300400H) OR shift_left(card,16)),0)
      READ_FAST_BUS(array[index],4)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '*****************************************************************************
  'transfer the input data from channel 1-8 to an array
  'card : module-address
  'array: destination array 
  'index: startindex in the destination array
  '*****************************************************************************
  SUB P2_READ_ADCF8(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33300400H) OR shift_left(card,16)),0)
      READ_FAST_BUS_UNPACKED(array[index],4)
    SUB_END_CRITICAL_SECTION
  ENDSUB
  
  
  '****************************************************************************
  'transfer the input data from channel 1-4 to an array
  'card : module-address
  'array: destination array 
  'index: startindex in the destination array
  '****************************************************************************
  SUB P2_READ_ADCF4(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33100400H) OR shift_left(card,16)),0)
      READ_FAST_BUS_UNPACKED(array[index],2)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '****************************************************************************
  'transfer the input data from channel 1-8 to an array
  'card : module-address
  'array: destination array 
  'index: startindex in the destination array
  '****************************************************************************
  SUB P2_READ_ADCF8_24B(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33400000h) OR shift_left(card,16)),7)
      READ_FAST_BUS(array[index],8)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '****************************************************************************
  'transfer the input data from channel 1-4 to an array
  'card : module-address
  'array: destination array 
  'index: startindex in the destination array
  '****************************************************************************
  SUB P2_READ_ADCF4_24B(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33300000h) OR shift_left(card,16)),0)
      READ_FAST_BUS(array[index],4)
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '****************************************************************************
  'sub set the input range 
  'card: module-address
  'channel 1-8
  'mode=0 range -10 V -> +10 V
  'mode=1 range -5V   -> + 5 V
  'mode=2 range -2.5V -> + 2.5 V
  'mode=3 range -1.25 -> + 1.25 V
  '****************************************************************************
  SUB P2_SET_GAIN(card,channel,mode)
    CHECK_CARD(card)
    POKE_FAST_BUS(((328051FFh+channel) OR shift_left(card,16)),mode)
  ENDSUB


  '****************************************************************************
  'sub set the input mode 
  'card_pattern: bit pattern to set the module adresses
  'bit 0 = auto mode ON
  'bit 1 = channel multiplex
  'bit 2 = start_convf by extern event (d-sub only)  
  '****************************************************************************
  SUB P2_ADCF_MODE(card_pattern,mode) 
    DIM startdelay AS LONG
    DIM delaymod AS LONG
    DIM old AS LONG
    dim card as long
    dim time as long
   
    SUB_BEGIN_CRITICAL_SECTION
      poke_fast_bus(32902000h, card_pattern)   '   Autosample off
      poke_fast_bus(32100000h, 0)                                                                         
    SUB_END_CRITICAL_SECTION
   
    for card=1 to 15
      if (card_pattern AND shift_left(1,card-1)>0) then
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS((33800055h OR shift_left(card,16)),0)
          READ_FAST_BUS(time,1)
        SUB_END_CRITICAL_SECTION
        time=(time/3.3333333)
        startdelay=globaldelay-time'100 conversion time F8/18
        if (startdelay<0) then startdelay=0
        if (mode AND 2>0) then 'channel multiplex on/off
          delaymod=globaldelay/2
          POKE_FAST_BUS(((32805045h) OR shift_left(card,16)),1)     
        else
          delaymod=globaldelay
          POKE_FAST_BUS(((32805045h) OR shift_left(card,16)),0)     
        endif       
   
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS((33804800h OR shift_left(card,16)),0)
          READ_FAST_BUS(old,1)
        SUB_END_CRITICAL_SECTION
  
        if (mode AND 4>0) then 'start_convf by event
          old =(old AND 0FFFEFFFFH) or 65536
        else 
          old =(old AND 0FFFEFFFFH)  
        endif
        POKE_FAST_BUS((32804800h OR shift_left(card,16)),old)
        POKE_FAST_BUS(((32805030h) OR shift_left(card,16)),6)  'Prescale T11 300 MHz -> 20 ns 
        POKE_FAST_BUS(((32805035h) OR shift_left(card,16)),startdelay)       
        POKE_FAST_BUS(((32805040h) OR shift_left(card,16)),delaymod) 
      
        SUB_BEGIN_CRITICAL_SECTION 'sync clear!!!
         POKE_FAST_BUS((33804000h OR shift_left(card,16)),0)
         READ_FAST_BUS(old,1)
        SUB_END_CRITICAL_SECTION
      endif
    next
    SUB_BEGIN_CRITICAL_SECTION
      poke_fast_bus(32902000h, card_pattern)   '   Autosample off
      poke_fast_bus(32100000h, (mode AND 1))                                                                      
    SUB_END_CRITICAL_SECTION
    IF (mode AND 1>0) then cpu_sleep(40)
  ENDSUB


  '****************************************************************************
  ' ADCF 
  '****************************************************************************
  ' card : module adress
  ' channel: channel (1-8)
  ' valueHIGH switch point to set limit overflow bit to 1
  ' valueLOW switch point to set limit underflow bit to 1
  '****************************************************************************
  SUB P2_ADCF_SET_LIMIT(card,channel,valueHigh,valueLow)
    CHECK_CARD(card)
    POKE_FAST_BUS(((328055FFh+channel) OR shift_left(card,16)),valueHigh)  
    POKE_FAST_BUS(((328054FFh+channel) OR shift_left(card,16)),valuelow)  
  ENDSUB
  
  
  '****************************************************************************
  'the sub reads the limit-overrun and -underrun flags of all FADC
  ' card : module-address
  '****************************************************************************
  FUNCTION P2_ADCF_READ_LIMIT(card) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33007030h) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_ADCF_READ_LIMIT,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '****************************************************************************
  'card : modul address
  '       mode=0 Filter off
  '            1 2'er
  '            2 4'er
  '            3 8
  '            4 16
  '            5 32
  '****************************************************************************
  SUB P2_SET_AVERAGE_FILTER(card,mode)
    CHECK_CARD(card)
    if (mode=0) then
      POKE_FAST_BUS((32805000h OR shift_left(card,16)),1)' stop 
    else
      POKE_FAST_BUS((32805000h OR shift_left(card,16)),2)' start
      POKE_FAST_BUS((32805005h OR shift_left(card,16)),mode-1)'filter 
    endif
  ENDSUB

        
  '******************************************************************************
  'Sub is setting the parameters of the burst mode
  'card : modul address
  'channel_Select=1 Sample Channel 1 
  '              =3 Sample Channel 1+2 
  '              =15 Sample Channel 1+2+3+4
  '              =255 Sample Channel 1+2+3+4+5+6+7+8
  
  'Ramstart: startadr ram
  'length_per_channel
  'sampleperiode (n*20 ns)
  
  'trigger_mode
  '              Bit 0 x
  '              Bit 1 0 Single 1 Continiuous
  '              Bit 2 0 Sync 1 Event 
  '******************************************************************************
  SUB P2_BURST_INIT (card,channel_Select,Ramstart,length_per_channel,sample_period,trigger_mode)
    dim ch_count as float
    dim ramend as long   
    dim i as long
    dim len as long

    CHECK_CARD(card)
    ch_count=0
    for i=0 to 7
      if (channel_select AND (Shift_left(1,i)) >0) then inc ch_count
    next
          
    ch_count=ch_count*0.5 *length_per_channel
    ramend=ramstart+ch_count
          
    #IF DEBUG_MODE=ON THEN
      if (ch_count=1) then
        if (length_per_channel AND 7>0) then PROZESS_FEHLER=200102  ':8
      else
        if (length_per_channel AND 3>0) then PROZESS_FEHLER=200101  ':4
      endif             
      if (ramstart AND 3>0) then PROZESS_FEHLER=200100  
    #ENDIF
    POKE_FAST_BUS((32805060h OR shift_left(card,16)),128)' stop /clear   
    POKE_FAST_BUS((32805061h OR shift_left(card,16)),Ramstart)     
    POKE_FAST_BUS((32805062h OR shift_left(card,16)),ramend-1)   
    POKE_FAST_BUS((32805064h OR shift_left(card,16)),channel_Select)      
    POKE_FAST_BUS((32805065h OR shift_left(card,16)),sample_period)      
    POKE_FAST_BUS((32805060h OR shift_left(card,16)),trigger_mode or 1)' +start
  ENDSUB

  '******************************************************************************
  'Sub start the burst measurement
  'card_pattern: bit pattern to set the module adresses
  '******************************************************************************
  SUB P2_BURST_START(card_pattern)
    SUB_BEGIN_CRITICAL_SECTION
      poke_fast_bus(32902100h, card_pattern)   '   Autosample off
      poke_fast_bus(32100000h, 1)                                                                         
    SUB_END_CRITICAL_SECTION
  ENDSUB

  '******************************************************************************
  'Sub stop the burst measure  
  'card_pattern: bit pattern to set the module adresses
  '******************************************************************************
  SUB P2_BURST_STOP(card_pattern) 
    SUB_BEGIN_CRITICAL_SECTION
      poke_fast_bus(32902100h, card_pattern)   '   Autosample off
      poke_fast_bus(32100000h, 0)                                                                         
    SUB_END_CRITICAL_SECTION
  ENDSUB

  '******************************************************************************
  'Sub Reset burst mode
  'card_pattern: bit pattern to set the module adresses
  '******************************************************************************
  SUB P2_BURST_RESET(card_pattern)        
    SUB_BEGIN_CRITICAL_SECTION
      poke_fast_bus(32902100h, card_pattern)   '   Autosample off
      poke_fast_bus(32100000h, 2)                                                                         
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  'Function  returns the sample position  
  'card : module-address
  '******************************************************************************
  Function P2_BURST_READ_INDEX(card) AS LONG
    dim status[4] as long
          
    CHECK_CARD(card)
    '1 status, 2 start, 3 end, 4 aktuell
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33B05060H) OR shift_left(card,16)),0)
      READ_FAST_BUS(status[1],4)
    SUB_END_CRITICAL_SECTION
    P2_BURST_READ_INDEX=status[4]
  ENDFUNCTION


  '******************************************************************************
  'function reads the progress of the burst measure
  'return value: number of convertions to do
  'card : module-address
  '******************************************************************************
  Function P2_BURST_STATUS(card) AS LONG
    dim status[5] as long
    dim ch_count as long
    dim i as long
          
    CHECK_CARD(card)
    '1 status, 2 start, 3 end, 4 aktuell 5 select
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33B05060H) OR shift_left(card,16)),0) '
      POKE_FAST_BUS((33805064h OR shift_left(card,16)),0)'ch_select
      READ_FAST_BUS(status[1],5)
    SUB_END_CRITICAL_SECTION
    ch_count=0
    for i=0 to 7
      if (status[5] AND (Shift_left(1,i)) >0) then inc ch_count
    next  
    P2_BURST_STATUS=(status[3]-status[4]+1)*2/ch_count
  ENDFUNCTION


  '******************************************************************************
  'transfer data to Modul
  'card : module-address
  'length: number of values
  'ramadr: startadr. ram
  'array: source array
  'array_startindex: startindex in the source array
  'performance 1=low
  '            2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_WRITE(card,length,ramadr,array[],arraystartindex,performance)
    dim ilen as long
    dim iindex as long
    dim pointer as long
    dim maxburst as long
    dim anzcount as long
           
    #IF PRIORITAET = LOW
      maxburst=128
      if (performance=1) then maxburst=8
      if (performance=3) then maxburst=1024
    #ELSE 
      maxburst=32768       
    #ENDIF       
           
    CHECK_CARD(card)      
    POKE_FAST_BUS(32007080h or (shift_left(card,16)),ramadr AND 0FFFFFFFCH) 
    POKE_FAST_BUS(3200FFF0h,00000004h) 
    ilen=length AND 0FFFFFFFCH
    iindex=arraystartindex 
  
    #IF DEBUG_MODE=ON THEN
      if (length AND 3>0) then PROZESS_FEHLER=200141  ':4
      if (ramadr AND 3>0) then PROZESS_FEHLER=200140
    #ENDIF
  
    if (ilen>0) then
      do 
        if (ilen>maxburst) then
          anzcount=maxburst
        else
          anzcount=ilen
        endif
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS(32407090h or (shift_left(card,16)),anzcount) ' x er Burst write
          ilen=ilen-anzcount
          Write_Fast_Bus(array[iindex],anzcount)              
        SUB_END_CRITICAL_SECTION
        iindex=iindex+anzcount        
      until (ilen=0)
    endif
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array
  'card : module-address
  'length: number of values
  'ramadr: startadr. ram
  'array: destination array
  'array_startindex: startindex in the destination array
  'performance 1=low
  '            2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_READ(card,length,ramadr,array[],arraystartindex,performance) 
    dim ilen as long
    dim iindex as long     
    dim maxburst as long
    dim anzcount as long
           
    #IF PRIORITAET = LOW
      maxburst=128
      if (performance=1) then maxburst=8
      if (performance=3) then maxburst=1024
    #ELSE 
      maxburst=32768         
    #ENDIF        
   
    CHECK_CARD(card)
    POKE_FAST_BUS(32007085h or (shift_left(card,16)),ramadr  AND 0FFFFFFFCH) 
    POKE_FAST_BUS(3200FFF0h,00000004h)    ' wait until FIFO empty
    ilen=length AND 0FFFFFFFCH
           
    #IF DEBUG_MODE=ON THEN
      if (length AND 3>0) then PROZESS_FEHLER=200121  ':4
      if (ramadr AND 3>0) then PROZESS_FEHLER=200120  
    #ENDIF
  
    iindex=arraystartindex 
    if (ilen>0) then
      do 
        if (ilen>maxburst) then
          anzcount=maxburst
        else
          anzcount=ilen
        endif
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS((33407090h) or (shift_left(card,16)),anzcount-1)           ' x 'er burst 
          ilen=ilen-anzcount
          READ_FAST_BUS(array[iindex],anzcount)
        SUB_END_CRITICAL_SECTION
        iindex=iindex+anzcount     
      until (ilen=0)
    endif         
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module-address
  'length: number of values
  'ramadr: startadr. ram
  'array: destination array
  'array_startindex: startindex in the destination array
  'performance 1=low
  '            2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_READ_UNPACKED1(card,length,ramadr,array[],arraystartindex,performance) 
    dim ilen as long
    dim iindex as long     
    dim maxburst as long
    dim anzcount as long
           
    #IF PRIORITAET = LOW
      maxburst=128
      if (performance=1) then maxburst=8
      if (performance=3) then maxburst=1024
    #ELSE 
      maxburst=32768       
    #ENDIF       
    
    CHECK_CARD(card)
    POKE_FAST_BUS(32007085h or (shift_left(card,16)),ramadr) 
    POKE_FAST_BUS(3200FFF0h,00000004h)   ' wait until FIFO empty
    ilen=length AND 0FFFFFFF8H 'Number of values is divisible by 8 ?
    ilen=ilen *0.5
    iindex=arraystartindex 
    
    #IF DEBUG_MODE=ON THEN
      if (length AND 7>0) then PROZESS_FEHLER=200123  ':8    
      if (ramadr AND 3>0) then PROZESS_FEHLER=200120
    #ENDIF
                  
    if (ilen>0) then            
      do 
        if (ilen>maxburst) then
          anzcount=maxburst
        else 
          anzcount=ilen
        endif
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS((33407090h) or (shift_left(card,16)),anzcount-1)' x 'er burst 
          ilen=ilen-anzcount
          READ_FAST_BUS_unpacked1(array[iindex],anzcount)
        SUB_END_CRITICAL_SECTION
        iindex=iindex+anzcount*2
      until (ilen=0)
    endif
  ENDSUB
         
         
  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module-address
  'length: number of values per channel
  'ramadr: startadr. ram
  'array: destination array low channel
  'array2: destination array high channel
  'array_startindex: startindex in the destination array
  'performance 1=low
  '            2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_READ_UNPACKED2(card,length,ramadr,array[],array2[],arraystartindex,performance) 
    dim ilen as long
    dim iindex as long      
    dim maxburst as long
    dim anzcount as long
           
    #IF PRIORITAET = LOW
      maxburst=128
      if (performance=1) then maxburst=16
      if (performance=3) then maxburst=1024
    #ELSE 
      maxburst=32768       
    #ENDIF        
     
    CHECK_CARD(card)      
    POKE_FAST_BUS(32007085h or (shift_left(card,16)),ramadr) 
    POKE_FAST_BUS(3200FFF0h,00000004h) ' wait until FIFO empty
    ilen=length 
    ilen=ilen AND 0FFFFFFFCH '/4
     
    #IF DEBUG_MODE=ON THEN
      if (length AND 3>0) then PROZESS_FEHLER=200124  ':8
      if (ramadr AND 3>0) then PROZESS_FEHLER=200120
    #ENDIF
    iindex=arraystartindex 
    if (ilen>0) then
      do
        if (ilen>maxburst) then
          anzcount=maxburst
        else
          anzcount=ilen
        endif
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS((33407090h) or (shift_left(card,16)),anzcount-1)
          ilen=ilen-anzcount
          READ_FAST_BUS_unpacked2(array[iindex],array2[iindex],anzcount)
        SUB_END_CRITICAL_SECTION
        iindex=iindex+anzcount
      until (ilen=0)
    endif
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module address
  'length: number of values per channel
  'ramadr: startadr. ram
  'array1: destination array channel 1
  'array2: destination array channel 2
  'array3: destination array channel 3
  'array4: destination array channel 4
  'array_startindex: startindex in the destination array
  'performance 1=low
  '            2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_READ_UNPACKED4(card,length,ramadr,array1[],array2[],array3[],array4[],arraystartindex,performance) 
     
    dim ilen as long
    dim iindex as long     
    dim maxburst as long
    dim anzcount as long
                   
    #IF PRIORITAET = LOW
      maxburst=128
      if (performance=1) then maxburst=16
      if (performance=3) then maxburst=1024
    #ELSE 
      maxburst=32768        
    #ENDIF       
          
    CHECK_CARD(card)
    POKE_FAST_BUS(32007085h or (shift_left(card,16)),ramadr) 
    POKE_FAST_BUS(3200FFF0h,00000004h)   ' wait until FIFO empty
    ilen=length 
    ilen=ilen AND 0FFFFFFFEH '/2
    ilen=ilen*2
     
    #IF DEBUG_MODE=ON THEN
      if (length AND 1>0) then PROZESS_FEHLER=200125  ':2 
      if (ramadr AND 3>0) then PROZESS_FEHLER=200120
    #ENDIF
    iindex=arraystartindex 
    if (ilen>0) then 
      do
        if (ilen>maxburst) then
          anzcount=maxburst
        else
          anzcount=ilen
        endif
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS((33407090h) or (shift_left(card,16)),anzcount-1)
          ilen=ilen-anzcount
          READ_FAST_BUS_unpacked4(array1[iindex],array2[iindex],array3[iindex],array4[iindex],anzcount)
          iindex=iindex+anzcount*0.5
        SUB_END_CRITICAL_SECTION
      until (ilen=0)
    endif
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module-address
  'length: number of values per channel
  'ramadr: startadr. ram
  'ar1: destination array channel 1
  'ar2: destination array channel 2
  'ar3: destination array channel 3
  'ar4: destination array channel 4
  'ar5: destination array channel 5
  'ar6: destination array channel 6
  'ar7: destination array channel 7
  'ar8: destination array channel 8
  'array_startindex: startindex in the destination array
  'performance 1=low
  '            2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_READ_UNPACKED8(card,length,ramadr,ar1[],ar2[],ar3[],ar4[],ar5[],ar6[],ar7[],ar8[],arraystartindex,performance) 
    dim ilen as long
    dim iindex as long     
    dim maxburst as long
    dim anzcount as long
                          
    #IF PRIORITAET = LOW
      maxburst=128   
      if (performance=1) then maxburst=16
      if (performance=3) then maxburst=1024
    #ELSE 
      maxburst=32768       
    #ENDIF       
    
		CHECK_CARD(card)
		POKE_FAST_BUS(32007085h or (shift_left(card,16)),ramadr) 
    POKE_FAST_BUS(3200FFF0h, 00000004h)  ' wait until FIFO empty
    ilen=length*4
    iindex=arraystartindex 
    #IF DEBUG_MODE=ON THEN       
      if (ramadr AND 3>0) then PROZESS_FEHLER=200120
    #ENDIF
    if (ilen>0) then 
      do
        if (ilen>maxburst) then
          anzcount=maxburst
        else               
          anzcount=ilen
        endif
        SUB_BEGIN_CRITICAL_SECTION
          POKE_FAST_BUS((33407090h) or (shift_left(card,16)),anzcount-1)
          ilen=ilen-anzcount
          READ_FAST_BUS_UNPACKED8(ar1[iindex],ar2[iindex],ar3[iindex],ar4[iindex],ar5[iindex],ar6[iindex],ar7[iindex],ar8[iindex],anzcount)
          iindex=iindex+anzcount*0.25
        SUB_END_CRITICAL_SECTION
      until (ilen=0)
    endif        
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module-address
  'length: number of values per channel
  'array: destination array 
  'array_startindex: startindex in the destination array
  'performance 1=low
  '            2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_CREAD_UNPACKED1(card,length,array[],arraystartindex,performance) 
    dim status[4] as long  '1 status, 2 start, 3 end, 4 aktuell
    dim le as long
    dim diff as long
    dim leb[2] as long
    dim startb[2] as long
    dim indexb[2] as long
    dim count as long
    dim i as long
    
		CHECK_CARD(card)     
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33B05060H) OR shift_left(card,16)),0)
      READ_FAST_BUS(status[1],4)
    SUB_END_CRITICAL_SECTION
    le=length/2 'long word
    status[4]=status[4]-4
    if (status[4]<status[2]) then status[4]=status[3]-3
    diff=status[4]-le 'write pointer - length32  
    if (diff>=status[2]) then 'diff> start => no overflow
      count=1     
      startb[1]=diff
      indexb[1]=arraystartindex
      leb[1]=le
    else 'overflow
      count=2                     
      leb[1]=status[2]-diff
      startb[1]=status[3]-leb[1]+1
      indexb[1]=arraystartindex
                  
      leb[2]=le-leb[1]
      startb[2]=status[2]
      indexb[2]=arraystartindex+leb[1]*2                          
    endif 
    for i=1 to count 
      P2_BURST_READ_UNPACKED1(card,(leb[i]*2),startb[i],array,indexb[i],performance)   
    next
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module-address
  'length: number of values per channel
  'array1: destination array low channel
  'array2: destination array high channel
  'array_startindex: startindex in the destination array
  'performance 1=low
  '                                                2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_CREAD_UNPACKED2(card,length,array1[],array2[],arraystartindex,performance) 
    dim status[4] as long  '1 status, 2 start, 3 end, 4 aktuell
    dim le as long
    dim diff as long
    dim leb[2] as long
    dim startb[2] as long
    dim indexb[2] as long
    dim count as long
    dim i as long
    
		CHECK_CARD(card)              
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33B05060H) OR shift_left(card,16)),0)
      READ_FAST_BUS(status[1],4)
    SUB_END_CRITICAL_SECTION
    le=length 'long word
    status[4]=status[4]-4
    if (status[4]<status[2]) then status[4]=status[3]-3
    diff=status[4]-le 'write pointer - length32
    if (diff>=status[2]) then 'diff> start => no overflow
      count=1     
      startb[1]=diff
      indexb[1]=arraystartindex
      leb[1]=le
    else 'overflow
      count=2                     
      leb[1]=status[2]-diff
      startb[1]=status[3]-leb[1]+1
      indexb[1]=arraystartindex
      leb[2]=le-leb[1]
      startb[2]=status[2]
      indexb[2]=arraystartindex+leb[1] '*2        
    endif 
    for i=1 to count 
      P2_BURST_READ_UNPACKED2(card,leb[i],startb[i],array1,array2,indexb[i],performance)   
    next
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module-address
  'length: number of values per channel
  'array1: destination array channel 1
  'array2: destination array channel 2
  'array3: destination array channel 3
  'array4: destination array channel 4
  'array_startindex: startindex in the destination array
  'performance 1=low
  '                                                2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_CREAD_UNPACKED4(card,length,array1[],array2[],array3[],array4[],arraystartindex,performance) 
    dim status[4] as long  '1 status, 2 start, 3 end, 4 aktuell
    dim le as long
    dim diff as long
    dim leb[2] as long
    dim startb[2] as long
    dim indexb[2] as long
    dim count as long
    dim i as long
    
		CHECK_CARD(card)              
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33B05060H) OR shift_left(card,16)),0)
      READ_FAST_BUS(status[1],4)
    SUB_END_CRITICAL_SECTION
    le=length 'long word
    le=le*2
    status[4]=status[4]-4
    if (status[4]<status[2]) then status[4]=status[3]-3
    diff=status[4]-le 'write pointer - length32
    if (diff>=status[2]) then 'diff> start => no overflow
      count=1     
      startb[1]=diff
      indexb[1]=arraystartindex
      leb[1]=le
    else 'overflow
      count=2                     
      leb[1]=status[2]-diff
      startb[1]=status[3]-leb[1]+1
      indexb[1]=arraystartindex
      leb[2]=le-leb[1]
      startb[2]=status[2]
      indexb[2]=arraystartindex+leb[1]*0.5                
    endif 
    for i=1 to count 
      P2_BURST_READ_UNPACKED4(card,(leb[i]/2),startb[i],array1,array2,array3,array4,indexb[i],performance)          
    next
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array and unpacked 
  'card : module-address
  'length: number of values per channel
  'ar1: destination array channel 1
  'ar2: destination array channel 2
  'ar3: destination array channel 3
  'ar4: destination array channel 4
  'ar5: destination array channel 5
  'ar6: destination array channel 6
  'ar7: destination array channel 7
  'ar8: destination array channel 8
  'array_startindex: startindex in the destination array
  'performance 1=low
  '                                                2=medium
  '            3=fast
  '******************************************************************************
  SUB P2_BURST_CREAD_UNPACKED8(card,length,ar1[],ar2[],ar3[],ar4[],ar5[],ar6[],ar7[],ar8[],arraystartindex,performance) 
    dim status[4] as long  '1 status, 2 start, 3 end, 4 aktuell
    dim le as long
    dim diff as long
    dim leb[2] as long
    dim startb[2] as long
    dim indexb[2] as long
    dim count as long
    dim i as long
    
		CHECK_CARD(card)              
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33B05060H) OR shift_left(card,16)),0)
      READ_FAST_BUS(status[1],4)
    SUB_END_CRITICAL_SECTION
    le=length 'long word
    le=le*4
    status[4]=status[4]-4
    if (status[4]<status[2]) then status[4]=status[3]-3
    diff=status[4]-le 'write pointer - length32
    if (diff>=status[2]) then 'diff> start => no overflow
      count=1     
      startb[1]=diff
      indexb[1]=arraystartindex
      leb[1]=le
    else 'overflow
      count=2                     
      leb[1]=status[2]-diff
      startb[1]=status[3]-leb[1]+1
      indexb[1]=arraystartindex
      leb[2]=le-leb[1]
      startb[2]=status[2]
      indexb[2]=arraystartindex+leb[1]*0.25               
    endif 
    for i=1 to count 
      P2_BURST_READ_UNPACKED8(card,(leb[i]/4),startb[i],ar1,ar2,ar3,ar4,ar5,ar6,ar7,ar8,indexb[i],performance)        
    next
  ENDSUB


  '********************************** AIN MUX ***********************************
  
  '******************************************************************************
  ' Start conversion of ADC.
  ' card: module-address
  '******************************************************************************
  SUB P2_START_CONV(card)
    CHECK_CARD(card)
    POKE_FAST_BUS((32007000h OR shift_left(card,16)),1)
  ENDSUB
  
  
  '******************************************************************************
  ' Wait until EOC-signal goes active (End Of Conversion).
  ' card: module-address
  '******************************************************************************
  SUB P2_WAIT_EOC(card)
    DIM reminder AS LONG
   
    CHECK_CARD(card)
    DO
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33007010h OR shift_left(card,16)),0)
        READ_FAST_BUS(reminder,1)
      SUB_END_CRITICAL_SECTION
    UNTIL ((reminder AND 1)=0) 
  ENDSUB


  '******************************************************************************
  ' Selects single-ended (s.e.) or differential (diff.) inputs
  ' for the AIN-32/12-module only.
  ' card: module-address
  ' mode: s.e. -> 0,  diff. -> 1 (default after power-up)
  '******************************************************************************
  SUB P2_SE_DIFF(card,mode)
    CHECK_CARD(card)
    POKE_FAST_BUS((32805012h OR shift_left(card,16)),mode)
  ENDSUB
  
  
  '******************************************************************************
  ' Set MUX to desired input channel.
  ' card:   module-address
  ' select: bit 9 & 8 -> gain,  bit 4...0 -> channel 1...32
  '******************************************************************************
  SUB P2_SET_MUX(card,select)
    CHECK_CARD(card)
    POKE_FAST_BUS((32805010h OR shift_left(card,16)),select)
  ENDSUB
  
  
  '******************************************************************************
  ' Returns conversion result of ADC 
  ' card:   module-address
  ' result: 16 bit integer
  '******************************************************************************
  FUNCTION P2_READ_ADC(card) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33000200h) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADC,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  ' Returns conversion result of ADV
  ' card:   module-address
  ' result: 24 bit integer
  '******************************************************************************
  FUNCTION P2_READ_ADC24(card) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33000000h) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADC24,1)
    SUB_END_CRITICAL_SECTION 
  ENDFUNCTION


  '******************************************************************************
  ' Samples, converts and reads out the digital ADC-value of an
  ' analog input.
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' ! Attention:                                                                !
  ' ! This instruction is not prepared to handle an access from                 !
  ' ! a low AND high priority process to the same module.                       !
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 16 bit integer
  '******************************************************************************
  FUNCTION P2_ADC(card,ADC_No) AS LONG
    DIM reminder AS LONG
    DIM muxtime AS LONG
          
    '............ set MUX ............
    CHECK_CARD(card)
    POKE_FAST_BUS((32805010h OR shift_left(card,16)),ADC_No-1)
          
    '............ wait multiplexer settling time ........
    SUB_BEGIN_CRITICAL_SECTION  'wait depending on hardware
      POKE_FAST_BUS((33805022h OR shift_left(card,16)),0)
      READ_FAST_BUS(muxtime,1) ' step 20 ns
    SUB_END_CRITICAL_SECTION
  
    if ((muxtime>6) AND (muxtime<12345678H)) then 
      P2_SLEEP(shift_left(muxtime,2))
    endif
          
    '............ start conversion ............
    POKE_FAST_BUS((32007000h OR shift_left(card,16)),1)
          
    '............ wait EOC ............
    do
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33007010h OR shift_left(card,16)),0)
        READ_FAST_BUS(reminder,1)
      SUB_END_CRITICAL_SECTION
    until ((reminder AND 1)=0) 
    
     '............ read out result ............
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33000200h) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_ADC,1)
    SUB_END_CRITICAL_SECTION 
  ENDFUNCTION


  '******************************************************************************
  ' Samples, converts and reads out the digital ADC-value of an
  ' analog input.
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' ! Attention:                                                                !
  ' ! This instruction is not prepared to handle an access from                 !
  ' ! a low AND high priority process to the same module.                       !
  ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ' card:   module-address
  ' ADC_No: channel number of analog input
  ' result: 24 bit integer
  '******************************************************************************
  FUNCTION P2_ADC24(card,ADC_No) AS LONG
    DIM reminder AS LONG
    DIM muxtime AS LONG
          
    '............ set MUX ............
    CHECK_CARD(card)
    POKE_FAST_BUS((32805010h OR shift_left(card,16)),ADC_No-1)
          
    '............ wait multiplexer settling time ........
    SUB_BEGIN_CRITICAL_SECTION  'wait depending on hardware
      POKE_FAST_BUS((33805022h OR shift_left(card,16)),0)
      READ_FAST_BUS(muxtime,1) ' step 20 ns
    SUB_END_CRITICAL_SECTION
  
    if ((muxtime>6) AND (muxtime<12345678H)) then 
      P2_SLEEP(shift_left(muxtime,2))
    endif
  
    '............ start conversion ............
    POKE_FAST_BUS((32007000h OR shift_left(card,16)),1)
          
    '............ wait EOC ............
    do
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33007010h OR shift_left(card,16)),0)
        READ_FAST_BUS(reminder,1)
      SUB_END_CRITICAL_SECTION
    until ((reminder AND 1)=0) 
  
    '............ read out result ............
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33000000h) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_ADC24,1)
    SUB_END_CRITICAL_SECTION 
  ENDFUNCTION


  '******************************************************************************
  ' Returns conversion result of ADC and starts immediately
  ' a new conversion.
  ' card:   module-address
  ' result: 16 bit long
  '******************************************************************************
  FUNCTION P2_READ_ADC_SCONV(card) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33000300h) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADC_SCONV,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  ' Returns conversion result of ADC and starts immediately
  ' a new conversion.
  ' card:   module-address
  ' result: 24 bit long
  '******************************************************************************
  FUNCTION P2_READ_ADC_SCONV24(card) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((33000100h) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_READ_ADC_SCONV24,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  'transfer the input data to an array (16 Bit long)
  'card : dip switch address
  'length: number of values (only even-numbered)
  'array: destination array 
  'index: startindex in the destination array
  '******************************************************************************
  SUB P2_SEQ_READ(card,length,array[],index)    
    CHECK_CARD(card)
    IF (length>1) then 
      SUB_BEGIN_CRITICAL_SECTION
        IF (length>9) THEN 
          POKE_FAST_BUS(((33400400H) or shift_left(card,16)),shift_right(length,1)-1) 
        ELSE 
          POKE_FAST_BUS((33000400H or shift_Left((length-2) AND 0FFFFFFEH,19)OR shift_left(card,16)),0)
        ENDIF
        READ_FAST_BUS_UNPACKED(array[index],shift_right(length,1)) 
      SUB_END_CRITICAL_SECTION
    ENDIF
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array (32 Bit long)
  'card : modul address
  'length: number of values / 2
  'array: destination array 
  'index: startindex in the destination array
  '****************************************************************************** 
  SUB P2_SEQ_READ_PACKED(card,length,array[],index)    
    CHECK_CARD(card)
    IF (length>0) then
      SUB_BEGIN_CRITICAL_SECTION
      IF (length>4) THEN 
        POKE_FAST_BUS(((33400400H) OR shift_left(card,16)),length-1)
      ELSE  
        POKE_FAST_BUS(((33000400H or shift_Left(length-1,20)) OR shift_left(card,16)),0)
      ENDIF
      READ_FAST_BUS(array[index],length)    
      SUB_END_CRITICAL_SECTION
    ENDIF
  ENDSUB


  '******************************************************************************
  'transfer the input data to an array (24 Bit long)
  'card : modul address
  'length: number of values 
  'array: destination array 
  'index: startindex in the destination array
  '******************************************************************************
  SUB P2_SEQ_READ24(card,length,array[],index)    
    CHECK_CARD(card)
    IF (length>0) then
      SUB_BEGIN_CRITICAL_SECTION
        IF (length>4) THEN 
          POKE_FAST_BUS(((33400000H) OR shift_left(card,16)),length-1)
        ELSE  
          POKE_FAST_BUS(((33000000H or shift_Left(length-1,20)) OR shift_left(card,16)),0)
        ENDIF
        READ_FAST_BUS(array[index],length)    
      SUB_END_CRITICAL_SECTION
    ENDIF
  ENDSUB


  '******************************************************************************
  'initialising the ain mode 
  'card : modul address
  'mode =0 normal Mode 
  '     =1 single shot mode
  '     =2 continuous mode Eventdelay
  '     =3 continuous mode max Speed
  'gain=0 range -10 V -> +10 V
  'gain=1 range -5V   -> + 5 V
  'gain=2 range -2.5V -> + 2.5 V
  'gain=3 range -1.25 -> + 1.25 V
  'channel :selected channels in binary
  'time 0=default time 
  'mux_time unit [20 ns]
  '******************************************************************************
  SUB P2_SEQ_INIT(card,mode,gain,channel,mux_time)
    
    dim i as long
    dim anz as long 
    dim delay as long
    dim imux as long
    dim startdelay as long
           
    CHECK_CARD(card)
    
    anz=0
    
		for i=0 to 31
      if (shift_left(1,i) AND channel>0) then inc anz
    next
    
		POKE_FAST_BUS((32007020h OR shift_left(card,16)),0) 'stop
    P2_SET_MUX(card,shift_left(gain,8))  'gain 
    POKE_FAST_BUS((32805045h OR shift_left(card,16)),channel) 'channel
    POKE_FAST_BUS((32805030h OR shift_left(card,16)),6) 'takt divisor
    
	
		if (mux_time<>0) then
      POKE_FAST_BUS((32805020h OR shift_left(card,16)),mux_time) 
      imux=mux_time
    else
      POKE_FAST_BUS((32805020h OR shift_left(card,16)),125) '2,5 s
      imux=125
    endif
    startdelay=globaldelay-((anz*imux*6)+700)
    p2_sleep(70)
		
		if (startdelay<0) then startdelay=0
      if (mode=3) then
      POKE_FAST_BUS((32805035h OR shift_left(card,16)),0)
      POKE_FAST_BUS((32805040h OR shift_left(card,16)),0)
      POKE_FAST_BUS((32007020h OR shift_left(card,16)),3) 'continous
    else
      POKE_FAST_BUS((32805035h OR shift_left(card,16)),startdelay/6) 'startdelay
      POKE_FAST_BUS((32805040h OR shift_left(card,16)),globaldelay) 'startdelay
      if (mode=2) then
        POKE_FAST_BUS((32007020h OR shift_left(card,16)),3) 'mode
					
					SUB_BEGIN_CRITICAL_SECTION 
            POKE_FAST_BUS((33804000h OR shift_left(card,16)),0)
            READ_FAST_BUS(i,1)
          SUB_END_CRITICAL_SECTION
      else
        POKE_FAST_BUS((32007020h OR shift_left(card,16)),mode) 'mode
      endif        
    endif
    
  ENDSUB


  '******************************************************************************
  'Start SEQ-Mode
  'card_pattern: bit pattern to set the module adresses
  '******************************************************************************
  SUB P2_SEQ_START(card_pattern)
    POKE_FAST_BUS(32801010h,card_pattern) '       
  ENDSUB


  '******************************************************************************
  ' Wait until SEQ
  ' card: module-address
  '******************************************************************************
  SUB P2_SEQ_WAIT(card)
    DIM reminder AS LONG

    CHECK_CARD(card)
    DO
      SUB_BEGIN_CRITICAL_SECTION
        POKE_FAST_BUS((33007010h OR shift_left(card,16)),0)
        READ_FAST_BUS(reminder,1)
      SUB_END_CRITICAL_SECTION
    UNTIL ((reminder AND 1)=0) 
  ENDSUB


  '******************************************************************************
  ' card : module-address
  ' nr=1 READ LIMIT channel 1-16
  ' nr=2 READ LIMIT channel 17-32
  '******************************************************************************
  FUNCTION P2_ADC_READ_LIMIT(card,nr) AS LONG
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
      POKE_FAST_BUS(((3300702Eh+nr*2) OR shift_left(card,16)),0)
      READ_FAST_BUS(P2_ADC_READ_LIMIT,1)
    SUB_END_CRITICAL_SECTION
  ENDFUNCTION


  '******************************************************************************
  ' card : module adress
  ' channe: channel (1-32)
  ' valueHIGH switch point to set limit overflow bit to 1
  ' valueLOW switch point to set limit underflow bit to 1
  '******************************************************************************
  SUB P2_ADC_SET_LIMIT(card,channel,valueHigh,valueLow)
   CHECK_CARD(card)
   POKE_FAST_BUS(((328055FFh+channel) OR shift_left(card,16)),valueHigh)  
   POKE_FAST_BUS(((328054FFh+channel) OR shift_left(card,16)),valuelow)  
  ENDSUB


  '********************************** DAC ***************************************
  '***********************' Convert the digitial value to an analog output ******
  ' card:   module-address (1..15)
  ' DAC_No: channel number of analog output (1..8)
  ' value:  output value (0..65535)
  '******************************************************************************
  SUB P2_DAC(card,DAC_No,value)
    CHECK_CARD(card)
    POKE_FAST_BUS(((320022FFh+DAC_NO) OR shift_left(card,16)),value)
  ENDSUB


  '******************************************************************************
  'transfer the output data from array to DAC 1-4 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_DAC4(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
    WRITE_FAST_BUS_PACKED(array[index],2,1,(32002500h or (shift_left(card,16))))
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  'transfer the output data from array to DAC 1-8 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_DAC8(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
    WRITE_FAST_BUS_PACKED(array[index],4,1,(32002500h or (shift_left(card,16))))  
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  ' Set DAC-register to desired value
  ' card:   module-address (1..15)
  ' DAC_No: channel number of analog output (1..8)
  ' value:  output value (0..65535)
  '******************************************************************************
  SUB P2_WRITE_DAC(card,DAC_No,value)
    CHECK_CARD(card)
    POKE_FAST_BUS(((320021FFh+DAC_No) OR shift_left(card,16)),value)
  ENDSUB


  ' *****************************************************************************
  ' Set DAC-register to desired value 
  ' card: module-address (1..15)
  ' DAC_No: 0 = Channel 1 and 2
  ' DAC_No: 1 = Channel 3 and 4
  ' DAC_No: 2 = Channel 5 and 6
  ' DAC_No: 3 = Channel 7 and 8
  ' value: output value 32Bit
  '******************************************************************************
  SUB P2_WRITE_DAC32(card,DAC_No,value)
    CHECK_CARD(card)
    POKE_FAST_BUS(((32002400h+DAC_NO) OR shift_left(card,16)),value)
  ENDSUB


  '******************************************************************************
  'transfer the output data from array 16 BIT to DAC-register 1-4 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_WRITE_DAC4(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
    WRITE_FAST_BUS_PACKED(array[index],2,1,(32002400h or (shift_left(card,16))))
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  'transfer the output data from array 16 BIT to DAC-register 1-8 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_WRITE_DAC8(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
    WRITE_FAST_BUS_PACKED(array[index],4,1,(32002400h or (shift_left(card,16))))
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  'transfer the output data from array 32 BIT to DAC-register 1-4 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_WRITE_DAC4_PACKED(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
     POKE_FAST_BUS(((32102400h) OR shift_left(card,16)),array[index])
     POKE_FAST_BUS(((32002400h) OR shift_left(card,16)),array[index+1])
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  'transfer the output data from array 32 BIT to DAC-register 1-8 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_WRITE_DAC8_PACKED(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
     POKE_FAST_BUS(((32302400h) OR shift_left(card,16)),array[index])
     POKE_FAST_BUS(((32002400h) OR shift_left(card,16)),array[index+1])
     POKE_FAST_BUS(((32002400h) OR shift_left(card,16)),array[index+2])
     POKE_FAST_BUS(((32002400h) OR shift_left(card,16)),array[index+3])
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  'transfer the output data from array 32 BIT to DAC-register 1-4 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_DAC4_PACKED(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
     POKE_FAST_BUS(((32102500h) OR shift_left(card,16)),array[index])
     POKE_FAST_BUS(((32002500h) OR shift_left(card,16)),array[index+1])
    SUB_END_CRITICAL_SECTION
  ENDSUB


  '******************************************************************************
  'transfer the output data from array 32 BIT to DAC-register 1-8 
  ' card:   module-address (1..15)
  ' array:  source array 
  ' index:  startindex in the source array
  '******************************************************************************
  SUB P2_DAC8_PACKED(card,array[],index)    
    CHECK_CARD(card)
    SUB_BEGIN_CRITICAL_SECTION
     POKE_FAST_BUS(((32302500h) OR shift_left(card,16)),array[index])
     POKE_FAST_BUS(((32002500h) OR shift_left(card,16)),array[index+1])
     POKE_FAST_BUS(((32002500h) OR shift_left(card,16)),array[index+2])
     POKE_FAST_BUS(((32002500h) OR shift_left(card,16)),array[index+3])
    SUB_END_CRITICAL_SECTION
  ENDSUB





  '******************************************************************************
  ' Simultaneously start conversion of all DAC on this module.
  ' card:   module-address (1..15)
  '******************************************************************************
  SUB P2_START_DAC(card)
    CHECK_CARD(card)
    POKE_FAST_BUS((32007002h OR shift_left(card,16)),0)
  ENDSUB
#else
  #error("This include file can only be used with the processor T11.")
#endif

