****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--L16
'
'###############################################################
'#                        ADWL16.inc                           #
'#              INCLUDE-file for ADwin-Light 16                #
'###############################################################
'#                                                             #
'# Contents: Include functions for ADwin-Light 16              #
'#                                                             #
'#  13.06.2002  MF   creation                                  #
'#  14.08.2002  JK   cntnr   ->  (cntnr)                       #
'#  02.11.2005  MF   Seq Mode       (only for L16 Rev B)       #
'#  26.01.2006  MF   SSI_*           (only L16 REV B / DIO_02) #
'#  26.01.2006  MF   DIGIN/OUT_LONG_E (only DIO_02 or DIO_03)  #
'#  24.02.2006  MF   L16_MODE         (only L16 REV B )        #
'#  29.03.2006  MF   SEQ_INIT         (only L16 REV B )        #
'#  23.08.2006  UR   LS-BUS                                    #
'#                                                             #
'#    Attention:                                               #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#                                                             #
'###############################################################

#define  enadrwr  204000dch      'wr 13            Address-table to access the hardware 
#define  enadrrd  204001dch      'wr 29
#define  rdcan    204000fch      'rd 15
#define  wrcan    204000fch      'wr 15
#define  rescan   204001fch      'rd 14

#if make_lib=off then
  dim can_msg[9] as integer         ' array with 9 elements 
#endif


'---------------------------------------------------------------
' If a low-priority process accesses a LS Bus Modul it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
SUB SUB_BEGIN_CRITICAL_SECTION() 
  #IF PRIORITAET = LOW
    BEGIN_CRITICAL_SECTION
  #ENDIF
ENDSUB
  
SUB SUB_END_CRITICAL_SECTION()
  #IF PRIORITAET = LOW
    END_CRITICAL_SECTION
  #ENDIF
ENDSUB


'***************************************************************
'***************** DIO on Light 16 extension *******************
'***************************************************************

'***************************************************************
' Initialisation of digital I/O   
' value : each bit corresponds to 8 bit
'     0 = input
'     1 = output
'***************************************************************
SUB CONF_DIO_E(value)
  Poke(2040046CH,value)
ENDSUB


'***************************************************************
' Reads the digital inputs (channel 0 - 15) 
'***************************************************************
FUNCTION DIGIN_WORD1_E() as long
  DIGIN_WORD1_E=peek(20400454H)
ENDFUNCTION


'***************************************************************
' Reads the digital inputs (channel 16 - 31) 
'***************************************************************
FUNCTION DIGIN_WORD2_E() as long
  DIGIN_WORD2_E=peek(20400464H)
ENDFUNCTION

'***************************************************************
' Reads the digital inputs (channel 0 - 31) 
' only DIO_02
'***************************************************************
FUNCTION DIGIN_LONG_E() as long
  DIGIN_LONG_E=peek(20400458H)
ENDFUNCTION


'***************************************************************
' Sets the digital outputs (channel 0 - 15) 
'***************************************************************
SUB DIGOUT_WORD1_E(value)
  Poke(20400454H,value)
ENDSUB

'***************************************************************
' Sets the digital outputs (channel 0 - 31) 
' only DIO_02 
'***************************************************************
SUB DIGOUT_LONG_E(value)
  Poke(20400458H,value)
ENDSUB


'***************************************************************
' Sets the digital outputs (channel 16 - 31) 
'***************************************************************
SUB DIGOUT_WORD2_E(value)
  Poke(20400464H,value)
ENDSUB


'***************************************************************
' Sets selected digital outputs (channel 0-15)
' set : Bitstring indicating the outputs which should be set
'***************************************************************
SUB DIGOUT_SET1_E(set)   'Set Register Bit 0-15
  Poke(20400474H,set)
ENDSUB


'***************************************************************
' Sets selected digital outputs (channel 16-31)
' set  : Bitstring indicating the outputs which should be set
'***************************************************************
SUB DIGOUT_SET2_E(set)   'Set Register Bit 16-31
  Poke(20400484H,set)
ENDSUB


'***************************************************************
' Resets selected digital outputs (channel 0-15)
' reset: Bitstring indicating the outputs which should be reset
'***************************************************************
SUB DIGOUT_RESET1_E(reset) 'Reset Register Bit 0-15
  Poke(20400494H,reset)
ENDSUB


'***************************************************************
' Resets selected digital outputs (channel 16-32)
' reset: Bitstring indicating the outputs which should be reset
'***************************************************************
SUB DIGOUT_RESET2_E(reset) 'Reset Register Bit 16 - 31
  Poke(204004A4H,reset)
ENDSUB



'***************************************************************
'************************ Counter ******************************
'***************************************************************

'***************************************************************
SUB CNT_CLEAR(CNTSELECT) 
  ' clear all counters selected with a bit 1
  poke(20400310h,CNTSELECT)
ENDSUB


' **************************************************************
SUB CNT_ENABLE(CNTSELECT) 
  ' enable all counters selected with a bit 1
  poke(20400300h,CNTSELECT)
ENDSUB


' **************************************************************
SUB CNT_MODE(CNTSELECT) 
  ' Select Counter-mode  (0 = CLK external, 1 = CLK internal(PWM))
  poke(20400340h,CNTSELECT)
ENDSUB


' **************************************************************
SUB CNT_SET(CNTSELECT) 
  ' Set Counter   (0 = 4fach, 1 = CLK/DIR)
  ' Set PWM-Counter Frequency (0 = 20 MHz, 1 = 5 MHz)
  poke(20400350h,CNTSELECT)
ENDSUB


' **************************************************************
SUB CNT_INPUTMODE(CNTSELECT) 
  ' Set Counterinputline   (0 = Clear counter, 1 = latch counter)
  poke(20400330h,CNTSELECT)
ENDSUB


' **************************************************************
SUB CNT_LATCH(CNTSELECT) 
  ' latch all counters selected with a Bit 1
  poke(20400320h,cntselect)
ENDSUB


' **************************************************************
FUNCTION CNT_READ(CNTNR) AS long
  ' performs a software-latch and reads the selected counter
  ' ATTENTION : this function may NOT be used, if the latch is
  '  done by an external signal (e.g. period-time or pulse 
  '  low/high-time measurements) !

  dim cadr as integer
  dim cntsel as integer

  cntsel = shift_left(1,(cntnr-1))
  poke(20400320h, cntsel)
  cadr = 204001F4h + (cntnr) * 16 ' parentheses bec.  i + 1
                                  ' could be passed as cntnr
  cnt_read = peek(cadr)
  ' (we do not need multiple reads, because for software
  '  latch the synchronisation is done by hardware.)
ENDFUNCTION


' **************************************************************
FUNCTION CNT_READLATCH(CNTNR) AS long
  ' reads the latch register triggerd by software-latch or 
  '  signal-rise (of an external signal)

  dim cadr as integer
  dim ih as integer

  cadr = 204001F4h + (cntnr) * 16 ' parentheses bec.  i + 1 
                                  ' could be passed as cntnr 
  cnt_readlatch = peek(cadr)

  ' case a : the latch register is triggered by a software- latch :
  ' ---------------------------------------------------------------
  ' In this case, there is no need for multiple reads, because 
  '  the synchronisation is done by hardware (see also the 
  '  comments at CNT_READ()). The following instructions are 
  '  not necessary, but they also do not harm (except wasting
  '  time). Therefore they are a potential for speed optimi-
  '  sations.
 
  ' case b : the latch register is triggered by an external signal :
  ' ----------------------------------------------------------------
  ' Check, if there was a (from an external signal triggered)
  '  LATCH just in the moment, when we read in the latch 
  '  register. (This is neccessary because this case is not
  '  handled by the hardware.)
  '  If we have this case, the second reading of the latch 
  '  register differs from the first reading and therefore 
  '  one of the readings may be corrupt. Read a third time to 
  '  be sure to have a valid reading. 
  '        The measured time for these three readings is 25 
  '        cycles = 625 ns   => the (period) time between two
  '        successive (external signal triggered) LATCHs may 
  '        NOT be shorter than this limit.
  '        => valid measurements (using this method with LATCH
  '        done by external signal) cannot be guaranteed for 
  '        smaller LATCH (period) times than 625 ns. (Longtime 
  '        tests were done and o.k. with 664 ns). To have a  
  '        safety margin for future changes in the ADbasic  
  '        compiler, our statement to the customer is the  
  '        limit of 1000 ns. 

  ih = peek(cadr)
  if (ih <> cnt_readlatch) then
    cnt_readlatch = peek(cadr)
  endif
ENDFUNCTION


'***************************************************************
FUNCTION CNT_READFLATCH(CNTNR) AS long
  ' reads the latch register triggerd by signal-falling edge
  dim cadr as integer
  dim ih as integer
  
  cadr = 204001F8h + (cntnr) * 16 ' parentheses bec.  i + 1 
                                  ' could be passed as cntnr 
  cnt_readflatch = peek(cadr)
  ' (please see comments to READLATCH)
  ih = peek(cadr)
  if (ih <> cnt_readflatch) then
    cnt_readflatch = peek(cadr)
  endif
ENDFUNCTION


'***************************************************************
' reads the status of a counter input 
'***************************************************************
FUNCTION CNT_GETSTATUS() AS long
  CNT_GETSTATUS = PEEK(20400370h)           
ENDFUNCTION


'***************************************************************
' enables the hardware clear input of a counter
' value : bitcombination ; each bit corresponds with counter
'***************************************************************
SUB CNT_CLEARENABLE(value) 
  dim value2 as long
  value2=value AND 0FH
  Poke(20400370H,value2)
endsub


'***************************************************************
'***************************** CAN *****************************
'***************************************************************
'Enables a message object for receiving messages.
'Disables all interrups of the message object.
'objectnumber : Number of the message object
'Identifier : incomming frames are accepted by this message object, if the identifier matches the frame identifier
'extended: Determines whether the identifier is 11 or 29 Bit
'      0 = 11 Bit Identifier  
'      1 = 29 Bit Identifier  
'***************************************************************
sub en_receive(objectnumber,identifier,extended)
  set_can_reg(objectnumber * 16, 149)
  if (extended = 0) then 
    set_can_reg(objectnumber * 16 + 6, 128)                         'read; DLC = 8 ; 11 Bit Identifier
    set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,3)and 255))  'Set Identifier
    set_can_reg(objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
  else
    set_can_reg(objectnumber * 16 + 6, 132)                         'read; DLC = 8 ; 29 Bit Identifier
    set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,21)and 255)) 'Set Identifier
    set_can_reg(objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
    set_can_reg(objectnumber * 16 + 4, (shift_right(identifier,5)and 255))  
    set_can_reg(objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
  endif
endsub


'***************************************************************
'Enables a message object for transmitting messages.
'Disables all interrups of the message object.
'objectnumber : Number of the message object
'Identifier : identifier for the frames which will be transmitted
'extended: Determines whether the identifier is 11 or 29 Bit 
'      0 = 11 Bit Identifier  
'      1 = 29 Bit Identifier  
'***************************************************************
sub en_transmit(objectnumber,identifier,extended)
  REM Message Objekt freigeben
  set_can_reg(objectnumber * 16, 149)
  if (extended = 0) then 
    set_can_reg(objectnumber * 16 + 6, 136)                         'write; DLC = 8 ; 11 Bit Identifier
    set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,3)and 255))  'Set Identifier
    set_can_reg(objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
  else
    set_can_reg(objectnumber * 16 + 6, 140)                         'write; DLC = 8 ; 29 Bit Identifier
    set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,21)and 255)) 'Set Identifier
    set_can_reg(objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
    set_can_reg(objectnumber * 16 + 4, (shift_right(identifier,5)and 255))  
    set_can_reg(objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
  endif
endsub


'***************************************************************
'Initialisation of the CAN-controller.
'All message objects will be disabled.
'Bitrat: 1MBit/s
'Acceptance filter : Must match
'***************************************************************
sub init_can()
  dim count as integer

  poke(rescan,1)          ' Reset the CAN-Controllers (Hardwarereset)
  sleep(10000)            'Resetpin mu mindestens 1 ms low sein
  poke(rescan,0)

  set_can_reg(0,65)       'Access to the registers of the controller only for CPU
  set_can_reg(2,65)     'CPU interface register
  set_can_reg(06h,0ffh) 'Setting all masks to "must match"
  set_can_reg(07h,0ffh)
  set_can_reg(08h,0ffh)
  set_can_reg(09h,0ffh)
  set_can_reg(0ah,0ffh)
  set_can_reg(0bh,0ffh)
  set_can_reg(0ch,0ffh)
  set_can_reg(0dh,0ffh)
  set_can_reg(0eh,0ffh)
  set_can_reg(0fh,0ffh)
  set_can_reg(01fh,0)     'Clock Out Register
  set_can_reg(02fh,0)     'Bus configuration register
  set_can_reg(03fh,0)     'Bit Timing register 0  
  set_can_reg(04fh,32)    ' Bit Timing register 1 

  for count = 1 to 15       'Disable all message objects
    set_can_reg(count * 16,85)
    set_can_reg(count * 16 + 1,85)
  next count 

  set_can_reg(0,0)          'Access to the registers of the controller only for Application 
endsub


'***************************************************************
'Function only for internal use.
'***************************************************************
function round_intern(value) as long
  dim buffer as float

  buffer = value + 0.5
  round_intern = buffer
endfunction


'***************************************************************
'Function only for internal use.
'***************************************************************
function int_check(fl,int) as long
  dim fbuffer as float

  fbuffer = fl-int
  if ((fbuffer >= 0.00001) or (fbuffer <= -0.00001)) then 
    int_check = 1       'not equal
  else
    int_check = 0       'equal
  endif
endfunction


'***************************************************************
'Function is setting the baudrate of the CAN-Bus.
'rate : CAN-Bus baudrate
'return value : 0 = baudrate is set 
'       1 = the selected baudrate is not set 
'***************************************************************

function set_can_baudrate(rate) as long
  dim scale as long
  dim fbuffer as float
  dim lbuffer as long
  dim back as long
  dim tseg1 as long  
  dim tseg2 as long  
  dim brp as long  
  dim btr0 as long  
  dim btr1 as long  

  set_can_baudrate = 0          'Initialisation
  fbuffer = 8000000 / rate
  scale = round_intern(fbuffer)       'total scale to achive the baudrate
  set_can_baudrate = int_check(fbuffer,scale) '1 if baudrate not possible
  if (set_can_baudrate = 0) then      'If baudrate possible then find settings
    brp = (scale - 1) / 25        'Prescaler

    do              'find the right brp
      fbuffer = (scale / (brp + 1) - 3)
      lbuffer = round_intern(fbuffer)
      back = int_check(fbuffer,lbuffer)   'inc prescaler until tseg1 + tseg 2 is an integer
      inc(brp)
    until((back = 0) or (fbuffer<5)) 
    dec(brp)
    if (back <> 0) then set_can_baudrate = 1
  endif

  if (set_can_baudrate = 0) then      'If there is a correct prescaler
    tseg2 = lbuffer * 0.4
    tseg1 = lbuffer - tseg2
    if (tseg2 > 7) then
      do
        dec(tseg2)
        inc(tseg1)
      until(tseg2 = 7)
    endif 
    btr0 = brp            'Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + shift_left(tseg2,4)    'one sampling each Bit
    set_can_reg(0,65)       'enable access to btr regisers
    set_can_reg(3fh,btr0)   'set btr0 regisers
    set_can_reg(4fh,btr1)   'set btr1 regisers
    set_can_reg(0,0)        'disable access to btr regisers
  endif
endfunction


'***************************************************************
'The function checks, if there is a new frame in the selected
'message object. If there is a new frame all databytes are read
'and then written to the array "can_msg".
'The number of dadabytes is written to the element 9 of the array "can_msg".
'The return value of the function is the identifier of the frame. 
'If there is no new frame in the message box the return value is -1.
'msg_nummer : number of the message object
'***************************************************************
function read_msg(msg_nummer) as integer
  dim new as integer                                           ' new message in the message object
  dim id0,id1,id2,id3 as integer                               ' Identifier Byte 0 und 1
  dim count as integer                                          
  dim buffer as integer                
  dim id_lenght as integer                                     ' buffer to distinguish 11 and 29 bit identifier

  new = get_can_reg(msg_nummer * 16 + 1) and 3                 'New Data Bit (check for new message)
  if (new =2) then                                             ' New frame is arrived
    buffer = get_can_reg(msg_nummer * 16 + 6)
    can_msg[9] = shift_right((buffer and 0f0h),4)              'nomber of data bytes
    id_lenght = buffer and 4
    id0 = get_can_reg(msg_nummer * 16 + 2)                     'Identifierbyte 0
    id1 = get_can_reg(msg_nummer * 16 + 3)                     'Identifierbyte 1
    if (id_lenght = 4) then
      id2 = get_can_reg(msg_nummer * 16 + 4)                   'Identifierbyte 2
      id3 = get_can_reg(msg_nummer * 16 + 5)                   'Identifierbyte 3
    endif

    for count = 1 to can_msg[9]                                ' reading databytes
      can_msg[count] = get_can_reg((msg_nummer * 16) +count+6)
    next count

    set_can_reg(msg_nummer * 16,0fdh)                     ' Reset the new data flag
    set_can_reg(msg_nummer * 16 +1,85) 
    if (id_lenght = 0) then
      read_msg = (shift_right(id1,5)) or (shift_left(id0,3))        ' return value = 11 bit identifier
    else
      read_msg = (shift_right(id3,3)) or (shift_left(id2,5)) or (shift_left(id1,13))  or (shift_left(id0,21))       ' return value = 29 bit identifier
    endif
  else
    read_msg = -1                                                  ' return value = -1
  endif
endfunction


'***************************************************************
'Transmitting a frame. 
'msg_nummer : number of the message object
'The databytes and the number of databytes have to be written in the
'array "can_msg" before this subroutine is activated.
'After this subroutine the frame is transmitted as soon as the 
'CAN-bus allows it.
'***************************************************************
SUB transmit(msg_num)
  dim buffer as integer
  dim count as integer

  for count = 1 to can_msg[9]
    set_can_reg((msg_num * 10h)+count+6,can_msg[count]) 'copy datas
  next count
  REM transfer nomber of data bytes
  buffer = get_can_reg((msg_num * 10h)+6)         'read register
  buffer = buffer and 0fh                         ' change DLC Bits 
  buffer = buffer or shift_left(can_msg[9],4)
  set_can_reg(msg_num *16 +6,buffer)           ' write register
  
  set_can_reg(msg_num * 16 +1, 102)' Control register (setting bit to transmit data)
ENDSUB


'***************************************************************
'Enable the interrupt of a message object.
'msg_nummer : number of the message object
'***************************************************************
SUB en_interrupt(msg_num)
  set_can_reg(msg_num * 16, 0ebh)
  set_can_reg(0, 02h)
ENDSUB


'***************************************************************
'Setting a register of the CAN-controller.
'register_no : register which should be set
'value : value which should be written to the register.
'***************************************************************
SUB set_can_reg(registernummer, wert)   
  #IF PRIORITAET = LOW            'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
    BEGIN_CRITICAL_SECTION
  #ENDIF
  poke(enadrwr,registernummer) 
  poke(rdcan,wert) 
  #IF PRIORITAET = LOW
    END_CRITICAL_SECTION
  #ENDIF
ENDSUB


'***************************************************************
'Reading a register of the CAN-controller.
'register_no : register to read
'return value : value of the register
'***************************************************************
Function get_can_reg(registernummer) as integer
  #IF PRIORITAET = LOW            'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
    BEGIN_CRITICAL_SECTION
  #ENDIF
  poke(enadrrd, registernummer) 
  sleep(6)
  get_can_reg = peek(rdcan)
  #IF PRIORITAET = LOW
    END_CRITICAL_SECTION
  #ENDIF
endfunction
'***************************************************************


'**************************************************************
'read the input data in seq mode
'channel:
'only L16 Rev B or higher
'**************************************************************
FUNCTION SEQ_READ(channel) as long 
  SEQ_READ=peek(20400800H+(channel)/2)
ENDFUNCTION


'**************************************************************
'initialising the ain mode 
'mode =0 normal Mode 
'     =1 single shot mode
'     =2 continuous mode Eventdelay
'     =3 continuous mode max Speed
'gain=0 range -10 V -> +10 V
'gain=1 range -5V   -> + 5 V
'gain=2 range -2.5V -> + 2.5 V
'gain=3 range -1.25 -> + 1.25 V
'channel :selected channels in binary
'time 0=default time 
'mux_time
'only L16 Rev B or higher
'**************************************************************
SUB SEQ_INIT(mode,gain,channel,mux_time)
  dim channeli as long
  dim i as long
  dim anz as long 
  dim delay as long
  dim imux as long
  dim startdelay as long
  
  channeli=channel AND 5555H
  anz=0
  for i=0 to 15
    if (shift_left(1,i) AND channeli>0) then inc anz
  next

  POKE(20400810H,0) 
  SET_MUX(shift_left(gain,6))  

  #IF PRIORITAET = LOW
    delay=globaldelay*4000
  #else
    delay=globaldelay
  #endif

  poke(20400814H,channel) 
  if (mux_time<>0) then
    poke(20400818H,mux_time)
    imux=mux_time
  else
    poke(20400818H,200)
    imux=200
  endif
  
  startdelay=delay-((anz*imux)+200)
  if (startdelay<0) then startdelay=0
  
  if (mode=3) then
    POKE(20400810H,mode-1)
    poke(2040081CH,0)              'Start delay 
    poke(20400820H,0)
  else
    POKE(20400810H,mode)
    poke(2040081CH,startdelay)     'Start delay 
    poke(20400820H,delay)      
  endif
ENDSUB


'**************************************************************
' read SSI encoder value 32 Bit (new counter board)
' counter : number of the counter
'**************************************************************
FUNCTION SSI_READ(counter) AS long
  SSI_READ = PEEK(204005afh + counter)      'read 32 Bit-value
ENDFUNCTION


'**************************************************************
' sets the number of databits for the SSI Interface
' counter : number of the counter
' value   : number of bits
'**************************************************************
SUB SSI_SET_BITS(counter,value)
  poke((204005A7h + counter) , value)           
ENDSUB


'**************************************************************
' sets frequency of the SSI clock
' counter : number of the counter
' value   : frequency = 10MHZ / value
'**************************************************************
SUB SSI_SET_CLOCK(counter,value)
  poke((204005A3h + counter), value)           
ENDSUB


'**************************************************************
' Starts the SSI interface
' value  : Bitcombination each bit corresponts to one counter
'**************************************************************
SUB SSI_START(value)
  poke(204005ACh, value)
ENDSUB


'*************************************************************
' Sets the SSI mode
' value : Bitcombination each bit corresponts to one counter
'         0 = single start mode
'         1 = continuous start mode
'*************************************************************
SUB SSI_MODE(value)
  poke(204005b4h,value)
ENDSUB


'*************************************************************
' Reads the SSI status
' counter      : number of the SSI counter
' return value : 0 = SSI value compleated
'                1 = SSI transfer running
'*************************************************************
FUNCTION SSI_STATUS(counter) AS long
  dim value2 as long
  
  value2 = peek(204005ACh)
  ssi_status=shift_right(value2,(counter-1)) AND 01H
ENDFUNCTION


'*************************************************************
'select L16 mode
'mode =0   : classic mode (wait_eoc after 5 s) default 
'mode =1   : 500 KHz mode (wait_eoc after 2 s)  
'only L16 Rev B or higher
'*************************************************************
SUB L16_MODE(mode)
  dim old as long
  
  old=peek(20400008H) AND 0FFDH
  old=old or shift_left((mode AND 1),1)
  poke(20400008H,old)
ENDSUB


'***************************************************************
' Function only for internal use!
' receive LS-Bus
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'***************************************************************
function I_RECEIVE(dev_adr, reg_adr, cnt_dat, buf[]) as long
  dim cnt_i, frc, ftc, tmout, tmstart, th as long
  dim erg as long

  sub_begin_critical_section   
    poke(20400880H, (shift_left(cnt_dat-1,4) or dev_adr))   ' Header 1
    poke(20400880H, 0 or reg_adr)                           ' Header 2
  sub_end_critical_section 
  
  do
    ftc=peek(2040088CH)
  until (ftc = 0)                          ' tx wait
  
  th = 250                                 ' first 6,25mikrosek
  for cnt_i=1 to cnt_dat                   ' data count
    tmstart=peek(204003F0H) 
    do                                     ' rx wait
      tmout=peek(204003F0H)-tmstart 
      frc=peek(20400888H)
    until ((frc>=1) or (tmout>th))
    buf[cnt_i] = peek(20400880H)
    th = 180                               ' 4,5mikrosek
  next cnt_i
  tmstart=peek(204003F0H) 
  do                                       ' ack wait
    tmout=peek(204003F0H)-tmstart          ' rx count
    frc=peek(20400888H)
  until ((frc>=1) or (tmout>180))          ' 4,5 mikrosec
  if (frc>=1) then
    erg = peek(20400880H)
  else
    erg = -1
  endif
  
  I_RECEIVE = erg
endfunction


'***************************************************************
' Function only for internal use!
' send LS-Bus
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'***************************************************************
function I_SEND(dev_adr, reg_adr, cnt_dat, buf[]) as long
  dim cnt_i, frc, ftc, tmout, tmstart  as long
  dim erg as long
  
  sub_begin_critical_section 
    poke(20400880H,(shift_left(cnt_dat-1,4) or dev_adr))
    poke(20400880H,(80h or reg_adr))
    for cnt_i=1 to cnt_dat                   ' data count
      poke(20400880H,buf[cnt_i])
    next cnt_i
  sub_end_critical_section 
  do
    ftc=peek(2040088CH)
  until (ftc = 0)                          ' tx wait

  tmstart=peek(204003F0H) 
  do                                       ' ack wait
    tmout=peek(204003F0H)-tmstart 
    frc=peek(20400888H)
  until ((frc>=1) or (tmout>180))          ' 4,5 mikrosec
  if (frc >= 1) then 
    erg=peek(20400880H)
  else
    erg = -1
  endif
  i_send = erg
endfunction


'***************************************************************
' Function only for internal use!
' send LS-Bus no acknowlege
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'***************************************************************
sub I_SEND_NA(dev_adr, reg_adr, cnt_dat, buf[])
  dim cnt_i as long
  
  sub_begin_critical_section   
    poke(20400880H, (shift_left(cnt_dat-1,4) or dev_adr)) ' Header 1
    poke(20400880H, (80h or reg_adr))                     ' Header 2
  
    for cnt_i=1 to cnt_dat                                ' data count
      poke(20400880H, buf[cnt_i])
    next cnt_i
  sub_end_critical_section 
endsub


'***************************************************************
' Function only for internal use!
' send LS-Bus broadcast no acknowlege
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'***************************************************************
sub I_SEND_BC(reg_adr, cnt_dat, buf[])
  dim cnt_i as long
  
  sub_begin_critical_section    
    poke(20400880H, (shift_left(cnt_dat-1,4)))    ' Header 1
    poke(20400880H, (80h or reg_adr))             ' Header 2
    for cnt_i=1 to cnt_dat                        ' data count
      poke(20400880H, buf[cnt_i])
    next cnt_i
  sub_end_critical_section 
endsub


'***************************************************************
' Request to read data
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
'***************************************************************
sub LS_READ_REQ(dev_adr, reg_adr, cnt_dat)
  sub_begin_critical_section  
    poke(20400880H, (shift_left(cnt_dat-1,4) or dev_adr))  ' Header 1
    poke(20400880H, 0 or reg_adr)                          ' Header 2
  sub_end_critical_section  
endsub


'***************************************************************
' Read response (only DIG_IO request)
' return  : state of digital outputs and inputs
'***************************************************************
function LS_READ_RESP_DIO() as long
  dim ld[4] as long at dm_local
  dim cnt_i as long

  for cnt_i=1 to 4               ' rx data read
    ld[cnt_i]=peek(20400880H)
  next cnt_i
  LS_READ_RESP_DIO = ld[1] or (shift_left(ld[2],8)) or (shift_left(ld[3],16)) or (shift_left(ld[4],24))
endfunction


'***************************************************************
' Read response
' cnt_dat : count of data  (1..16)
' buf[]   : array (min len is cnt_dat)
' return  : error code (0->ok) 
'***************************************************************
function LS_READ_RESP(cnt_dat, buf[]) as long
  dim cnt_i as long

  for cnt_i=1 to cnt_dat                   ' rx data read
    buf[cnt_i]=peek(20400880H)
  next cnt_i
  LS_READ_RESP = peek(20400880H)           ' acknowledge
endfunction


'***************************************************************
' the function reset the watchdog timer, set digital outputs and
' read digital inputs.
' dev_adr : device nr lsbus (FIX 1)
' value   : each bit corresponds to a channel
' return  : state of digital outputs and inputs
'***************************************************************
function LS_DIG_IO(value) as long
  dim ld[4] as long at dm_local
  dim cnt_i as long

  for cnt_i=1 to 4               ' rx data read
    ld[cnt_i]=peek(20400880H)
  next cnt_i
  LS_DIG_IO = ld[1] or (shift_left(ld[2],8)) or (shift_left(ld[3],16)) or (shift_left(ld[4],24))

  ld[1] = 1                      ' WD trigger
  I_SEND_BC(44h, 1, ld)

  ld[1] = value and 0FFh        ' tx data transmit
  ld[2] = shift_right(value,8) and 0FFh
  ld[3] = shift_right(value,16) and 0FFh
  ld[4] = shift_right(value,24) and 0FFh
  I_SEND_NA(1, 7Ch, 4, ld)      ' channel 1..32

  LS_READ_REQ(1, 7Ch, 4)        'request new in data
endfunction


'***************************************************************
' the function enable,disable and config the watchdog 
' dev_adr : device nr lsbus (1..15)
' enable  : 0->disable
'           1->enable
' time    : trigger time [ms]
' return  : error code (0->ok)
'***************************************************************
function LS_WATCHDOG_INIT(dev_adr, enable, time) as long
  dim ld[4] as long at dm_local
  dim ret, t as long

  'Watchdog disable
  ld[1] = 0ADh
  ld[2] = 0
  ret = I_SEND(dev_adr, 45h, 2, ld)

  'Watchdog time
  t = time / 25e-6
  ld[1] = t and 0FFh
  ld[2] = shift_right(t,8) and 0FFh
  ld[3] = shift_right(t,16) and 0FFh
  ld[4] = shift_right(t,24) and 0FFh
  ret = ret or (I_SEND(dev_adr, 48h, 4, ld))

  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable and 1
  LS_WATCHDOG_INIT = ret or (I_SEND(dev_adr, 45h, 2, ld))
endfunction


'***************************************************************
' reset the watchdog timer
' If the watchdog is activated, the user program has to call
' this function at least every ....
'***************************************************************
sub LS_WATCHDOG_RESET()
  dim ld[1] as long at dm_local

  ld[1] = 1
  I_SEND_BC(44h, 1, ld)
endsub

 
'******************************************************************************
' Initialisation of a digital I/O module (channel 0-31)
' dev_adr : device nr LS-bus (1..15)
' value   : each bit corresponds to 8 channel
'           0 -> input
'           1 -> output
'           bit 0: channels 1..8
'               1: channels 9..16
'               2: channels 17..24
'               3: channels 25..32
' return  : error code (0->ok)
'******************************************************************************
function LS_DIGPROG(dev_adr, value) as long
  dim ld[2] as long at dm_local
  dim ret as long

  ld[1] = shift_left(value,3) and 8h
  ld[1] = ld[1] or (shift_left(value,7) and 80h)
  ld[1] = ld[1] or 11h                     ' as after reset
  ld[2] = shift_left(value,2) and 8h
  ld[2] = ld[2] or (shift_left(value,6) and 80h)
  ld[2] = ld[2] or 11h
  ret = I_SEND(dev_adr, 16h, 2, ld)

  ld[1] = shift_left(value,1) and 8h
  ld[1] = ld[1] or (shift_left(value,5) and 80h)
  ld[1] = ld[1] or 11h
  ld[2] = value and 8h
  ld[2] = ld[2] or (shift_left(value,4) and 80h)
  ld[2] = ld[2] or 11h
  LS_DIGPROG = ret or (I_SEND(dev_adr, 20h+16h, 2, ld))
endfunction


'***************************************************************
' Sets the digital outputs (channel 0 - 31)
' dev_adr : device nr LS-bus (1..15)
' value   : each bit corresponds to a channel
'***************************************************************
sub LS_DIGOUT_LONG(dev_adr, value)
  dim ld[4] as long at dm_local

  ld[1] = value and 0FFh
  ld[2] = shift_right(value,8) and 0FFh
  ld[3] = shift_right(value,16) and 0FFh
  ld[4] = shift_right(value,24) and 0FFh
  I_SEND_NA(dev_adr, 7Ch, 4, ld)      ' channel 1..32
endsub


'***************************************************************
' Reads the digital inputs (channel 0 - 31)
' dev_adr : device nr LS-bus (1..15)
' return  : state of digital outputs and inputs
'***************************************************************
function LS_DIGIN_LONG(dev_adr) as long
  dim ld[4] as long at dm_local
  dim ret as long

  ret = I_RECEIVE(dev_adr, 7Ch, 4, ld)
  LS_DIGIN_LONG = ld[1] or (shift_left(ld[2],8)) or (shift_left(ld[3],16)) or (shift_left(ld[4],24))
endfunction


'***************************************************************
' Reads the digital output status (overcurrent) (channel 0 - 31) 
' ls_mod_adr: device nr lsbus
' Return : each bit corresponds a channel 0=OK 1=Error
'***************************************************************
function LS_GET_OUTPUT_STATUS(ls_mod_adr) as long
  dim ld[4] as long at dm_local
  dim ret,t as long

  t = I_RECEIVE(ls_mod_adr, 50h, 4, ld)
  ret=ld[1] or shift_left(ld[2],8) or shift_left(ld[3],16) or shift_left(ld[4],24)
  LS_GET_OUTPUT_STATUS = ret
endfunction


'***************************************************************
' Initialize the LS-Modul
' dev_adr : device nr LS-bus (1..15)
' return  : error code (0->ok)
'***************************************************************
function LS_DIO_INIT(dev_adr) as long
  dim ld[4] as long at dm_local
  dim ret as long

  poke(2040089CH, 1)                            ' autoreset rx ON
  ld[1] = 3
  ret = I_SEND(dev_adr, 40h, 1, ld)             ' Reset JX 1,2
  ld[1] = 1
  ret = ret or (I_SEND(dev_adr, 5Ch, 1, ld))    ' timeout reset
  ld[1]=0
  ld[2]=0
  ld[3]=0
  ld[4]=0
  LS_DIO_INIT = ret or (I_SEND(dev_adr, 50h, 4, ld)) ' overcurrent reset
  ld[1]=30h
  LS_DIO_INIT = ret or (I_SEND(dev_adr, 43h, 1, ld)) ' overtemperature reset
endfunction

