****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwpEXT.inc                          #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Summary of functions and procedures               #
'#           for ADwin-ext-modules.                            #
'#                                                             #
'#  25.05.1997  OL   creation                                  #
'#  08.04.1998  OL   changes for ADSP (ADbasic 3)              #
'#  08.04.1999  OL   changes for seriel interface              #
'#  12.06.1999  OL   commands for CAN interface                #
'#  29.07.1999  OL   commands for Profibus interface           #
'#  06.08.1999  OL   29 Bit-ID for CAN interface               #
'#  24.01.2000  OL   commands for Anybus-S                     #
'#  04.08.2000  OL   changes for CAN-2                         #
'#  22.08.2000  OL   RS485 functions check_shift_reg and       #
'#                                    rs485_send               #
'#  20.03.2001  OL   PROFIBUS set_write_buffer ;               #
'#                             interne Schleife um 1 verkrzt  #
'#  16.11.2001  JK   replacements because ADbasic keywords :   #
'#                      register     ->   register_no          #
'#                      fifo_empty   ->   fifo_status          #
'#  16.11.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  19.11.2001  JK   added one NOP to POKE_NOP  => now         #
'#                      identical with other PRO include files #
'#  13.05.2002  OL   new command: get_line_status (CAN-LS)     #
'#  29.07.2002  OL   switching big functions (PM) to library   #
'#                   functions to save program memory          #
'#  18.10.2002  OL   combine includes for DSP and Transputer   #
'#  18.10.2002  OL   changes for T10 (ADbasic 4)               #
'#  28.01.2004  OL   optimized for smaler program-code         #
'#  13.05.2004  MF   bugfix RS RESET                           #
'#  24.05.2004  MF   bugfix get_line_status                    #
'#  03.02.2005  MF   NOT T11                                   #
'#  01.03.2005  MF   TC ISO                                    #
'#  14.04.2005  MF   ERROR WRONG PROCESSOR                     #
'#  29.04.2005  MF   TC ISO TYP N,E                            #
'#  16.06.2005  MF   make_lib=off                              #
'#  20.09.2005  MF   TC READ VOLTAGE                           #
'#  24.04.2006  MF   TCJ_DIG_TO_TEMP                           #
'#  24.04.2006  MF   TCK_DIG_TO_TEMP                           #
'#  02.05.2006  MF   PT100_DIG_TO_TEMP                         #
'#  02.05.2006  MF   PT100_DIG_TO_R                            #
'#  20.06.2006  MF   TC_READ_B                                 #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#   - arrays which should be transfered to lib-functions must #
'#     be declared at external DRAM                            #
'#                                                             #
'###############################################################

#IF PROZESSOR=T11 THEN
	#error("This include file can only be used with the processor T2, T4, T5, T8, T9 or T10.")
#ELSE


#IF  PROZESSOR = ADSP THEN
  
		
	#if make_lib=off then
		dim can_msg[9] as long at DRAM_EXTERN' array with 9 elements 
	#endif
	
                                 ' element 1 to 8 for databyte 1 to 8 in CAN-Frame
                                 ' element 9 for the number of databytes in CAN-Frame 

  #IF PROZESSOR = T9 THEN
    #define DL         20400000H
    #define DH         20400010H
    #define DLX        20400020H
    #define DHX        20400030H
    #define ADWR       20400060H
    #define ADRD       20400070H
    #define cpu_EVENT  204000F0H
    #define watchdog   204001D0H
    #define WD_TIMER   204001E0H
    #define cpu_LED    204001F0H
		#define d32        20400180h

  #ENDIF
  #IF PROZESSOR = T10 THEN
    #define DL         20800000H
    #define DH         20800010H
    #define DLX        20800020H
    #define DHX        20800030H
    #define ADWR       20800060H
    #define ADRD       20800070H
    #define cpu_EVENT  208000F0H
    #define watchdog   208001D0H
    #define WD_TIMER   208001E0H
    #define cpu_LED    208001F0H
		#define d32        20800180h

  #ENDIF

  'Profibus slave adresses (DPRAM)
  'Handshakeregisters
    #define app_ind			7feH 
    #define any_ind			7ffH 


  '***************************************************************
  ' If the processor is a T9 this prcedure disables the interrupt,
  ' so that a process with low priority can not be interrupted.
  ' The procedure is used to protect a read or a write cycle.
  '***************************************************************
  SUB SUB_BEGIN_CRITICAL_SECTION()
    #IF PROZESSOR = ADSP THEN
      #IF PRIORITAET = LOW
        BEGIN_CRITICAL_SECTION
      #ENDIF
    #ENDIF
  ENDSUB

  '***************************************************************
  ' This procedure enables the interrupt.
  ' (see SUB_BEGIN_CRITICAL_SECTION)
  '***************************************************************
  SUB SUB_END_CRITICAL_SECTION()
    #IF PROZESSOR = ADSP THEN 
      #IF PRIORITAET = LOW
        END_CRITICAL_SECTION
      #ENDIF
    #ENDIF
  ENDSUB
  #IF PROZESSOR = T9 THEN
    {import adwpext_lib.li9}
		{import tc.li9}
	#ENDIF	
  #IF PROZESSOR = T10 THEN
    {import adwpext_lib.lia}
		{import tc.lia}
	#ENDIF	

  '*****************************************************************
  ' Procedure inserts 5 nop's after a poke instruction if the used processor 
  ' is an ADSP. 
  '*****************************************************************
  SUB poke_nop(adress,value)
  #IF PROZESSOR = T9 THEN
     poke(adress,value)
     nops(5)
	#ELSE
	  #IF PROZESSOR = T10 THEN
      poke(adress,value)
      nops(10)
  	#ELSE
      poke(adress,value)
  	#ENDIF
  #ENDIF
  ENDSUB

  '***************************************************************
  ' Procedure inserts 1 nop if the processor is a T9. 
  '***************************************************************

  SUB NOP_T9()
  #IF PROZESSOR = T9 THEN
    NOP
  #ENDIF
  #IF PROZESSOR = T10 THEN
    nops(2)
  #ENDIF
  endsub

  '-----------------Thermocouple

  '***********************************************
  ' Setting the thermocouple multipexer
  '  card  : dip switch address 
  '	channel: multiplexer channel
  '***********************************************
  SUB TC_SELECT(card,channel)
  DIM adr,adcnr as integer
    adr = 0D0H OR (SHIFT_LEFT(card,8))
    SUB_BEGIN_CRITICAL_SECTION()
      poke (ADWR, adr)
      nop_t9
      poke_nop (DLX, channel-1) 
    SUB_END_CRITICAL_SECTION()
  ENDSUB


  '------------------CAN


  '***************************************************************
  'The function checks, if there is a new frame in the selected
  'message object. If there is a new frame all databytes are read
  'and then written to the array "can_msg".
  'The number of dadabytes is written to the element 9 of the array "can_msg".
  'The return value of the function is the identifier of the frame. 
  'If there is no new frame in the message box the return value is -1.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
  'msg_nummer : number of the message object
  '***************************************************************
  function read_msg(card,channel,msg_number) as integer
    read_msg=lib_read_msg(card,channel,msg_number,can_msg)
  endfunction


  '***************************************************************
  'Transmitting a frame. 
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
  'msg_nummer : number of the message object
  'The databytes and the number of databytes have to be written in the
  'array "can_msg" before this subroutine is activated.
  'After this subroutine the frame is transmitted as soon as the 
  'CAN-bus allows it.
  '***************************************************************
  sub transmit(card,channel,msg_num)
    lib_transmit(card,channel,msg_num,can_msg)
  endsub


  '***************************************************************
  'Setting a register of the CAN-controller.
  'card : dip switch address
  'register : register which should be set
  'value : value which should be written to the register.
  '***************************************************************
  sub set_can_reg(card,channel,reg,value)   
  dim adr1 as integer  
  dim adr2 as integer  
    adr1 = 0c0h or (shift_left(card, 8)) or ((channel-1)*8)
    adr2 = adr1 or (1+((channel-1)*8))
    SUB_BEGIN_CRITICAL_SECTION()
      poke(adwr ,adr2)
      nop_t9
      poke_nop(dlx ,reg)
      poke(adwr ,adr1)
      nop_t9
      poke_nop(dlx ,value)
    SUB_END_CRITICAL_SECTION()
 endsub


  '***************************************************************
  'Reading a register of the CAN-controller.
  'card : dip switch address
  'channel : number of the CAN interface on the CAN module
  '          (also necessary if the module provides only one channel)
  'register : register to read
  'return value : value of the register
  '***************************************************************
  Function get_can_reg(card,channel,reg) as integer
  dim adr1 as integer  
  dim adr2 as integer  
    adr1 = 0c0h or (shift_left(card, 8)) or ((channel-1)*8)
    adr2 = adr1 or (2+((channel-1)*8))
    SUB_BEGIN_CRITICAL_SECTION()
      poke(adwr ,adr2)
      nop_t9
      poke_nop(dlx ,reg)
      sleep(6)
      poke_nop(adrd ,adr1)
      get_can_reg = peek(dlx) and 255
    SUB_END_CRITICAL_SECTION()
  endfunction

	
	'***************************************************************
	'Reading the register where the bus error pin of the tranceiver
	'is sored.
	'The register is set when the a bus error occurs and is reset by 
	'reading the register.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module
	'          (also necessary if the module provides only one channel)
	'return value : 0 = no error
	'               1 = error
	'Attention: This command is only for low-speed CAN
	'***************************************************************
	
	Function get_line_status(card,channel) as long
	dim adr as long
    adr =  0c0h or shift_left(card, 8) or (3Dh - channel)
    SUB_BEGIN_CRITICAL_SECTION()
	    poke_nop(ADRD, adr)
	    get_line_status = peek(DLX)
    SUB_END_CRITICAL_SECTION()
	endfunction
	



  '------------------RS
  '***********************************************
  ' Setting a register of the seriell controller
  ' 	card  : dip switch address 
  '	register_no: register on the serial controller
  '     value : value for the selected register
  '***********************************************
	sub set_rs(card,register_no,value)
	dim adr as integer
	  adr = (0c0h + register_no) or (shift_left(card, 8))
    SUB_BEGIN_CRITICAL_SECTION()
		  poke (adwr, adr)
		  nop_t9
	  	poke_nop (dlx, value) 
    SUB_END_CRITICAL_SECTION()
	endsub

  '***********************************************
  ' reads the value of a register of the serial controller
  ' 	card  : dip switch address 
  '	register_no: register on the serial controller
  '**********************************************
	FUNCTION get_rs(card, register_no) AS INTEGER
	DIM adr as integer
	  adr = (0c0h + register_no) or (shift_left(card,8))
    SUB_BEGIN_CRITICAL_SECTION()
		  poke_nop(adrd, adr)
		  get_rs = peek(DLX)
    SUB_END_CRITICAL_SECTION()
	ENDFUNCTION

  '***************************************************************
  'Reset for the ADwin module (serial interface module)
  'card : dip switch address
  '***************************************************************
  sub rs_reset(card)
  dim adr as long
    set_rs(card,23, 1)    			  ' reset aktiv
    set_rs(card,23, 0)    			  ' reset not aktiv
  endsub


  '-------------------Anybus

	function init_slave(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt) as long
    init_slave = init_slave_lib(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt)
  endfunction
  '*****************************************************************
  'Getting a byte from the DPRAM of a profibus-DP master or slave
  'card  : dip switch address 
  'bytenumber: number of the byte on the DPRAM
  '*****************************************************************
  function get_pro_byte(card,bytenumber) as long
  dim adr as long
    adr = 80c0h or shift_left(card,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63) 
    SUB_BEGIN_CRITICAL_SECTION()
      poke_nop(adrd, adr)
      get_pro_byte=peek(dlx) 
    SUB_END_CRITICAL_SECTION()
  endfunction

  '*****************************************************************
  'Setting a byte in the DPRAM of a profibus-DP master or slave
  ' 	card  : dip switch address 
  '	bytenumber: number of the byte on the DPRAM
  '     value : value for the selected byte
  '*****************************************************************
  sub set_pro_byte(card,bytenumber,value)
  dim adr as long
    adr = 80c0h or shift_left(card,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63) 
    SUB_BEGIN_CRITICAL_SECTION()
      poke(adwr, adr) 
      nop_t9
      poke_nop(dlx, value) 
    SUB_END_CRITICAL_SECTION()
  endsub

  '******************************************************
  'The function gives the information wether the data in
  'the out area has changen or not. If there is new data
  'the return value is <> 0 else the return value is 0.
  'size:	number of bytes of the out area.
  '******************************************************
  Function changed_data(card,size) as long
  dim loopsize as long
  dim buffer as long
  dim count as long
    changed_data = 0
    loopsize = (size - 1)/8 + 1
    for count = 1 to loopsize
      buffer = get_pro_byte(card,(count + 7E3h))
      changed_data = changed_data or buffer
    next count 
  endfunction

  '******************************************************
  'Check access right. If bit is set the application has
  'access right.
  'The DPRAM consists of 3 parts. Each part equals a bit
  'in the parameter array:
  'Bit 0: 	Anybus control registers
  'Bit 1: 	Output data
  'Bit 2: 	Input data
  '******************************************************
  function check_access(card) as long
    check_access = get_pro_byte(card,any_ind) and 07h
  endfunction

  '*******************************************************
  'Reads the input data from the DPRAM
  '	card  :	 	dip switch address 
  '	array :		destination array for input data
  '	start :		first byte (DPRAM)
  '	count :		number of bytes
  '*******************************************************
  sub get_read_buffer(card,array,start,count)
  dim i as long
    for i = start to (start + count - 1)
      array[i + 1 - start] = get_pro_byte(card,i)
    next i
  endsub


  '*******************************************************
  'Writes the output data to the DPRAM
  '	card  :	 	dip switch address 
  '	array :		source array for input data
  '	start :		first byte (DPRAM)
  '	count :		number of bytes
  '*******************************************************
  sub set_write_buffer(card,array,start,count)
  dim i as long
    for i = start to (start + count - 1)
      set_pro_byte(card,i,array[i+1])
    next i
  endsub


'***************************************************************
' convert digit from TC4/8/16 J to temperature
' digit16 inputvalue
' unit 1= C
'      2= F
'***************************************************************
FUNCTION TCJ_DIG_TO_TEMP(digit16,unit) as float
	 TCJ_DIG_TO_TEMP = TC_CONVERT_TYP_J((digit16 - 32778) * 1.57758)
	 IF (UNIT=2) THEN  'C -> F
	 TCJ_DIG_TO_TEMP=(TCJ_DIG_TO_TEMP*1.8)+32
	 ENDIF
ENDFUNCTION

'***************************************************************
' convert digit from TC4/8/16 K to temperature
' digit16 inputvalue
' unit 1= C
'      2= F
'***************************************************************
FUNCTION TCK_DIG_TO_TEMP(digit16,unit) as float
	 TCK_DIG_TO_TEMP = TC_CONVERT_TYP_K((digit16 - 32778) * 1.234192)
	 IF (UNIT=2) THEN  'C -> F
	 TCK_DIG_TO_TEMP=(TCK_DIG_TO_TEMP*1.8)+32
	 ENDIF
ENDFUNCTION


'***************************************************************
' convert digit from PT-100 to temperature
' digit16 inputvalue
' unit 1= C
'      2= F
'***************************************************************
FUNCTION PT100_DIG_TO_TEMP(dig,unit) AS FLOAT
  DIM x AS FLOAT
  x = (dig-32768)*20/65536
	IF (x <= 0) THEN
	 PT100_DIG_TO_TEMP = ((((0.0002*x - 0.0032) * x + 0.0906) * x + 25.581) * x - 0.002)
	ELSE
   PT100_DIG_TO_TEMP = (0.1097*x + 25.536)*x + 0.0444
	ENDIF
	
	IF (unit = 2) THEN PT100_DIG_TO_TEMP = PT100_DIG_TO_TEMP*1.8 + 32
ENDFUNCTION

'***************************************************************
' convert digit from PT-100 to resistor
' digit16 inputvalue
' return r[ohm]
'***************************************************************
FUNCTION PT100_DIG_TO_R(dig) AS FLOAT
  PT100_DIG_TO_R = ((dig-32768)*200/65536)+100
ENDFUNCTION




'***************************************************************
' read value of tc iso TYP J  -210 C->1200 C 
' card : dip switch adress		
' channel (1-8) 
' unit 0= thermovoltage V
'			 1= C
'      2= F
'***************************************************************
function TC_READ_J(card,channel,unit) as float
	dim adr as long
	dim value as long
	dim spg as long
	dim coldjunction as long 
	dim spg2 as float
	
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32)
	SUB_END_CRITICAL_SECTION
	
	 coldjunction=(shift_right(value,16)) AND 1FFFH
	 if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
	
	 spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
	 if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H	 
	 
	 spg2=spg *2.44140625 'thermovoltage => V
	 spg2=spg2 +TC_CONVERT_TYP_J_INV((coldjunction/16))
	 
   IF (UNIT>0) then 'convert
	 TC_READ_J=TC_CONVERT_TYP_J(spg2) '-210 C->1200 C DIN EN 60584-1
	 ELSE 
	 TC_READ_J=spg2 
	 endif

   if (UNIT=2) then  'C -> F
	 TC_READ_J=(TC_READ_J*1.8)+32
	 endif

endfunction

'***************************************************************
' read value of tc iso TYP K -200 C -> 1372 C 
' card : dip switch adress	
' channel (1-8) 
' unit 0= thermovoltage in V
'			 1= C
'      2= F
'***************************************************************
function TC_READ_K(card,channel,unit) as float
	dim adr as long
	dim value as long
	dim spg as long
	dim coldjunction as long 
	dim spg2 as float
	
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32)
	SUB_END_CRITICAL_SECTION
	
	 coldjunction=(shift_right(value,16)) AND 1FFFH
	 if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

	 spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
	 if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H	 
	 
	 spg2=spg *2.44140625 'thermovoltage => V
	 
	 if (coldjunction<=400) then '<25 C
		 spg2=spg2+(2.5055*coldjunction)
   else
     spg2=spg2+(2.56*(coldjunction-9.76))
	 endif
	 
   IF (UNIT>0) then 'convert
	 TC_READ_K=TC_CONVERT_TYP_K(spg2) '-200 C -> 1372 C DIN EN 60584-1
	  ELSE 
	 TC_READ_K=spg2 
	 endif

   if (UNIT=2) then  'C -> F
	 TC_READ_K=(TC_READ_K*1.8)+32
	 endif

endfunction


'***************************************************************
' read value of tc iso TYPE S -50 C-> 1768 C
' card : dip switch adress
' channel (1-8) 	
' unit 0= thermovoltage in V
'			 1= C
'      2= F
'***************************************************************
function TC_READ_S(card,channel,unit) as float
	dim adr as long
	dim value as long
	dim spg as long
	dim coldjunction as long 
	dim spg2 as float
	
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32)
	SUB_END_CRITICAL_SECTION
	
	 coldjunction=(shift_right(value,16)) AND 1FFFH
	 if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

	 spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
	 if(spg AND 32768=32768) then spg=spg OR 0FFFF0000H	 
	 
	 spg2=spg *2.44140625 'thermovoltage => V
	 spg2=spg2 +TC_CONVERT_TYP_S_INV((coldjunction/16))
	 
   IF (UNIT>0) then 'convert
	 TC_READ_S=TC_CONVERT_TYP_S(spg2) '-50 C-> 1768 C DIN EN 60584-1
   ELSE 
	 TC_READ_S=spg2 	 
	 endif

   if (UNIT=2) then  'C -> F
	 TC_READ_S=(TC_READ_S*1.8)+32
	 endif

endfunction


'***************************************************************
' read value of tc iso TYPE T -200 C-> 400 C 
' card : dip switch adress
' channel (1-8) 		
' unit 0= thermovoltage in V
'		   1= C
'      2= F
'***************************************************************
function TC_READ_T(card,channel,unit) as float
	dim adr as long
	dim value as long
	dim spg as long
	dim coldjunction as long 
	dim spg2 as float
	
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32)
	SUB_END_CRITICAL_SECTION
	
	 coldjunction=(shift_right(value,16)) AND 1FFFH
	 if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
	
	 spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
	 if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H	 
	 spg2=spg *2.44140625 'thermovoltage => V
	 spg2=spg2 +TC_CONVERT_TYP_T_INV((coldjunction/16))

   IF (UNIT>0) then 'convert
	  TC_READ_T=TC_CONVERT_TYP_T(spg2) '-200 C-> 400 C DIN EN 60584-1
   ELSE 
	  TC_READ_T=spg2 
	 endif

   if (UNIT=2) then  'C -> F
	 TC_READ_T=(TC_READ_T*1.8)+32
	 endif

endfunction

'***************************************************************
' read value of tc iso TYPE R -50 C-> 1768 C 
' card : dip switch adress
' channel (1-8) 		
' unit 0= thermovoltage in V
'		   1= C
'      2= F
'***************************************************************
function TC_READ_R(card,channel,unit) as float
	dim adr as long
	dim value as long
	dim spg as long
	dim coldjunction as long 
	dim spg2 as float
	
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32)
	SUB_END_CRITICAL_SECTION
	
	 coldjunction=(shift_right(value,16)) AND 1FFFH
	 if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
	
	 spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
	 if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H	 
	 spg2=spg *2.44140625 'thermovoltage => V
	 spg2=spg2 +TC_CONVERT_TYP_R_INV((coldjunction/16))

   IF (UNIT>0) then 'convert
	  TC_READ_R=TC_CONVERT_TYP_R(spg2) 
   ELSE 
	  TC_READ_R=spg2 
	 endif

   if (UNIT=2) then  'C -> F
	 TC_READ_R=(TC_READ_R*1.8)+32
	 endif

endfunction


'***************************************************************
' read value of tc iso TYP N  -200C->1300 C 
' card : dip switch adress		
' channel (1-8) 
' unit 0= thermovoltage V
'			 1= C
'      2= F
'***************************************************************
function TC_READ_N(card,channel,unit) as float
	dim adr as long
	dim value as long
	dim spg as long
	dim coldjunction as long 
	dim spg2 as float
	
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32)
	SUB_END_CRITICAL_SECTION
	
	 coldjunction=(shift_right(value,16)) AND 1FFFH
	 if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
	
	 spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
	 if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H	 
	 
	 spg2=spg *2.44140625 'thermovoltage => V
	 spg2=spg2 +TC_CONVERT_TYP_N_INV((coldjunction/16))
	 
   IF (UNIT>0) then 'convert
	 TC_READ_N=TC_CONVERT_TYP_N(spg2) '-210 C->1200 C DIN EN 60584-1
	 ELSE 
	 TC_READ_N=spg2 
	 endif

   if (UNIT=2) then  'C -> F
	 TC_READ_N=(TC_READ_N*1.8)+32
	 endif

endfunction

'***************************************************************
' read value of tc iso TYPE E -200 C-> 1000 C 
' card : dip switch adress
' channel (1-8) 		
' unit 0= thermovoltage in V
'		   1= C
'      2= F
'***************************************************************
function TC_READ_E(card,channel,unit) as float
	dim adr as long
	dim value as long
	dim spg as long
	dim coldjunction as long 
	dim spg2 as float
	
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32)
	SUB_END_CRITICAL_SECTION
	
	 coldjunction=(shift_right(value,16)) AND 1FFFH
	 if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H
	
	 spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
	 if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H	 
	 spg2=spg *2.44140625 'thermovoltage => V
	 spg2=spg2 +TC_CONVERT_TYP_E_INV((coldjunction/16))

   IF (UNIT>0) then 'convert
	  TC_READ_E=TC_CONVERT_TYP_E(spg2) 
   ELSE 
	  TC_READ_E=spg2 
	 endif

   if (UNIT=2) then  'C -> F
	 TC_READ_E=(TC_READ_E*1.8)+32
	 endif

endfunction

  '***************************************************************
  ' read value of tc iso TYPE B '250 C-1820 
  ' card : dip switch adress
  ' channel (1-8)                 
  ' unit 0= thermovoltage in V
  '                  1= C
  '      2= F
  '***************************************************************
  function TC_READ_B(card,channel,unit) as float
    dim adr as long
    dim value as long
    dim spg as long
    dim coldjunction as long 
    dim spg2 as float
    
    adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr )
      value = peek(d32)
    SUB_END_CRITICAL_SECTION
   
    spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
    if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H     
    spg2=spg *2.44140625 'thermovoltage => V
   
  
    IF (UNIT>0) then 'convert
      TC_READ_B=TC_CONVERT_TYP_B(spg2) 
    ELSE 
      TC_READ_B=spg2 
    endif
  
    if (UNIT=2) then  'C -> F
      TC_READ_B=(TC_READ_B*1.8)+32
    endif
  endfunction





'**************************************************************
'Sub is setting the sampelrate of tc iso modul
'card : dip switch address
'mode=1 sampelrate = 3520 Hz
'mode=2 sampelrate = 1760 Hz
'mode=3 sampelrate = 880 Hz
'mode=4 sampelrate = 440 Hz
'mode=5 sampelrate = 220 Hz
'mode=6 sampelrate = 110 Hz
'mode=7 sampelrate = 55 Hz
'mode=8 sampelrate = 27.5 Hz
'mode=9 sampelrate = 13.75 Hz
'mode=15 sampelrate = 6.875 Hz (default)
'**************************************************************	
 sub TC_SET_RATE(card,mode) 
    dim adr as long
    adr = SHIFT_LEFT(card,8)or 0c0h 

    SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR , adr )
    nop_t9
    poke_nop( d32 , mode)  
    SUB_END_CRITICAL_SECTION
 endsub

'***************************************************************
' read the input voltage [v] without coldjunction correction  
' This function may be used if not a Thermocouple is connected 
' to the inputs of the TC-8 ISO , but if a voltage is applied 
' directly to the inputs. Max. input voltage is +- 80 mVolt
' card : dip switch adress
' channel (1-8) 		
'***************************************************************
function TC_READ_VOLTAGE(card,channel) as float
	dim adr as long
	dim value as long
	dim spg as long
		
	adr = SHIFT_LEFT(card,8) or 0c0h or (channel-1)
 
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    value = peek(d32) AND 0FFFFH
	SUB_END_CRITICAL_SECTION
		
	 if( VALUE AND 32768=32768) then value=value OR 0FFFF0000H	 
	
	 TC_READ_VOLTAGE=VALUE *2.44140625 'voltage => V
	 
endfunction








#ELSE
	dim test as integer                       ' variable for delay
	dim can_msg[9] as integer   			' array with 9 elements 
	                                          ' element 1 to 8 for databyte 1 to 8 in CAN-Frame
	                                          ' element 9 for the number of databytes in CAN-Frame 
	
	'***************************************************************
	' Address-table to access the hardware of the Pro-system,
	' depending on the CPU in use (ADSP OR Transputer).
	'***************************************************************
	#IF PROZESSOR = T9 THEN
	  #define DL         20400000H
	  #define DH         20400010H
	  #define DLX        20400020H
	  #define DHX        20400030H
	  #define ADWR       20400060H
	  #define ADRD       20400070H
	  #define cpu_EVENT  204000F0H
	  #define watchdog   204001D0H
	  #define WD_TIMER   204001E0H
	  #define cpu_LED    204001F0H
	#ELSE
	  #define DL               00H
	  #define DH               10H
	  #define DLX              20H
	  #define DHX              30H
	  #define ADWR             60H
	  #define ADRD             70H
	  #define cpu_EVENT       0F0H
	  #define watchdog        1D0H
	  #define WD_TIMER        1E0H
	  #define cpu_LED         1F0H
	#ENDIF
	
	'Profibus slave adresses (DPRAM)
	'Handshakeregisters
	  #define app_ind			7feH 
	  #define any_ind			7ffH 
	'Mailboxregisters
	  #define mail_in_0			400H 
	  #define mail_in_1			401H 
	  #define mail_in_2			402H 
	  #define mail_in_3			403H 
	  #define mail_in_4			404H 
	  #define mail_in_5			405H 
	  #define mail_in_6			406H 
	  #define mail_in_7			407H 
	  #define mail_in_8			408H 
	  #define mail_in_9			409H 
	  #define mail_in_a			40aH 
	  #define mail_in_b			40bH 
	  #define mail_in_c			40cH 
	  #define mail_in_d			40dH 
	  #define mail_in_e			40eH 
	  #define mail_in_f			40fH 
	
	  #define mail_out_0			520H 
	  #define mail_out_1			521H 
	  #define mail_out_2			522H 
	  #define mail_out_3			523H 
	  #define mail_out_4			524H 
	  #define mail_out_5			525H 
	  #define mail_out_6			526H 
	  #define mail_out_7			527H 
	  #define mail_out_8			528H 
	  #define mail_out_9			529H 
	  #define mail_out_a			52aH 
	  #define mail_out_b			52bH 
	  #define mail_out_c			52cH 
	  #define mail_out_d			52dH 
	  #define mail_out_e			52eH 
	  #define mail_out_f			52fH 
	
	
	
	'*****************************************************************
	' Procedure inserts 4 nop's after a poke instruction if the used processor 
	' is an ADSP.
	'*****************************************************************
	
	sub poke_nop(address,value)
	#IF PROZESSOR = T9 THEN
	   poke(address,value)
	   nop   
	   nop   
	   nop   
	   nop   
		 nop   ' 5 th NOP
	#ELSE
	   poke(address,value)
	#ENDIF
	endsub
	
	'*****************************************************************
	' Procedure inserts 1 nop if the used processor is an ADSP.
	'*****************************************************************
	
	sub nop_t9()
	  #IF PROZESSOR = T9 THEN
	     nop   
	  #ENDIF
	endsub
	
	'-----------------Thermocouple
	
	'***********************************************
	' Setting the thermocouple multipexer
	' 	card  : dip switch address 
	'	channel: multiplexer channel
	'***********************************************
	SUB TC_SELECT(card,channel)
	DIM adr,adcnr as integer
	  
	PRECALC
	  adr = 0D0H OR (SHIFT_LEFT(card,8))
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke (ADWR, adr)
	  nop_t9
	  poke_nop (DLX, channel-1) 
		  #IF PROZESSOR = T9 THEN						'This part enables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	ENDSUB
	
	
	'-------------------serial interface
	
	'***********************************************
	' Setting a register of the seriell controller
	' 	card  : dip switch address 
	'	register_no: register on the serial controller
	'     value : value for the selected register
	'***********************************************
	sub set_rs(card,register_no,value)
	dim adr as integer
	  adr = (0c0h + register_no) or (shift_left(card, 8))
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke (adwr, adr)
	  nop_t9
	  poke_nop (dlx, value) 
		  #IF PROZESSOR = T9 THEN						'This part enables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	endsub
	
	'***********************************************
	' reads the value of a register of the serial controller
	' 	card  : dip switch address 
	'	register_no: register on the serial controller
	'**********************************************
	FUNCTION get_rs(card, register_no) AS INTEGER
	DIM adr as integer
	  adr = (0c0h + register_no) or (shift_left(card,8))
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke_nop(adrd, adr)
	  get_rs = peek(DLX)
		  #IF PROZESSOR = T9 THEN						'This part enables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	ENDFUNCTION
	
	'******************************************************************
	'Initialisation of a serial interface
	'List of parameters:
	'card : dip switch address
	'channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
	'Baudrate: Baudrate for the serial comunication
	'parity :     0 = no parity
	'             1 = even 
	'             2 = odd 
	'word_length: Number of databits for the serial comunication
	'stop_bits:   0 = 1 Stopbit
	'             1 = 1,5 Stopbits by using 5 Databits
	'             1 = 2 Stopbits bei 6,7 by using 8 Databits
	'handshake:   0 = RS-232 no handshake
	'             1 = RS-232 Hardware handshake (RTS/CTS)
	'             2 = RS-232 Software handshake (Xon/Xoff)
	'             3 = RS-485 no handshake
	'******************************************************************
	
	
	sub rs_init(card,channel,Baud_rate,parity,word_length,stop_bits,handshake)
	dim hard_adr as integer				  			' phyisical address of the ADwin module (basic address)
	dim offset as integer                       			' offset for the selected serial interface
	dim divisor as long				  			' value by which the external clock has to be divided to get the selected baudrate
	dim DLL_value as integer			  			' value for the DLL register
	dim DLH_value as integer			  			' value for the DLH register
	dim LCR_value as integer                    			' value for the LCR register
	
	offset = ((channel - 1) and 1) * 8
	
	if (channel >= 3) then 				  			' for ADwin-PRO modules with more the 2 serial interfaces
	  hard_adr = card + 1 				  			' The hardware address for the serial interfaces 3 and 4 is dip switch + 1 
	else
	  hard_adr = card                           			' The hardware address for the serial interfaces 3 and 4 is dip switch
	endif
	
	divisor = (36864000/1) / (Baud_rate*16)    			' calculates the the divider for the external clock
	DLL_value = divisor and 0ffh			  			' value for the DLL register
	DLH_value = shift_right((divisor and 0ff00h),8)    		' value for the DLH register
	
	LCR_value = word_length - 5 
	LCR_value = LCR_value or shift_left(stop_bits,2)    
	if (parity = 1) then LCR_value = LCR_value or 011000b
	if (parity = 2) then LCR_value = LCR_value or 001000b    	'value for the LCR register
	
	
	  set_rs(hard_adr, offset + 3, 080h)			' LCR-bit7=1	Divisor latch enable
	  set_rs(hard_adr, offset + 0, DLL_value)	 		' DLL-reg		setting baudrate
	  set_rs(hard_adr, offset + 1, DLH_value)			' DLH-reg		setting baudrate
	  set_rs(hard_adr, offset + 3,  (0bfh)) 			' LCR-reg		Enhanced feature reg enable
	  set_rs(hard_adr, offset + 4,  011h)   			' setting character for softwarehandshake Xon1     
	  set_rs(hard_adr, offset + 5,  012h)   			' setting character for softwarehandshake Xon2
	  set_rs(hard_adr, offset + 6,  013h)   			' setting character for softwarehandshake Xoff1
	  set_rs(hard_adr, offset + 7,  014h)   			' setting character for softwarehandshake Xoff2
	  if (handshake = 0) then 
	    set_rs(hard_adr, offset + 2, 010h) 			' EFR-reg		no handshake(RS232) + enhanced functions enabeld
	  endif
	  if (handshake = 1) then
	    set_rs(hard_adr, offset + 2, 0d0h) 			' EFR-reg		hardwarehandshake(RS232) + enhanced functions enabeld
	  endif
	  if (handshake = 2) then
	    set_rs(hard_adr, offset + 2, 01ah) 			' EFR-reg		softwarehandshake(RS232) (Xon1/Xoff1) + enhanced functions enabeld
	  endif
	  if (handshake = 3) then
	    set_rs(hard_adr, offset + 2, 090h) 			' EFR-reg		no handshake (RS485) + enhanced functions enabeld
	  endif
	  set_rs(hard_adr, offset + 3,  LCR_value)		' LCR-reg		Divisor latch disable; 8 Databits
	  set_rs(hard_adr, offset + 4 , 040h) 			' MCR reg		enable access to TCR and TLR register 
	  set_rs(hard_adr, offset + 6 , 087h) 			' TCR reg		FIFO trigger level
	  set_rs(hard_adr, offset + 4 , 04h) 			' MCR reg		FIFOrdy reg enable; is necessary to get status information of the FIFO
	  set_rs(hard_adr, offset + 2, 00fh) 			' FCR-reg		FIFOs enable, FIFOs clear, DMA Mode1
	endsub
	
	
	'***************************************************************
	'Reset for the ADwin module (serial interface module)
	'card : dip switch address
	'***************************************************************
	sub rs_reset(card)
	  set_rs(card, 23, 1)    			  ' reset aktiv
	  set_rs(card, 23, 0)    			  ' reset not aktiv
	endsub
	
	
	
	'***************************************************************
	'Writes a byte to the transmit FIFO, if the FIFO is not full
	'card : dip switch address
	'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
	'value : value which should be written to the FIFO
	'return value: 
	'write_fifo : 0 = byte is written
	'             1 = FIFO full
	'***************************************************************
	
	function write_fifo(card,channel,value) as integer
	dim hard_adr as integer				' phyisical address of the ADwin module (basic address)
	dim offset as integer				' offset for the selected serial interface
	dim bit as integer
	dim fifo_free as integer			' FIFO status
	  if (channel = 1) then bit = 01h		' select the bit, which indicates the status of the selected FIFO
	  if (channel = 2) then bit = 08h
	  if (channel = 3) then bit = 02h
	  if (channel = 4) then bit = 04h
	  fifo_free = get_rs(card, 7) and bit
	  if (fifo_free  <> 0) then 			' If the FIFO is not full then the byte is written
	    offset = ((channel - 1) and 1) * 8
	    if (channel >= 3) then 
	      hard_adr = card + 1 
	    else
	      hard_adr = card 
	    endif
	    set_rs(hard_adr,offset, value)	  	' Writeing byte to transmit FIFO
	    write_fifo = 0        			' return value: byte is written successful to the transmit FIFO
	  else 
	    write_fifo = 1				' return value: Fifo full; byte is not written
	  endif
	endfunction
	
	
	'***************************************************************
	'checks if there is any more data to transmit
	'card : dip switch address
	'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
	'return value: 
	'check_shift_reg : 0 = Shift register and transmit hold are empty
	'            	 1 = Shift register and transmit hold are not empty
	'***************************************************************
	
	function check_shift_reg(card,channel) as integer
	dim hard_adr as integer				' phyisical address of the ADwin module (basic address)
	dim offset as integer				' offset for the selected serial interface
	dim ret as integer				' return value
	  offset = ((channel - 1) and 1) * 8
	  if (channel >= 3) then 
	    hard_adr = card + 1 
	  else
	    hard_adr = card 
	  endif
	  ret = get_rs(hard_adr,offset + 5) and 64	' reading the status byte
	  if (ret = 64) then
	    check_shift_reg = 0
	  else 
	    check_shift_reg = 1
	  endif
	endfunction
	
	
	'***************************************************************
	'Read byte from the receive FIFO
	'card : dip switch address
	'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
	'return value: 
	'read_fifo : 0 - 255 = value of the received byte
	'            -1 = no bytes in the receive FIFO
	'***************************************************************
	
	function read_fifo(card,channel) as integer
	dim hard_adr as integer				' phyisical address of the ADwin module (basic address)
	dim bit as integer				  
	dim offset as integer				' offset for the selected serial interface
	dim fifo_status as integer			' FIFO status
	  offset = ((channel - 1) and 1) * 8
	  if (channel >= 3) then 
	    hard_adr = card + 1 
	  else
	    hard_adr = card 
	  endif
	  fifo_status = get_rs(hard_adr,offset + 5) and 1   
	  if (fifo_status <> 0) then			' read byte, if there is a byte in the receive FIFO
	    read_fifo = get_rs(hard_adr,offset)	' read byte from receive FIFO (return value = value of the received byte)
	  else
	    read_fifo = -1				' no new byte in the receive FIFO (return value = -1)
	  endif
	endfunction
	
	'***************************************************************
	'Only for RS485.
	'Selects whether the interface is sending data or is listening on the bus.
	'card : dip switch address
	'channel : number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
	'value :	0 = Listening
	'           1 = Sending Data
	'           2 = Sending Data + Listening
	'***************************************************************
	
	sub rs485_send(card,channel,value)
	dim hard_adr as integer				' physical address of the ADwin module (basic address)
	dim offset as integer				' offset for the selected serial interface
	dim reg_value as integer
	  if (value = 0) then reg_value = 5
	  if (value = 1) then reg_value = 6
	  if (value = 2) then reg_value = 7
	  offset = ((channel - 1) and 1) * 8
	  if (channel >= 3) then 
	    hard_adr = card + 1 
	  else
	    hard_adr = card 
	  endif
	  set_rs(hard_adr,offset + 4,reg_value)	'setting the RTS-Pin
	endsub
	
	'------------------CAN
	
	'***************************************************************
	'Enables a message object for receiving messages.
	'Disables all interrups of the message object.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
	'objectnumber : Number of the message object
	'Identifier : incomming frames are accepted by this message object, if the identifier matches the frame identifier
	'extended: Determines whether the identifier is 11 or 29 Bit
	'	     0 = 11 Bit Identifier 	
	'	     1 = 29 Bit Identifier 	
	'***************************************************************
	
	sub en_receive(card,channel,objectnumber,identifier,extended)
	    set_can_reg(card,channel, objectnumber * 16, 149)							'enable message object
	    if (extended = 0) then 
	      set_can_reg(card,channel, objectnumber * 16 + 6, 128)						'read; DLC = 8 ; 11 Bit Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,3)and 255))  'Set Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
	    else
	      set_can_reg(card,channel, objectnumber * 16 + 6, 132)						'read; DLC = 8 ; 29 Bit Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,21)and 255))	'Set Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
	      set_can_reg(card,channel, objectnumber * 16 + 4, (shift_right(identifier,5)and 255))  
	      set_can_reg(card,channel, objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
	    endif
	endsub
	
	
	'***************************************************************
	'Enables a message object for transmitting messages.
	'Disables all interrups of the message object.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
	'objectnumber : Number of the message object
	'Identifier : identifier for the frames which will be transmitted
	'extended: Determines whether the identifier is 11 or 29 Bit 
	'	     0 = 11 Bit Identifier 	
	'	     1 = 29 Bit Identifier 	
	'***************************************************************
	
	sub en_transmit(card,channel,objectnumber,identifier,extended)
	    set_can_reg(card,channel, objectnumber * 16, 149)							'enable message object
	    if (extended = 0) then 
	      set_can_reg(card,channel, objectnumber * 16 + 6, 136)						'write; DLC = 8 ; 11 Bit Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,3)and 255))	'Set Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
	    else
	      set_can_reg(card,channel, objectnumber * 16 + 6, 140)						'write; DLC = 8 ; 29 Bit Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 2, (shift_right(identifier,21)and 255))	'Set Identifier
	      set_can_reg(card,channel, objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
	      set_can_reg(card,channel, objectnumber * 16 + 4, (shift_right(identifier,5)and 255))	
	      set_can_reg(card,channel, objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
	    endif
	endsub
	
	
	
	'***************************************************************
	'Initialisation of the CAN-controller.
	'All message objects will be disabled.
	'Bitrat: 1MBit/s
	'Acceptance filter : Must match
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
	'***************************************************************
	
	sub init_can(card,channel)
	dim counter as integer
	dim adr1 as integer
	
	  adr1 = 0c0h or (shift_left(card, 8)) or (38 + channel)
	
	 	  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke(adwr, adr1)					 ' Reset the CAN-Controllers (Hardwarereset)
	  nop_t9
	  poke_nop(dlx, 1)
		  #IF PROZESSOR = T9 THEN						'This part enables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	#IF PROZESSOR = T9 THEN						'Resetpin must be low for at least 1 ms
	  sleep(10000)
	#ELSE
	  nwtime=read_timer()
	  wait(1000)
	#ENDIF
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke(adwr, adr1)
	  nop_t9
	  poke_nop(dlx, 0)
		  #IF PROZESSOR = T9 THEN						'This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	
	    set_can_reg(card,channel, 0,65)				  'Access to the registers of the controller only for CPU
	
	    set_can_reg(card,channel, 2,65)				  'CPU interface register
	
	    set_can_reg(card,channel, 06h,0ffh)			  'Setting all masks to "must match"
	    set_can_reg(card,channel, 07h,0ffh)
	    set_can_reg(card,channel, 08h,0ffh)
	    set_can_reg(card,channel, 09h,0ffh)
	    set_can_reg(card,channel, 0ah,0ffh)
	    set_can_reg(card,channel, 0bh,0ffh)
	    set_can_reg(card,channel, 0ch,0ffh)
	    set_can_reg(card,channel, 0dh,0ffh)
	    set_can_reg(card,channel, 0eh,0ffh)
	    set_can_reg(card,channel, 0fh,0ffh)
	
	    set_can_reg(card,channel, 01fh,0)  			' Clock Out Register
	 
	    set_can_reg(card,channel, 02fh,0)  			'  Bus configuration register
	
	    set_can_reg(card,channel, 03fh,0)  			' Bit Timing register 0  
	
	    set_can_reg(card,channel, 04fh,032h)  			' Bit Timing register 1 
	
	
	  for counter = 1 to 15					'Disable all message objects
	    set_can_reg(card,channel, counter * 16,85)
	    set_can_reg(card,channel, counter * 16 + 1,85)
	  next counter 
	
	    set_can_reg(card,channel, 0,0)				'Access to the registers of the controller only for Application 
	endsub
	
	
	
	
	'***************************************************************
	'The function checks, if there is a new frame in the selected
	'message object. If there is a new frame all databytes are read
	'and then written to the array "can_msg".
	'The number of dadabytes is written to the element 9 of the array "can_msg".
	'The return value of the function is the identifier of the frame. 
	'If there is no new frame in the message box the return value is -1.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
	'msg_nummer : number of the message object
	'***************************************************************
	
	
	function read_msg(card,channel,msg_number) as integer
	  dim new as integer                                           ' new message in the message object
	  dim id0,id1,id2,id3 as integer                               ' Identifier Byte 0 and 1
	  dim counter as integer                                         
	  dim buffer as integer							   
	  dim id_lenght as integer						   ' buffer to distinguish 11 and 29 bit identifier
	
	  new = get_can_reg(card,channel, msg_number * 16 + 1) and 3           ' Check, if a new frame in arrived
	if (new =2) then                                               ' New frame is arrived
	    buffer = (get_can_reg(card,channel, msg_number * 16 + 6))
	    can_msg[9] = shift_right((buffer and 0f0h),4)               ' Number of databytes
	    id_lenght = buffer and 4
	
	    id0 = get_can_reg(card,channel, msg_number * 16 + 2)		' Identifier registers
	    id1 = get_can_reg(card,channel, msg_number * 16 + 3)
	    if (id_lenght = 4) then
	      id2 = get_can_reg(card,channel, msg_number * 16 + 4)		
	      id3 = get_can_reg(card,channel, msg_number * 16 + 5)
	    endif
	
	    for counter = 1 to can_msg[9]					' reading databytes
	      can_msg[counter] = get_can_reg(card,channel, (msg_number * 16) +counter+6)
	    next counter
	
	    set_can_reg(card,channel, msg_number * 16 , 0fdh) 				' Reset the new data flag
	    set_can_reg(card,channel, msg_number * 16 +1 , 85) 
	    if (id_lenght = 0) then
	      read_msg = (shift_right(id1,5)) or (shift_left(id0,3))        ' return value = 11 bit identifier
	    else
	      read_msg = (shift_right(id3,3)) or (shift_left(id2,5)) or (shift_left(id1,13)) or (shift_left(id0,21))        ' return value = 29 bit identifier
	    endif
	else
	  read_msg = -1                                                  ' return value = 0
	endif
	
	endfunction
	
	
	
	'***************************************************************
	'Transmitting a frame. 
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
	'msg_nummer : number of the message object
	'The databytes and the number of databytes have to be written in the
	'array "can_msg" before this subroutine is activated.
	'After this subroutine the frame is transmitted as soon as the 
	'CAN-bus allows it.
	'***************************************************************
	
	sub transmit(card,channel,msg_num)
	dim merker as integer
	dim counter as integer
	
	  for counter = 1 to can_msg[9]
	    set_can_reg(card,channel, (msg_num * 10h)+counter+6,can_msg[counter]) 	'copy datas
	  next counter
	
	
	  ' Anzahl der Datenbytes bergeben
	  merker = get_can_reg(card,channel, (msg_num * 10h)+6)      	'read register
	  merker = merker and 0fh                         	'change DLC Bits 
	  merker = merker or shift_left(can_msg[9],4)
	  set_can_reg(card,channel, msg_num *16 +6,merker)           	'write register
	  
	  set_can_reg(card,channel, msg_num * 16 +1, 102)		  	' Control register (setting bit to transmit data)
	ENDSUB
	
	
	'***************************************************************
	'Enable the interrupt of a message object.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module
	'          (also necessary if the module provides only one channel)
	'msg_nummer : number of the message object
	'***************************************************************
	sub en_interrupt(card,channel,msg_num)
	  set_can_reg(card,channel, msg_num * 16, 0ebh) 	'Enable interrupt of the message object.
	  set_can_reg(card,channel, 0, 02h)			'Enable global interrupt.
	endsub
	
	
	
	'***************************************************************
	'Setting a register of the CAN-controller.
	'card : dip switch address
	'register_no : register which should be set
	'value : value which should be written to the register.
	'***************************************************************
	
	
	sub set_can_reg(card,channel,register_no, value)   
	dim adr1 as integer  
	dim adr2 as integer  
	  adr1 = 0c0h or (shift_left(card, 8)) or ((channel-1)*8)
	  adr2 = adr1 or (1+((channel-1)*8))
		  #IF PROZESSOR = T9 THEN			'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke(adwr ,adr2)
	  nop_t9
	  poke_nop(dlx ,register_no)
	  poke(adwr ,adr1)
	  nop_t9
	  poke_nop(dlx ,value)
		  #IF PROZESSOR = T9 THEN						'This part enables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	endsub
	
	
	'***************************************************************
	'Reading a register of the CAN-controller.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module
	'          (also necessary if the module provides only one channel)
	'register_no : register to read
	'return value : value of the register
	'***************************************************************
	
	Function get_can_reg(card,channel,register_no) as integer
	dim adr1 as integer  
	dim adr2 as integer  
	  adr1 = 0c0h or (shift_left(card, 8)) or ((channel-1)*8)
	  adr2 = adr1 or (2+((channel-1)*8))
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke(adwr ,adr2)
	  nop_t9
	  poke_nop(dlx ,register_no)
	#IF PROZESSOR = T5 THEN
	  test =1*1*1*1
	#ELSE
	  #IF PROZESSOR = T9 THEN
	    sleep(6)
	 #ELSE 
	    test = SHIFT_LEFT(1,8)
	  #ENDIF
	#ENDIF
	  poke_nop(adrd ,adr1)
	  get_can_reg = peek(dlx) and 255
		  #IF PROZESSOR = T9 THEN						'This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	endfunction
	
	
	'***************************************************************
	'Reading the register where the bus error pin of the tranceiver
	'is sored.
	'The register is set when the a bus error occurs and is reset by 
	'reading the register.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module
	'          (also necessary if the module provides only one channel)
	'return value : 0 = no error
	'               1 = error
	'Attention: This command is only for low-speed CAN
	'***************************************************************
	
	Function get_line_status(card,channel) as long
	dim adr as long
	    adr =  0c0h or shift_left(card, 8) or (3Dh - channel)
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	    poke_nop(ADRD, adr)
	    get_line_status = peek(DLX)
		  #IF PROZESSOR = T9 THEN						'This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	endfunction
	
	'***************************************************************
	'Function only for internal use.
	'***************************************************************
	
	function round(value) as long
	dim buffer as float
	  buffer = value + 0.5
	  round = buffer
	endfunction
	
	'***************************************************************
	'Function only for internal use.
	'***************************************************************
	
	function int_check(fl,int) as long
	dim fbuffer as float
	  fbuffer = fl-int
	  if ((fbuffer >= 0.00001) or (fbuffer <= -0.00001)) then 
	    int_check = 1				'not equal
	  else
	    int_check = 0				'equal
	  endif
	endfunction
	
	
	
	'***************************************************************
	'Function is setting the baudrate of the CAN-Bus.
	'card : dip switch address
	'channel : number of the CAN interface on the CAN module
	'          (also necessary if the module provides only one channel)
	'rate : CAN-Bus baudrate
	'return value : 0 = baudrate is set 
	'		    1 = the selected baudrate is not set 
	'***************************************************************
	
	function set_can_baudrate(card,channel,rate) as long
	dim scale as long
	dim fbuffer as float
	dim lbuffer as long
	dim back as long
	dim tseg1 as long  
	dim tseg2 as long  
	dim brp as long  
	dim btr0 as long  
	dim btr1 as long  
	  set_can_baudrate = 0					'Initialisation
	  fbuffer = 8000000 / rate
	  scale = round(fbuffer)				'total scale to achive the baudrate
	  set_can_baudrate = int_check(fbuffer,scale)	'1 if baudrate not possible
	
	  if (set_can_baudrate = 0) then			'If baudrate possible then find settings
	    brp = (scale - 1) / 25				'Prescaler
	
	    do 							'find the right brp
	      fbuffer = (scale / (brp + 1) - 3)
	      lbuffer = round(fbuffer)
	      back = int_check(fbuffer,lbuffer)		'inc prescaler until tseg1 + tseg 2 is an integer
	      inc(brp)
	    until((back = 0) or (fbuffer<5)) 
	    dec(brp)
	    if (back <> 0) then set_can_baudrate = 1
	  endif
	
	  if (set_can_baudrate = 0) then			'If there is a correct prescaler
	    tseg2 = lbuffer * 0.4
	    tseg1 = lbuffer - tseg2
	    if (tseg2 > 7) then
	      do
	        dec(tseg2)
	        inc(tseg1)
	      until(tseg2 = 7)
	    endif 
	    btr0 = brp						'Synchronization jump width = 1 (bits = 0)
	    btr1 = tseg1 + shift_left(tseg2,4)		'one sampling each Bit
	    set_can_reg(card,channel,0,65) 			'enable access to btr regisers
	    set_can_reg(card,channel,3fh,btr0)		'set btr0 regisers
	    set_can_reg(card,channel,4fh,btr1)		'set btr1 regisers
	    set_can_reg(card,channel,0,0) 			'disable access to btr regisers
	  endif
	endfunction
	
	
	
	
	
	'-------------------Anybus
	
	'*****************************************************************
	'Getting a byte from the DPRAM of a profibus-DP master or slave
	' 	card  : dip switch address 
	'	bytenumber: number of the byte on the DPRAM
	'*****************************************************************
	function get_pro_byte(card,bytenumber) as long
	dim adr as long
	  adr = 80c0h or shift_left(card,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63) 
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke_nop(adrd, adr)
	  get_pro_byte=peek(dlx) 
		  #IF PROZESSOR = T9 THEN						'This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	endfunction
	
	'*****************************************************************
	'Setting a byte in the DPRAM of a profibus-DP master or slave
	' 	card  : dip switch address 
	'	bytenumber: number of the byte on the DPRAM
	'     value : value for the selected byte
	'*****************************************************************
	sub set_pro_byte(card,bytenumber,value)
	dim adr as long
	  adr = 80c0h or shift_left(card,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63) 
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke(adwr, adr) 
	  nop_t9
	  poke_nop(dlx, value) 
		  #IF PROZESSOR = T9 THEN						'This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	endsub
	
	
	'*****************************************************************
	'Hardware reset on the HMS Module
	' 	card  : dip switch address 
	'*****************************************************************
	sub Hardware_reset(card)
	dim adr as long
	  adr = 0c0h or (shift_left(card, 8)) or 39
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke(adwr, adr) 
	  nop_t9
	  poke_nop(dlx, 1) 
		  #IF PROZESSOR = T9 THEN						'This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
		  #IF PROZESSOR = T9 THEN						'Reset signal must be low for at least 5s
	          sleep(50)
	        #ELSE
	          wait(5)
	        #ENDIF
		  #IF PROZESSOR = T9 THEN						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      BEGIN_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
	  poke(adwr, adr) 
	  nop_t9
	  poke_nop(dlx, 0) 
		  #IF PROZESSOR = T9 THEN						'This part disables the interrupt.
		    #IF PRIORITAET = LOW
		      END_CRITICAL_SECTION
		    #ENDIF
		  #ENDIF
		  #IF PROZESSOR = T9 THEN						'Wait until the module has finished his internal initialisation
	          sleep(3000000)
	        #ELSE
	          wait(300000)
	        #ENDIF
	endsub
	
	
	
	'Slave
	
	'********************************************************
	'This function is for mailbox handling. When the in mailbox
	'is set the mail is sent with this command.
	'********************************************************
	sub send_mail(card)
	dim buffer as long
	  buffer = get_pro_byte(card,app_ind)
	  set_pro_byte(card,app_ind,buffer xor 80h)
	endsub
	
	
	'********************************************************
	'This function is for mailbox handling. If the in mailbox
	'is free to handle a new mailbox communication the return
	'value is 0 else the return value is 1.
	'********************************************************
	function check_inbox_free(card) as long
	dim buffer1 as long
	dim buffer2 as long
	  buffer1 = get_pro_byte(card,app_ind) and 080h
	  buffer2 = get_pro_byte(card,any_ind) and 080h
	  if (buffer1 = buffer2) then
	    check_inbox_free = 0
	  else
	    check_inbox_free = 1
	  endif
	endfunction
	
	'********************************************************
	'This function is for mailbox handling. Checks if new
	'data is in the out mailbox. If there is new data the 
	'return value is 0, else the return value is 1.
	'********************************************************
	function check_outbox_full(card) as long
	dim buffer1 as long
	dim buffer2 as long
	  buffer1 = get_pro_byte(card,app_ind) and 040h
	  buffer2 = get_pro_byte(card,any_ind) and 040h
	  if (buffer1 = buffer2) then
	    check_outbox_full = 1
	  else
	    check_outbox_full = 0
	  endif
	endfunction
	
	'********************************************************
	'This function is for mailbox handling. The function is 
	'waiting until the in mailbox is free to handle a new
	'mailbox communication. The return value is 0 when the
	'waiting was successful, else the return value is 08000h.
	'********************************************************
	function wait_inbox_free(card) as long
	dim buffer1 as long
	dim counter as long
	  counter = 0
	  do
	    inc counter
	    buffer1 = check_inbox_free(card)
	  until((counter > 10000000) or (buffer1 = 0))
	  if (counter > 10000000) then
	    wait_inbox_free = 08000h					'mail failed
	  else
	    wait_inbox_free = 0						'mail sended
	  endif
	endfunction
	
	'********************************************************
	'This function is for mailbox handling. The function is 
	'waiting until the out mailbox is full to handle a new
	'mailbox communication. The return value is 0 when the
	'waiting was successful, else the return value is 04000h.
	'********************************************************
	function wait_outbox_full(card) as long
	dim buffer1 as long
	dim counter as long
	  counter = 0
	  do
	    inc counter
	    buffer1 = check_outbox_full(card)
	  until((counter > 10000000) or (buffer1 = 0))
	  if (counter > 10000000) then
	    wait_outbox_full = 04000h					'mail failed
	  else
	    wait_outbox_full = 0					'mail sended
	  endif
	endfunction
	
	'********************************************************
	'This procedure is for mailbox handling. If a new mail 
	'is in out mailbox and is read. This command gives an
	'ACK. The next message can be received now.
	'********************************************************
	sub ack_mail(card)
	dim buffer1 as long
	dim buffer2 as long
	  buffer1 = get_pro_byte(card,any_ind) and 040h
	  buffer2 = ((get_pro_byte(card,app_ind) and 0bfh) or buffer1)
	  set_pro_byte(card,app_ind,buffer2)
	endsub
	
	'********************************************************
	'This procedure is for initialisation of the anybus module 
	'via mailbox. The in mailbox is set to start the 
	'initialisation.
	'********************************************************
	sub set_mailbox_start_init(card)
	  set_pro_byte(card,mail_in_0,000h)
	  set_pro_byte(card,mail_in_1,001h)
	  set_pro_byte(card,mail_in_2,040h)
	  set_pro_byte(card,mail_in_3,001h)
	  set_pro_byte(card,mail_in_4,000h)
	  set_pro_byte(card,mail_in_5,001h)
	  set_pro_byte(card,mail_in_6,000h)
	  set_pro_byte(card,mail_in_7,000h)
	  set_pro_byte(card,mail_in_8,000h)
	  set_pro_byte(card,mail_in_9,001h)
	  set_pro_byte(card,mail_in_a,000h)
	  set_pro_byte(card,mail_in_b,001h)
	  set_pro_byte(card,mail_in_c,000h)
	  set_pro_byte(card,mail_in_d,000h)
	  set_pro_byte(card,mail_in_e,000h)
	  set_pro_byte(card,mail_in_f,000h)
	endsub
	
	'********************************************************
	'This procedure is for initialisation of the anybus module 
	'via mailbox. The in mailbox is set to terminate the 
	'initialisation.
	'********************************************************
	sub set_mailbox_end_init(card)
	  set_pro_byte(card,mail_in_0,000h)
	  set_pro_byte(card,mail_in_1,001h)
	  set_pro_byte(card,mail_in_2,040h)
	  set_pro_byte(card,mail_in_3,001h)
	  set_pro_byte(card,mail_in_4,000h)
	  set_pro_byte(card,mail_in_5,003h)
	  set_pro_byte(card,mail_in_6,000h)
	  set_pro_byte(card,mail_in_7,000h)
	  set_pro_byte(card,mail_in_8,000h)
	  set_pro_byte(card,mail_in_9,001h)
	  set_pro_byte(card,mail_in_a,000h)
	  set_pro_byte(card,mail_in_b,001h)
	  set_pro_byte(card,mail_in_c,000h)
	  set_pro_byte(card,mail_in_d,000h)
	  set_pro_byte(card,mail_in_e,000h)
	  set_pro_byte(card,mail_in_f,000h)
	endsub
	
	'********************************************************
	'This procedure is for initialisation of the anybus module 
	'via mailbox. The in mailbox is set to check the bus  
	'specific hardware.
	'********************************************************
	sub set_mailbox_hw_chk(card)
	  set_pro_byte(card,mail_in_0,000h)
	  set_pro_byte(card,mail_in_1,001h)
	  set_pro_byte(card,mail_in_2,040h)
	  set_pro_byte(card,mail_in_3,001h)
	  set_pro_byte(card,mail_in_4,000h)
	  set_pro_byte(card,mail_in_5,006h)
	  set_pro_byte(card,mail_in_6,000h)
	  set_pro_byte(card,mail_in_7,000h)
	  set_pro_byte(card,mail_in_8,000h)
	  set_pro_byte(card,mail_in_9,001h)
	  set_pro_byte(card,mail_in_a,000h)
	  set_pro_byte(card,mail_in_b,001h)
	  set_pro_byte(card,mail_in_c,000h)
	  set_pro_byte(card,mail_in_d,000h)
	  set_pro_byte(card,mail_in_e,000h)
	  set_pro_byte(card,mail_in_f,000h)
	endsub
	
	'********************************************************
	'This procedure is for initialisation of the anybus module 
	'via mailbox. The in mailbox is set to configure the 
	'module according to the user defined values.
	'********************************************************
	sub set_mailbox_anybus_init(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt)
	dim space_in, space_out as long
	dim io_in_low,io_in_high,io_out_low,io_out_high,space_in_low,space_in_high,space_out_low,space_out_high as long
	  space_in = IO_in + par_in 
	  space_out = IO_out + par_out
	  io_in_low = io_in and 0ffh
	  io_in_high = shift_right(io_in,8) and 0ffh
	  io_out_low = io_out and 0ffh
	  io_out_high = shift_right(io_out,8) and 0ffh
	  space_in_low = space_in and 0ffh
	  space_in_high = shift_right(space_in,8) and 0ffh
	  space_out_low = space_out and 0ffh
	  space_out_high = shift_right(space_out,8) and 0ffh
	
	  set_pro_byte(card,mail_in_0,000h)
	  set_pro_byte(card,mail_in_1,00ah)
	  set_pro_byte(card,mail_in_2,040h)
	  set_pro_byte(card,mail_in_3,001h)
	  set_pro_byte(card,mail_in_4,000h)
	  set_pro_byte(card,mail_in_5,002h)
	  set_pro_byte(card,mail_in_6,000h)
	  set_pro_byte(card,mail_in_7,012h)
	  set_pro_byte(card,mail_in_8,000h)
	  set_pro_byte(card,mail_in_9,001h)
	  set_pro_byte(card,mail_in_a,000h)
	  set_pro_byte(card,mail_in_b,001h)
	  set_pro_byte(card,mail_in_c,000h)
	  set_pro_byte(card,mail_in_d,000h)
	  set_pro_byte(card,mail_in_e,000h)
	  set_pro_byte(card,mail_in_f,000h)
	
	  set_pro_byte(card,0420h,io_in_high)
	  set_pro_byte(card,0421h,io_in_low)
	  set_pro_byte(card,0422h,space_in_high)
	  set_pro_byte(card,0423h,space_in_low)
	  set_pro_byte(card,0424h,space_in_high)
	  set_pro_byte(card,0425h,space_in_low)
	  set_pro_byte(card,0426h,io_out_high)
	  set_pro_byte(card,0427h,io_out_low)
	  set_pro_byte(card,0428h,space_out_high)
	  set_pro_byte(card,0429h,space_out_low)
	  set_pro_byte(card,042ah,space_out_high)
	  set_pro_byte(card,042bh,space_out_low)
	  set_pro_byte(card,042ch,input_handling)
	  set_pro_byte(card,042dh,output_handling)
	  set_pro_byte(card,042eh,000h)
	  set_pro_byte(card,042fh,interrupt)
	endsub
	
	'********************************************************
	'This function checks, if the responding mail to the 
	'start_init mail is ok. If ok return value is 0, else
	'return value is 2.
	'********************************************************
	function check_mailbox_start_init(card) as long
	  check_mailbox_start_init = 0
	  if (get_pro_byte(card,mail_out_1) <> 01h) then check_mailbox_start_init = 2
	  if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_start_init = 2
	  if (get_pro_byte(card,mail_out_5) <> 01h) then check_mailbox_start_init = 2
	  if (get_pro_byte(card,mail_out_7) <> 00h) then check_mailbox_start_init = 2
	  if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_start_init = 2
	  if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_start_init = 2
	  if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_start_init = 2
	  if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_start_init = 2
	endfunction
	
	'********************************************************
	'This function checks, if the responding mail to the 
	'end_init mail is ok. If ok return value is 0, else
	'return value is 080h.
	'********************************************************
	function check_mailbox_end_init(card) as long
	  check_mailbox_end_init = 0
	  if (get_pro_byte(card,mail_out_1) <> 01h) then check_mailbox_end_init = 080h
	  if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_end_init = 080h
	  if (get_pro_byte(card,mail_out_5) <> 03h) then check_mailbox_end_init = 080h
	  if (get_pro_byte(card,mail_out_7) <> 00h) then check_mailbox_end_init = 080h
	  if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_end_init = 080h
	  if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_end_init = 080h
	  if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_end_init = 080h
	  if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_end_init = 080h
	endfunction
	
	'********************************************************
	'This function checks, if the responding mail to the 
	'anybus_init mail is ok. If ok return value is 0, else
	'return value is 4.
	'********************************************************
	function check_mailbox_anybus_init(card) as long
	  check_mailbox_anybus_init = 0
	  if (get_pro_byte(card,mail_out_1) <> 0ah) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,mail_out_5) <> 02h) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,mail_out_7) <> 012h) then check_mailbox_anybus_init =4
	  if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,053eh) <> 00h) then check_mailbox_anybus_init = 4
	  if (get_pro_byte(card,053fh) <> 00h) then check_mailbox_anybus_init = 4
	endfunction
	
	'********************************************************
	'This function checks, if the responding mail to the 
	'hw_chk mail is ok. If ok return value is 0 else
	'return value is 1.
	'********************************************************
	function check_mailbox_hw_chk(card) as long
	  check_mailbox_hw_chk = 0
	  if (get_pro_byte(card,mail_out_1) <> 01h) then check_mailbox_hw_chk = 1
	  if (get_pro_byte(card,mail_out_3) <> 01h) then check_mailbox_hw_chk = 1
	  if (get_pro_byte(card,mail_out_5) <> 06h) then check_mailbox_hw_chk = 1
	  if (get_pro_byte(card,mail_out_7) <> 00h) then check_mailbox_hw_chk = 1
	  if (get_pro_byte(card,mail_out_9) <> 01h) then check_mailbox_hw_chk = 1
	  if (get_pro_byte(card,mail_out_b) <> 01h) then check_mailbox_hw_chk = 1
	  if (get_pro_byte(card,mail_out_d) <> 00h) then check_mailbox_hw_chk = 1
	  if (get_pro_byte(card,mail_out_f) <> 00h) then check_mailbox_hw_chk = 1
	endfunction
	
	
	'********************************************************
	'This function checks, if the DPRAM is ok.
	'If ok return value is 0, else return value is 040h.
	'The elements of the watchdog and the handshake are not 
	'checked. This will result in errors.
	'********************************************************
	function dpram_test(card) as long
	dim counter as long
	dim byte as long
	dim buffer as long
	  dpram_test = 0
	  for counter = 00h to 07d3h
	    byte = get_pro_byte(card,counter)					'save value
	    set_pro_byte(card,counter,(counter and 0ffh))			'write new value
	    buffer = get_pro_byte(card,counter)					'check new value
	    set_pro_byte(card,counter,byte)						'write back old value
	    if (buffer <> (counter and 0ffh)) then dpram_test = 040h	
	  next counter
	  for counter = 7d6h to 7fdh
	    byte = get_pro_byte(card,counter)
	    set_pro_byte(card,counter,(counter and 0ffh))
	    buffer = get_pro_byte(card,counter)
	    set_pro_byte(card,counter,byte)
	    if (buffer <> (counter and 0ffh)) then dpram_test = 040h
	  next counter
	endfunction
	
	'************************************************************************
	'Function to initialize an anybus module.
	'Attention: This function can only be used after power up.
	'Attention: This function can only be used in a low init part.
	'		Do not use in a high priority process.
	'Attention: input and output size must be equal. (INTERBUS)
	'card : dip switch address
	'IO_in:		number of input bytes for fast data exchange
	'par_in:		number of input bytes for parameter data exchange
	'IO_out:		number of output bytes for fast data exchange
	'par_out:		number of output bytes for parameter data exchange
	'input_handling:	bit0:	0 = input area cleared on application stopped
	'				1 = input area freezed on application stopped
	'			bit1:	0 = changed data field not activated
	'				1 = changed data field activated
	'output_handling:	bit0:	0 = Fieldbus OFF-line
	'				1 = Fieldbus ON-line
	'			bit1:	0 = output area cleared on fieldbus stopped
	'				1 = output area freezed on fieldbus stopped
	'interrupt:		bit0:	0 = no interrupt on data changed 
	'				1 = interrupt on data changed
	'			bit1:	0 = no interrupt Fieldbus OFF-line
	'				1 = interrupt Fieldbus OFF-line
	'			bit2:	0 = no interrupt Fieldbus ON-line
	'				1 = interrupt Fieldbus ON-line
	'return value:	0 = no error; initialisation OK
	'			bit1 = 0:	anybus hardware_check failed 
	'			bit1 = 1:	mailbox start_init failed 
	'			bit1 = 2:	mailbox anybus_init failed 
	'			bit1 = 3:	reseved for further use 
	'			bit1 = 4:	reseved for further use  
	'			bit1 = 5:	reseved for further use  
	'			bit1 = 6:	dpram check failed  
	'			bit1 = 7:	mailbox end_init failed 
	'			bit1 = 8:	reseved for further use  
	'			bit1 = 9:	reseved for further use  
	'			bit1 = 10:	reseved for further use  
	'			bit1 = 11:	reseved for further use  
	'			bit1 = 12:	reseved for further use  
	'			bit1 = 13:	reseved for further use  
	'			bit1 = 14:	mail was not received
	'			bit1 = 15:	mail was not send 
	'************************************************************************
	function init_slave(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt) as long
	dim buffer as long
	  init_slave = 0
	  buffer = get_pro_byte(card,07ffh)			'clear interrupt
	  buffer = 0
	
	'DPRAM_check (not via mailbox)
	  buffer = dpram_test(card)
	  init_slave = init_slave or buffer
	
	'Mailbox operations
	'Hardware_check
	  buffer = wait_inbox_free(card)			'waiting until in mailbox is free
	  init_slave = init_slave or buffer
	  set_mailbox_hw_chk(card)				'setting the in mailbox
	  send_mail(card)						'send mail
	  buffer = wait_inbox_free(card)			'wait until in mail was send
	  init_slave = init_slave or buffer
	  buffer = wait_outbox_full(card)			'wait until out mail was received
	  init_slave = init_slave or buffer
	  buffer = check_mailbox_hw_chk(card)		'check out mail (hw ok)
	  init_slave = init_slave or buffer
	  ack_mail(card)						'acknowledge mail
	
	'start_init
	  buffer = wait_inbox_free(card)			'waiting until in mailbox is free
	  init_slave = init_slave or buffer
	  set_mailbox_start_init(card)			'setting in mailbox
	  send_mail(card)						'send mail
	  buffer = wait_inbox_free(card)			'wait until in mail was send
	  init_slave = init_slave or buffer
	  buffer = wait_outbox_full(card)			'wait until out mail was received
	  init_slave = init_slave or buffer
	  buffer = check_mailbox_start_init(card)		'check out mail (init start ok)
	  init_slave = init_slave or buffer
	  ack_mail(card)						'acknowledge mail
	
	'anybus_init
	  buffer = wait_inbox_free(card)			'waiting until in mailbox is free
	  init_slave = init_slave or buffer
	  set_mailbox_anybus_init(card,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt)		'setting the in mailbox
	  send_mail(card)						'send mail
	  buffer = wait_inbox_free(card)			'wait until in mail was send
	  init_slave = init_slave or buffer
	  buffer = wait_outbox_full(card)			'wait until out mail was received
	  init_slave = init_slave or buffer
	  buffer = check_mailbox_anybus_init(card)	'check out mail (init anybus ok)
	  init_slave = init_slave or buffer
	  ack_mail(card)						'acknowledge mail
	
	'end_init
	  buffer = wait_inbox_free(card)			'waiting until in mailbox is free
	  init_slave = init_slave or buffer
	  set_mailbox_end_init(card)				'setting in mailbox
	  send_mail(card)						'send mail
	  buffer = wait_inbox_free(card)			'wait until in mail was send
	  init_slave = init_slave or buffer
	  buffer = wait_outbox_full(card)			'wait until out mail was received
	  init_slave = init_slave or buffer
	  buffer = check_mailbox_end_init(card)		'check out mail (end init ok)
	  init_slave = init_slave or buffer
	  ack_mail(card)						'acknowledge mail
	endfunction
	
	'******************************************************
	'The function gives the information wether the data in
	'the out area has changen or not. If there is new data
	'the return value is <> 0 else the return value is 0.
	'size:	number of bytes of the out area.
	'******************************************************
	Function changed_data(card,size) as long
	dim loopsize as long
	dim buffer as long
	dim count as long
	  changed_data = 0
	  loopsize = (size - 1)/8 + 1
	  for count = 1 to loopsize
	    buffer = get_pro_byte(card,(count + 7E3h))
	    changed_data = changed_data or buffer
	  next count 
	endfunction
	
	
	'******************************************************
	'Request application access to DPRAM.
	'The DPRAM consists of 3 parts. Each part equals a bit
	'in the parameter array:
	'Bit 0: 	Anybus control registers
	'Bit 1: 	Output data
	'Bit 2: 	Input data
	'******************************************************
	sub request_access(card,array) as long
	dim buffer1 as long
	  buffer1 = get_pro_byte(card,app_ind) and 0f8H
	  set_pro_byte(card,app_ind,((buffer1 or array) or 010h))
	endsub
	
	'******************************************************
	'Request application access release to DPRAM.
	'The DPRAM consists of 3 parts. Each part equals a bit
	'in the parameter array:
	'Bit 0: 	Anybus control registers
	'Bit 1: 	Output data
	'Bit 2: 	Input data
	'******************************************************
	sub request_release_access(card,array) as long
	dim buffer1 as long
	  buffer1 = get_pro_byte(card,app_ind) and 0e8H
	  set_pro_byte(card,app_ind,(buffer1 or array))
	endsub
	
	'******************************************************
	'Check access right. If bit is set the application has
	'access right.
	'The DPRAM consists of 3 parts. Each part equals a bit
	'in the parameter array:
	'Bit 0: 	Anybus control registers
	'Bit 1: 	Output data
	'Bit 2: 	Input data
	'******************************************************
	function check_access(card) as long
	  check_access = get_pro_byte(card,any_ind) and 07h
	endfunction
	
	'*******************************************************
	'Reads the input data from the DPRAM
	'	card  :	 	dip switch address 
	'	array :		destination array for input data
	'	start :		first byte (DPRAM)
	'	count :		number of bytes
	'*******************************************************
	sub get_read_buffer(card,array,start,count)
	dim i as long
	  for i = start to (start + count - 1)
	    array[i + 1 - start] = get_pro_byte(card,i)
	  next i
	endsub
	
	
	
	'*******************************************************
	'Writes the output data to the DPRAM
	'	card  :	 	dip switch address 
	'	array :		source array for input data
	'	start :		first byte (DPRAM)
	'	count :		number of bytes
	'*******************************************************
	sub set_write_buffer(card,array,start,count)
	dim i as long
	  for i = start to (start + count - 1)
	    set_pro_byte(card,i,array[i+1])
	  next i
	endsub
	
	
	
	'Master
	
	'*******************************************************
	' Giving access right to DPRAM to device.
	' Set Pdcom and Pdack unequal.
	' Data exchange mode 3 and 4.
	' 	card  : dip switch address 
	'*******************************************************
	sub pass_access_3(card)
	dim byte as long						
	dim flag as long
	  byte = (get_pro_byte(card,control_to_host) and 04h) xor 4
	  flag = (get_pro_byte(card,control_to_device) and 0bh) 
	  byte = flag or byte
	  set_pro_byte(card,control_to_device,byte)
	endsub
	
	
	'*******************************************************
	' Giving access right to DPRAM to device.
	' Set Pdcom and Pdack equal.
	' Data exchange mode 0 and 1.
	' 	card  :	dip switch address 
	'*******************************************************
	sub pass_access_0(card)
	dim byte as long				
	dim flag as long
	  byte = (get_pro_byte(card,control_to_host) and 04h)
	  flag = (get_pro_byte(card,control_to_device) and 0bh) 
	  byte = flag or byte
	  set_pro_byte(card,control_to_device,byte)
	endsub
	
	
	
	'*******************************************************
	' communication via mailbox
	' slave diagnostic
	' 	card  :	dip switch address 
	' 	number:	unique message number 
	' 	slave :	ID of the selected slave 
	'*******************************************************
	sub slave_diagnostic(card,number,slave)
	  set_pro_byte(card,out_mailbox_0,3)
	  set_pro_byte(card,out_mailbox_1,16)
	  set_pro_byte(card,out_mailbox_2,8)
	  set_pro_byte(card,out_mailbox_3,number)
	  set_pro_byte(card,out_mailbox_4,0)  
	  set_pro_byte(card,out_mailbox_5,0)
	  set_pro_byte(card,out_mailbox_6,66)
	  set_pro_byte(card,out_mailbox_7,0)
	  set_pro_byte(card,out_mailbox_8,slave)
	  set_pro_byte(card,out_mailbox_9,0)
	  set_pro_byte(card,out_mailbox_a,0)
	  set_pro_byte(card,out_mailbox_b,0)
	  set_pro_byte(card,out_mailbox_c,0)
	  set_pro_byte(card,out_mailbox_d,32)
	  set_pro_byte(card,out_mailbox_e,5)
	  set_pro_byte(card,out_mailbox_f,1)
	endsub
	
	
	
	
	'*******************************************************
	' communication via mailbox
	' global control
	'	card  :	dip switch address 
	'	number:	unique number
	'	slave :	127 = all selected slaves (selected by group)
	'			0 - 126 = only one slave (slavenumber)
	'	command:	20h = sync
	'			10h = unsync
	'			08h = freeze
	'			04h = unfreeze
	'			02h = clear
	'	group:	group for which the command is valid
	'*******************************************************
	sub global_control(card,number,slave,command,group)
	  set_pro_byte(card,out_mailbox_0,3)
	  set_pro_byte(card,out_mailbox_1,16)
	  set_pro_byte(card,out_mailbox_2,3)
	  set_pro_byte(card,out_mailbox_3,number)
	  set_pro_byte(card,out_mailbox_4,0)  
	  set_pro_byte(card,out_mailbox_5,0)
	  set_pro_byte(card,out_mailbox_6,70)
	  set_pro_byte(card,out_mailbox_7,0)
	  set_pro_byte(card,out_mailbox_8,slave)
	  set_pro_byte(card,out_mailbox_9,command)
	  set_pro_byte(card,out_mailbox_a,group)
	endsub
	
	'*******************************************************
	' communication via mailbox
	' read statistic counter
	'	card  : dip switch address 
	' 	number:	unique message number 
	' 	start:	bus address of first slave 
	' 	count:	number of slaves
	'*******************************************************
	sub statistic(card,number,start,count)
	  set_pro_byte(card,out_mailbox_0,7)
	  set_pro_byte(card,out_mailbox_1,16)
	  set_pro_byte(card,out_mailbox_2,8)
	  set_pro_byte(card,out_mailbox_3,number)
	  set_pro_byte(card,out_mailbox_4,0)  
	  set_pro_byte(card,out_mailbox_5,0)
	  set_pro_byte(card,out_mailbox_6,0feh)
	  set_pro_byte(card,out_mailbox_7,0)
	  set_pro_byte(card,out_mailbox_8,start)
	  set_pro_byte(card,out_mailbox_9,0)
	  set_pro_byte(card,out_mailbox_a,0)
	  set_pro_byte(card,out_mailbox_b,0)
	  set_pro_byte(card,out_mailbox_c,0)
	  set_pro_byte(card,out_mailbox_d,count)
	  set_pro_byte(card,out_mailbox_e,5)
	  set_pro_byte(card,out_mailbox_f,1)
	endsub
	
	
	'*******************************************************
	' communication via mailbox
	' clear statistic counter
	'	card  :	dip switch address 
	' 	number:	unique message number 
	'*******************************************************
	sub clear_statistic(card,number)
	  set_pro_byte(card,out_mailbox_0,7)
	  set_pro_byte(card,out_mailbox_1,16)
	  set_pro_byte(card,out_mailbox_2,8)
	  set_pro_byte(card,out_mailbox_3,number)
	  set_pro_byte(card,out_mailbox_4,0)  
	  set_pro_byte(card,out_mailbox_5,0)
	  set_pro_byte(card,out_mailbox_6,0feh)
	  set_pro_byte(card,out_mailbox_7,0)
	  set_pro_byte(card,out_mailbox_8,0)
	  set_pro_byte(card,out_mailbox_9,0)
	  set_pro_byte(card,out_mailbox_a,0)
	  set_pro_byte(card,out_mailbox_b,0)
	  set_pro_byte(card,out_mailbox_c,0)
	  set_pro_byte(card,out_mailbox_d,0)
	  set_pro_byte(card,out_mailbox_e,5)
	  set_pro_byte(card,out_mailbox_f,4)
	endsub
	
	
	
	'*******************************************************
	'Communication via Mailbox
	'check if requested message is arrived
	'return value :  1 = message arrived
	'		     2 = message not arrived
	'*******************************************************
	function check_msg(card) as long			
	dim byte as long
	dim flag as long
	  byte = get_pro_byte(card,control_to_host) and 02h
	  flag = get_pro_byte(card,control_to_device) and 02h
	  par_3 = flag
	  par_4 = byte
	  if (byte = flag) then
	    check_msg = 1					' message arrived
	  else
	    check_msg = 2					' message not arrived
	  endif
	endfunction
	
	
	
	'*******************************************************
	'communicaion via mailbox.
	'Sending message to note.
	'After the initialisation of the Out_mailbox the message
	'must be send to the profibus.
	'	card  : dip switch address 
	'*******************************************************
	sub send_msg_to_note(card)
	dim byte as long
	dim flag as long
	  byte = ((get_pro_byte(card,control_to_host) and 02h) xor 02h)
	  flag = (get_pro_byte(card,control_to_device))
	  flag = (flag and 0dh) or byte
	  set_pro_byte(card,control_to_device,flag) 
	endsub
	
	
	'*******************************************************
	' Gives acknolage to arrived message
	'	card  : dip switch address 
	'*******************************************************
	sub ack_msg(card)				
	dim byte as long
	  byte = get_pro_byte(card,control_to_host) and 03h
	  set_pro_byte(card,control_to_device, byte)
	endsub
	
	
	'*******************************************************
	'Reset the Master Module
	'	access_mode:	0 = bus synchronus ; device controlled
	'				1 = bufferd ; device controlled
	'				2 = uncontrolled
	'				3 = bufferd ; user controlled
	'				4 = bus synchronus ; user controlled
	'	card  :	 	dip switch address 
	'*******************************************************
	sub reset_master(card,access_mode)
	  set_pro_byte(card,set_exchange_mode,access_mode)		'set access mode
	  set_pro_byte(card,control_to_device,080h)			'set reset flag
	endsub
	
	
	'*******************************************************
	'Initialisation of the Master Module
	'	access_mode:	0 = bus synchronus ; device controlled
	'				1 = bufferd ; device controlled
	'				2 = uncontrolled
	'				3 = bufferd ; user controlled
	'				4 = bus synchronus ; user controlled
	'	card  :	 	dip switch address 
	'*******************************************************
	sub init_master(card,access_mode)
	dim mode as long
	  set_pro_byte(card,set_exchange_mode,access_mode)
	  set_pro_byte(card,control_to_device,040h)
	endsub
	
	
	'*******************************************************
	'Check if the device or the host has access right
	'function only valid in access_mode 0 and 1
	'	card  :	 	dip switch address 
	'	return value :	1 = host
	'				2 = device
	'*******************************************************
	function check_access_0(card) as long
	dim byte as long  
	dim flag as long  
	  byte = get_pro_byte(card,control_to_host) and 04h
	  flag = get_pro_byte(card,control_to_device) and 04h
	  if (flag <> byte) then
	    check_access_0 = 1
	  else
	    check_access_0 = 2
	  endif
	endfunction
	
	'*******************************************************
	'Check if the device or the host has access right
	'function only valid in access_mode 3 and 4
	'	card  :	 	dip switch address 
	'	return value :	1 = host
	'				2 = device
	'*******************************************************
	function check_access_3(card) as long
	dim byte as long  
	dim flag as long  
	  byte = get_pro_byte(card,control_to_host) and 04h
	  flag = get_pro_byte(card,control_to_device) and 04h
	  if (flag = byte) then
	    check_access_3 = 1
	  else
	    check_access_3 = 2
	  endif
	endfunction
	
	
	
	'*******************************************************
	'Shows the statue of the master
	'	card  :	 	dip switch address 
	'bit7:	1 = device is ready
	'		0 = device is not ready
	'bit6:	1 = communication is running
	'		0 = communication is not running
	'bit5:	1 = data is getting exchanged
	'		0 = no data exchanged
	'*******************************************************
	function master_status(card) as long
	  master_status = get_pro_byte(card,control_to_host) and 0f0h
	endfunction
	
#ENDIF
#ENDIF 'not T11
