****************************************
*	 Prozenummer = 9
*	 Delay = 1
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 1	Level 1
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'#########################################################################################
'##################################  ADwin-Pro-STORAGE  ##################################
'##################################    Version 1.01b    ##################################
'#########################################################################################

SUB INIT_DATASAVE() '#####################################################################
	f_cmd[8]=1				'INIT progress: if 1 INIT is in progress
	'-------- initialize ring buffer (RB) --------------------------------------------------
	FOR n=1 TO rb_size								'clear all elements ...
		rb[n]=0														'of RB
	NEXT n
	'-------- set, and adjust if necessary, media specific time-out values -----------------
	rst=1200 : rpt=150000							'set max. RESET time (rst) and respond time (rpt)
	#IF PROZESSOR=T10 THEN						'if CPU is T10 (low-prio. process runs with 50s!)?
		rst=rst*2 : rpt=rpt*2							'adjust times
	#ENDIF
	'-------- read file info ---------------------------------------------------------------
	stat=MEDIA_STAT(mad)							'read status of media
	IF ((stat AND 1h)=1h) THEN				'media inserted?
		'-------- trigger off RESET ----------------------------------------------------------
		MEDIA_RST(mad)										'RESET_MEDIA
		stat=MEDIA_WFR(mad,24h,rst)				'wait till end of RESET & media not BUSY
		'-------- command: READ_SECTOR #2 (file info) ----------------------------------------
		MEDIA_WR_CMD(mad,9,2,1)						'read out file info
		stat=MEDIA_WFR(mad,4h,rpt)				'wait till media ready (end of BUSY)
		FOR n=1 TO 22											'get complete file info ...
			f_info[n]=MEDIA_RD_DAT(mad)				'out of sector #2
		NEXT n
		s_start=f_info[f_cmd[1]*2+1]			'start sector of data file
		s_end=f_info[f_cmd[1]*2+2]				'end sector of data file
		'----- a plausibility check for start/end sectors may be added here -----
		IF ((s_start=0) OR (s_end=0)) THEN	'file does not exist?
			f_end=2
			EXIT
		ENDIF
		'------------------------------------------------------------------------
		f_cmd[4]=(s_end-s_start+1)*128		'number of 32 bit values that can be saved
		ptr_a=f_info[1]+f_cmd[1]-1				'1st sector, where the actual data ptr is saved
		ptr_b=ptr_a+10										'2nd sector, where the actual data ptr is saved
	ELSE															'media NOT inserted?
		f_end=1														'set return value
		EXIT															'terminate process!
	ENDIF
	'-------- evaluate file command array (FCA: f_cmd[] = DATA_198[]) ----------------------
	IF (f_cmd[2]=0) THEN							'mode file NEW? ======================================
		MEDIA_WR_CMD(mad,6,ptr_a,1)				'WRITE_SECTOR, sector[ptr_a]
		MEDIA_WR_DAT(mad,0h)							'set data ptr to 0h
		MEDIA_WR_DAT(mad,0FFFFFFFFh)			'set inverse value of 0h (32 Bit)
		FOR n=1 TO 126										'always write complete sector
			MEDIA_WR_DAT(mad,0)								'all other LONGs set to 0 and write to media
		NEXT n
		stat=MEDIA_WFR(mad,4h,rpt)				'wait for respond of media (maximum time-out = 15s)
		MEDIA_WR_CMD(mad,6,ptr_b,1)				'WRITE_SECTOR, sector[ptr_b]
		MEDIA_WR_DAT(mad,0h)							'set data ptr to 0h
		MEDIA_WR_DAT(mad,0FFFFFFFFh)			'set inverse value of 0h (32 Bit)
		FOR n=1 TO 126										'always write complete sector
			MEDIA_WR_DAT(mad,0)								'all other LONGs set to 0 and write to media
		NEXT n
		stat=MEDIA_WFR(mad,4h,rpt)				'wait for respond of media (maximum time-out = 15s)
		lc=0 : f_end=0										'initialize various variables
		s_cur=s_start											'sector ptr to start position and ...
		rb_ptr=0													'set ptr of ring buffer
		ptr_sel=0													'write 1st data ptr to sector[ptr_a]
	ELSE															'file APPEND? ========================================
		MEDIA_WR_CMD(mad,9,ptr_a,1)				'READ_SECTOR, sector[ptr_a]
		stat=MEDIA_WFR(mad,4h,rpt)				'wait for respond of media (maximum time-out = 15s)
		v1a=MEDIA_RD_DAT(mad)							'1st LONG of sector
		v1b=MEDIA_RD_DAT(mad)							'2nd LONG of sector
		MEDIA_WR_CMD(mad,9,ptr_b,1)				'READ_SECTOR, sector[ptr_b]
		stat=MEDIA_WFR(mad,4h,rpt)				'wait for respond of media (maximum time-out = 15s)
		v2a=MEDIA_RD_DAT(mad)							'1st LONG of sector
		v2b=MEDIA_RD_DAT(mad)							'2nd LONG of sector
		'-------- plausibility check of data ptr: -------------------------------------------
		ptr_valid=0												'first declare both data ptr as invalid
		IF ((v1a XOR v1b)=-1) THEN				'data ptr 1 correct?
			ptr_valid=ptr_valid OR 1h					'set bit 0
		ENDIF
		IF ((v2a XOR v2b)=-1) THEN				'data ptr 2 correct?
			ptr_valid=ptr_valid OR 2h					'set bit 1
		ENDIF
		SELECTCASE ptr_valid
			CASE 0														'both data ptr invalid?
				f_end=8														'set return value
				EXIT															'terminate process!
			CASE 1														'only data ptr in sector[ptr_a] valid?
				lc=v1a														'take data ptr out of sector[ptr_a]
			CASE 2														'only data ptr in sector[ptr_b] valid?
				lc=v2a														'take data ptr out of sector[ptr_b]
			CASE 3														'both data ptr valid?
				IF ((v1a-v2a)>0) THEN							'to sector[ptr_a] was written last?
					lc=v1a														'take data ptr out of sector[ptr_a]
				ELSE															'In Sektor[ptr_b] wurde zuletzt geschrieben?
					lc=v2a														'Daten-Ptr aus Sektor[ptr_b] nehmen
				ENDIF
		ENDSELECT
		'-------------------------------------------------------------------------------------
		s_cur=SHIFT_RIGHT(lc,7)+s_start		'calculate absolute sector in file and ...
		rb_ptr=lc-1-(s_cur-s_start)*128		'position of RB ptr
		IF (s_end<s_start) THEN						'neg. # of sectors -> file info (file #1) defect?
			f_end=16													'set return value
			EXIT															'terminate process!
		ELSE															'start sector possibly OK?
			IF (s_cur>s_end) THEN							'file full?
				f_end=4														'mark file end
				EXIT															'terminate process!
			ELSE															'file not full?
				f_end=0														'mark file as appendable
			ENDIF
			DO																'wait, till ...
				val=MEDIA_STAT(mad)								'media is ready again, ...
			UNTIL ((val AND 0Dh)=9h)					'e.g. no error, no busy and just ready to read
			MEDIA_WR_CMD(mad,9,s_cur,1)				'read sector where data was saved last
			stat=MEDIA_WFR(mad,4h,rpt)				'wait for respond of media (max. time-out = 15s)
			FOR n=1 TO rb_ptr									'get all data of this sector ...
				rb[n]=MEDIA_RD_DAT(mad)						'and write to RB
			NEXT n
		ENDIF
	ENDIF	'of "IF (f_cmd[2]=0) THEN"
	s_cnt=0 : s_new=0 : s_old=0				'initialze sektor variables
	p1=0 : p2=0												'initialze ptr variables
	f_cmd[5]=lc												'file usage: number of 32 bit values
	f_cmd[9]=0												'no command to stop storage process
	f_cmd[8]=0												'INIT progress: if 0, INIT done
	t_1=READ_TIMER()									'start time for calc. of writing after time-out
	t_2a=t_1													'store timer value for further evaluation
ENDSUB	'INIT_STORAGE


SUB EVENT_DATASAVE() '####################################################################
	ff=FIFO_FULL(199)									'get FIFO status
	f_cmd[6]=fb_size-ff								'free elements in FIFO
	stat=MEDIA_STAT(mad)							'get media status
	IF ((stat AND 0F26h)=0h) THEN			'media inserted, ready and no errors?
		'************ condition: write complete sectors only or after time-out ***************
		'maximum time-out results in: 100s * ((2^31)-1)       = ~ 59h 39min. for T9
		'                           :  50s * ((2^31)-1) *   2 = ~ 59h 39min. for T10
		'                           : 3.3ns * ((2^31)-1) * 3E4 = ~ 59h 39min. for T11
		t_2=READ_TIMER()									'get 100s timer value
		#IF PROZESSOR=T9 THEN
			t_out=f_cmd[3]-t_2+t_1						't_out counts-down from start value
		#ENDIF
		#IF PROZESSOR=T10 THEN
			t_d=(t_2-t_2a)*0.5								'calc. timer difference and scale to 100s steps
			t_s=t_s+t_d												'sum timer differences
			t_out=f_cmd[3]-t_s								'count down
			t_2a=t_2													'remember old timer value for next calc.
		#ENDIF
		#IF PROZESSOR=T11 THEN
			t_d=(t_2-t_2a)/3E4								'calc. timer difference and scale to 100s steps
			t_s=t_s+t_d												'sum timer differences
			t_out=f_cmd[3]-t_s								'count down
			t_2a=t_2													'remember old timer value for next calc.
		#ENDIF
		IF (f_cmd[9]=1) THEN							'command from MP to SP to terminate?
			t_out=-1													'claim time-out -> save immediately!
			IF (ff=0) THEN										'if FIFO empty, SP can be terminated
				f_cmd[9]=0												'take back command from MP to SP to terminate
				f_end=32													'set return value
				END																'terminate process!
			ENDIF
		ENDIF
		IF (t_out<0) THEN									'time-out exceeded?
			t_err=1														'set time-out flag
			t_s=0															'clear summed single-times
		ELSE															'time-out NOT exceeded?
			t_err=0														'clear time-out flag
		ENDIF
		'*************************************************************************************
		IF ((ff>0) AND (f_end=0)) THEN		'data in FB & file end not reached?
			'-------- get FIFO data and write to ring buffer (RB) ------------------------------
			p1=rb_ptr													'remember old RB ptr
			s_old=SHIFT_RIGHT(rb_ptr,7)				'remember "start sector" of RB
			IF (ff>1536) THEN ff=1536					'never get more data as for 12 sectors!
			FOR n=1 TO ff											'get up to 1,536 32 bit values out of FB:
				rb[rb_ptr+1]=fb										'write data out of FB into RB
				INC rb_ptr												'increment RB ptr
				rb_ptr=rb_ptr AND (rb_size-1)			'catch overflow - ptr to start position
			NEXT n
			p2=rb_ptr													'remember new RB ptr
			s_new=SHIFT_RIGHT(rb_ptr,7)				'remember "end sector" of RB
			'-------- sum up 32 bit data (to save in file info) --------------------------------
			IF (p1>p2) THEN										'RB ptr overflow?
				lc=lc+p2-p1+rb_size								'calc. difference and patch value
			ELSE															'no RB ptr overflow?
				lc=lc+p2-p1												'calc. difference
			ENDIF															'"lc" can still be >EOF (f_cmd[4])!
			'-------- calculate number of sectors to write -------------------------------------
			IF (s_old>s_new) THEN							'ring buffer overflow?
				s_cnt=s_new-s_old+16							'calc. # of "new" sectors
			ELSE															'no ring buffer overflow
				s_cnt=s_new-s_old									'calc. # of "new" sectors
			ENDIF
			'-----------------------------------------------------------------------------------
		ELSE															'no data in FIFO or file end not reached?
			s_cnt=0														'do not write any sector
		ENDIF	'of "IF ((ff>0) AND (f_end=0)) THEN"
		'-------- write RB data to media -----------------------------------------------------
		IF ((s_cnt>0) OR (t_err>0)) THEN	'at least 1 sector to write OR time-out?
			IF ((t_err>0) AND (p1<>p2)) THEN	'time-out AND data to save?
				INC s_cnt													'patch sectors upwards to write
			ENDIF
			IF (s_cnt>12) THEN s_cnt=12				'>12 sectors? -> limit to 12
			IF ((s_cur+s_cnt)>s_end) THEN			'exceeding file end?
				s_cnt=s_end-s_cur+1								'patch sector count, ...
				lc=f_cmd[4]												'patch data ptr and ...
				f_end=64													'mark file end
			ENDIF
			IF (s_cnt>0) THEN									'at least 1 sector to write?
				t_1=t_2														'reset time-out!
				p3=s_old*128											'get start element of ring buffer
				MEDIA_WR_CMD(mad,6,s_cur,s_cnt)		'command: WRITE_SECTOR
				FOR n=1 TO s_cnt*128							'save data sector by sector ...
					MEDIA_WR_DAT(mad,(rb[p3+1]))				'command: DATA_WRITE
					INC p3														'increment ptr ...
					p3=p3 AND (rb_size-1)							'catch overflow at [rb_size-1]
				NEXT n
				'(((((((( If no data pointer shall be written,        ((((((((
				'(((((((( mode 'APPEND' is then impossible,           ((((((((
				'(((((((( this part (parenthesized) must be remarked! ((((((((
				DO																'read ...
					stat=MEDIA_STAT(mad)							'media status until ... 
				UNTIL ((stat AND 4h)=0) 					'not BUSY anymore !!!
				IF (ptr_sel=0) THEN								'write data ptr to sector[ptr_a]?
					MEDIA_WR_CMD(mad,6,ptr_a,1)				'WRITE_SECTOR, file #1, sector[data file #]
					ptr_sel=1													'change data ptr
				ELSE															'write data ptr to sector[ptr_b]?
					MEDIA_WR_CMD(mad,6,ptr_b,1)				'WRITE_SECTOR, file #1, sector[data file #]
					ptr_sel=0													'change data ptr
				ENDIF
				MEDIA_WR_DAT(mad,lc)							'save data ptr with current value ...
				MEDIA_WR_DAT(mad,NOT(lc))					'and save invers of data ptr too
				FOR n=1 TO 126										'complete sector: still 126 LONGs to write
					MEDIA_WR_DAT(mad,0)								'all other LONGs set to 0 and write to media
				NEXT n
				')))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
			ENDIF
			IF ((t_err>0) AND (p1<>p2)) THEN	'time-out AND data to save previously present?
				DEC s_cnt													'patch sector count downwards
				p1=p2															'update start ptr
			ENDIF
			s_cur=s_cur+s_cnt									'update sector ptr
			f_cmd[5]=lc												'file usage: number of 32 bit values
		ENDIF	'of "IF ((s_cnt>0) OR (t_err>0)) THEN"
	ELSE															'media not inserted, not ready or ERROR?
		IF ((stat AND 2h)>0) THEN					'ERROR?
			MEDIA_RST(mad)										'trip RESET
			t1=READ_TIMER()										'read out 100s timer
			DO
				t2=READ_TIMER()										'read out 100s timer
				stat=MEDIA_STAT(mad)							'get media status
				IF (t2-t1 > rst) THEN							'media does not respond to RESET (>120ms)?
					f_end=128													'set return value
					END																'terminate process!
				ENDIF
			UNTIL ((stat AND 20h)=0h)					'wait till end of RESET?
		ENDIF
	ENDIF	'of "ELSE" from "IF ((stat AND 26h) = 0h) THEN"
	IF (f_end=64) THEN								'file full?
		END																'terminate process!
	ENDIF
ENDSUB	'SaveDataToStorage