#ifndef RETRY_COUNT_H
#define RETRY_COUNT_H

#include <libadwin/limits.h>

typedef struct {
	int global_retry_counter;
	int dev_retry_counter[DEVICE_NUM_MAX]; // ugly, but 16k is OK
} adwin_shm_t;

#ifdef __cplusplus
extern "C" {
#endif

extern int  getRetryCounter();
extern void incRetryCounter();
extern void resetRetryCounter();

#ifdef BUILD_LIBRARY
// actually, these functions are defined even if BUILD_LIBRARY is not
// defined. They don't do anything meaningful, though. But this way,
// code that calls the functions links properly.
extern int getDeviceRetryCounter(int device_no);
extern void resetDeviceRetryCounter(int device_no);
#endif

#ifdef __cplusplus
}
#endif

#endif /* RETRY_COUNT_H */
