
#ifndef __TRANSPUTER_H__
#define __TRANSPUTER_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <linux/adwin.h>
#include <libadwin/bits.h>

int T_Test_Version(adwin_dev_t *dev, int fd);

long T_Boot(adwin_dev_t *dev, int fd, const char *filename, long iboardsize);
processor_type_t T_Processor_Type(adwin_dev_t *dev, int fd, processor_type_t *processor);

int T_Load_Process(adwin_dev_t *dev, int fd, const char *filename);
int T_Start_Process(adwin_dev_t *dev, int fd, int processID);
int T_Stop_Process(adwin_dev_t *dev, int fd, int processID);
int T_Clear_Process(adwin_dev_t *dev, int fd, int processID);
int T_Process_Status(adwin_dev_t *dev, int fd, int processID);

int T_Free_Mem(adwin_dev_t *dev, int fd, int Mem_Spec, int *dest);

int T_Workload (adwin_dev_t *dev, int fd, int priority, int32_t *dest);

int T_Set_Par(adwin_dev_t *dev, int fd, int Parameternr, int32_t value);
int T_Set_FPar(adwin_dev_t *dev, int fd, int Parameternr, float value);

int T_Get_Par(adwin_dev_t *dev, int fd, int Parameternr, int *value);
int T_Get_FPar(adwin_dev_t *dev, int fd, int Parameternr, float *value);

int T_Get_Par_All(adwin_dev_t *dev, int fd, int first, int cnt, int32_t *dest);
int T_Get_FPar_All(adwin_dev_t *dev, int fd, int first, int cnt, float *dest);

int T_GetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *dest);
int T_SetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *src);

int T_Data_Length(adwin_dev_t *dev, int fd, long DataNo);

int T_Fifo_Clear(adwin_dev_t *dev, int fd, int fifono);
int T_Fifo_Empty(adwin_dev_t *dev, int fd, int fifono, int *dest);
int T_Fifo_Full(adwin_dev_t *dev, int fd, int fifono, int *dest);

int T_SetFifo(adwin_dev_t *dev, int fd, int fifono, long count, void *src);
int T_GetFifo(adwin_dev_t *dev, int fd, int fifono, long count, void *dest);


// ***************************** unsupported *****************************

int T_Get_Memory_dsp(adwin_dev_t *dev, int fd, long base_addr, long anzahl, long *dest);

int T_Clear_Data(adwin_dev_t *dev, int fd, int Datanr);
int T_GetDataType(adwin_dev_t *dev, int fd, int datanr);

#ifdef __cplusplus
}
#endif

#endif /* __TRANSPUTER_H__ */
