#ifndef __LIBADWIN_SCILAB_H__
#define __LIBADWIN_SCILAB_H__

#include <inttypes.h>

#ifdef __cplusplus
extern "C" {
#endif

/* The scilab driver is basically just a bunch of wrapper functions
   with pass-by-reference parameters that call the regular libadwin.h
   functions. 

   The code is far from being complete, but it is a proof of concept
   that shows how it works. Implementing the missing functions should
   be trivial.
*/
	void sl_Boot(const char *filename);
	void sl_Data_Length(int* data_no, int32_t* value);
	void sl_Fifo_Clear(int* fifo_no);
	void sl_Fifo_Empty(int* fifo_no, int32_t* value);
	void sl_Fifo_Full(int* fifo_no, int32_t* value);
	void sl_GetData_Float(int *data_no, float dest[], long *start_index, long *count);
	void sl_GetData_Long(int *data_no, int32_t dest[], long *start_index, long *count);
	void sl_GetFifo_Float(int *fifo_no, float dest[], long *count);
	void sl_GetFifo_Long(int *fifo_no, int32_t dest[], long *count);
	void sl_Get_FPar(int* index, float* value);
	void sl_Get_Last_Error(int *error_number);
	void sl_Get_Last_Error_Text(int *error_number, char *error_text);
	void sl_Get_Par(int *index, long *value);
	void sl_Load_Process(const char *filename);
	void sl_SetData_Float(int *data_no, float src[], long *start_index, long *count);
	void sl_SetData_Long(int *data_no, int32_t src[], long *start_index, long *count);
	void sl_SetFifo_Float(int *fifo_no, float src[], long *count);
	void sl_SetFifo_Long(int *fifo_no, int32_t src[], long *count);
	void sl_Set_DeviceNo(int *device_no);
	void sl_Set_FPar(int *index, float *value);
	void sl_Set_Par(int *index, long *value);
	void sl_Start_Process (int *process_no);
	void sl_Stop_Process (int *process_no);

#ifdef __cplusplus
}
#endif

#endif /* __LIBADWIN_SCILAB_H__ */
